<?php
$params = array_merge(
    require __DIR__ . '/../../common/config/params.php',
    require __DIR__ . '/../../common/config/params-local.php',
    require __DIR__ . '/params.php',
    require __DIR__ . '/params-local.php'
);

return [
    'id' => 'app-backend',
    'basePath' => dirname(__DIR__),
    'controllerNamespace' => 'backend\controllers',
    'bootstrap' => ['log'],
    'modules' => [],
    'components' => [
        // 'request' => [
        //     'csrfParam' => '_csrf-backend',
        // ],

        'assetManager' => [
            'bundles' => [
                'yii\web\JqueryAsset' => [
                    'jsOptions' => [ 'position' => \yii\web\View::POS_HEAD ],
                    'sourcePath' => null,   // do not publish the bundle
                    'js' => [
                       
                      'smart_pos/backend/web/themeassets/assets/global/plugins/jquery.min.js'
                        //'http://localhost/basic/themeassets/assets/global/plugins/jquery.min.js',
                    ]
                ],
            ],
        ],
        
        'user' => [
           
            'identityClass' => 'webvimark\modules\UserManagement\models\User',
            'class' => 'webvimark\modules\UserManagement\components\UserConfig',
            'enableAutoLogin' => false,
            'authTimeout' => 60*15,
            'identityCookie' => [
                'name' => '_portal', // unique for frontend
            ],

            
    
            // Comment this if you don't want to record user logins
            'on afterLogin' => function ($event) {
                \webvimark\modules\UserManagement\models\UserVisitLog::newVisitor($event->identity->id);
            }
        ],

        'api' => [
            'class' => 'backend\components\Api',
           
        ],
        'session' => [
            // this is the name of the session cookie used for login on the backend
            'name' => 'advanced-backend',
        ],
        'log' => [
            'traceLevel' => YII_DEBUG ? 3 : 0,
            'targets' => [
                [
                    'class' => 'yii\log\FileTarget',
                    'levels' => ['error', 'warning'],
                ],
            ],
        ],
        'errorHandler' => [
            'errorAction' => 'site/error',
        ],
        
        'urlManager' => [
            'enablePrettyUrl' => true,
            'showScriptName' => true,
            'rules' => [
            ],
        ]
    ],
    'params' => $params,
];
