<?php

namespace backend\controllers;

use Yii;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;
use yii\filters\ContentNegotiator;
use yii\web\Response;
use yii\web\Controller;
use backend\models\User; 
use backend\models\Organization;
use backend\models\Order;
use backend\models\OrderSerial;
use backend\models\OrderFeedback;
use backend\models\FavoriteProduct;

use backend\models\Feedback;
use backend\models\Vendor;
use backend\models\Product;
use backend\models\GenieAccount;
use backend\models\EzcashAccount;
use frontend\models\SignupForm;
use common\models\LoginForm;
use common\models\OtpCodes;
use common\models\GeniePushTransaction;
use backend\models\GenieGetTransaction;
use common\models\EzcashPushTransaction;
use common\models\TransactionNotification;

use common\models\OtpCodeValidate;
use common\models\OtpCodeResend;

use backend\models\OrderItem;
use backend\models\MenuType;
use backend\models\PayTypes;
use yii\web\NotFoundHttpException; 
use yii\helpers\Json;
use common\models\AccessTokens;
use common\models\AuthorizationCodes;

use backend\behaviours\Verbcheck;
use backend\behaviours\Apiauth;

use backend\components\AccessBehavior;
use backend\components\Api;
use yii\db\Query;
use linslin\yii2\curl;
use yii\httpclient\Client;



/**
 * OrganizationController implements the CRUD actions for Organization model.
 */
class MobileController extends Controller
{
    public function behaviors(){
        $behaviors = parent::behaviors();

      return $behaviors + [
          'apiauth' => [		
             'class' => Apiauth::className(),		
              'exclude' => ['authorize', 'register', 'accesstoken','test','session','sendotpcode','otpvalidate','vendorusers','main-catogory','sub-category','sub-category-products','get-all-menu-type','favorite-product','posusers','order-serial','payment-update','geine-get'],		
              ],
          'access' => [
              'class' => AccessControl::className(),
              'only' => ['logout', 'signup'],
              'rules' => [
                  [
                      'actions' => ['signup'],
                      'allow' => true,
                      'roles' => ['?'],
                  ],
                  [
                      'actions' => ['logout'],
                      'allow' => true,
                      'roles' => ['@'],
                  ],
                  [
                      'actions' => ['authorize', 'register', 'accesstoken','place-order','test','sendotpcode','otpvalidate','get-all-vendors','vendorusers','main-catogory','sub-category','sub-category-products','get-all-menu-type','favorite-product','posusers','order-serial','payment-update','geine-get'],
                      'allow' => true,
                      'roles' => ['*'],
                  ],
              ],
          ],
          'verbs' => [
              'class' => VerbFilter::className(),
              'actions' => [
                  'test'=>['GET'],
                  'session' => ['GET']
                  ],
          ],
      ];
  }
  
   

  // methods used for tokken api -- >
  public function actionRegister()
  {
    $all_product_array = array();

    $request = yii::$app->request;      
    $_POST = Json::decode($request->rawBody);
    // return $_POST['mobile_number'];
    // return $_POST;
      $model = new SignupForm();
      $model->attributes = $this->request;

   

      array_push($all_product_array, array('SignupForm'=>$_POST ));

      $allnmber=OtpCodes::find()->where(['phone_number'=>$_POST['mobile_number']])->andWhere(['status'=>2])->one();


      if($allnmber){

        if ($model->load($all_product_array[0]) && $model->signup()) { 
            $response = [
                "Success" => true,
                "message" => "Signup Successful",   
            ];
            return \yii\helpers\Json::encode($response); 
        }  else{
            $response = [
                "Success" => false,
                "message" => "Signup Error",   
            ];
            return \yii\helpers\Json::encode($response); 
                    }

      }else{

        $response = [
            "Success" => false,
            "message" => "Signup Error",   
        ];
        return \yii\helpers\Json::encode($response); 

      }




      



  }



  public function actionGeineGet()
  {

    $request = yii::$app->request;
    $post = Json::decode($request->rawBody);
    // $vendor_id = $post['vendor_id']; 
    $database = $post['database_name'];


    $ModelGenieGetTransaction = new GenieGetTransaction();
                               $ModelGenieGetTransaction->order_rf_id=1235154;
                              $ModelGenieGetTransaction->created_on=time('Y-m-d h:i:s');	
                             // $ModelGenieGetTransaction->response_array="test";
                             $ModelGenieGetTransaction->geneie_Ref_No="ssssss";	

                             if( $ModelGenieGetTransaction->save()){

                                return 1;

                             }else{

                                return 0;


                             }
                            




  }






  public function actionVendorusers()
  {
      $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        // $vendor_id = $post['vendor_id']; 
        $database = $post['database_name'];
        // $product_id = $post['product_id']; 
        $con = $this->setDb($database);

         $modeVendor=Vendor::find()->where(['database_name'=>$database])->one();


        $VendorUser=User::find()->where(['vendor_id'=>$modeVendor->id])->all();
        


       

        return $this->asJson($VendorUser);  



  }

  public function actionPosusers()
  {
      $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        // $vendor_id = $post['vendor_id']; 
        $database = $post['database_name'];
        // $product_id = $post['product_id']; 
        $con = $this->setDb($database);

         $modeVendor=Vendor::find()->where(['database_name'=>$database])->one();


        $VendorUser=User::find()->where(['vendor_id'=>$modeVendor->id])->andWhere(['user_type'=>2])->all();
        


       

        return $this->asJson($VendorUser);  



  }
  public function actionOrderRating()
  {
   
      $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        // $vendor_id = $post['vendor_id']; 
        $database = $post['database_name'];
        $rating = $post['rating'];
        $order_id = $post['order_id'];

        // $product_id = $post['product_id']; 
        $con = $this->setDb($database);
        $session = Yii::$app->session;
        // $session->set('vendor_db_name',$databaseName); 
        $session->set('vendor_db_name',  $database);
        $modelOrder=Order::find()->where(['id'=>$order_id])->one();
        $modelOrder->rating=$rating;
        if($modelOrder->save()){

            $response = [
                "Success" => true,
                "message" => "Rating Succusefll",   
            ];
            return \yii\helpers\Json::encode($response); 

        }



  }


  public function actionOrderFeedback()
  {
    $request = yii::$app->request;
    $post = Json::decode($request->rawBody);
    // $vendor_id = $post['vendor_id']; 
    $database = $post['database_name'];
    $feedback = $post['msg'];
    $order_id = $post['order_id'];
    $user_id = $post['user_id'];

    $con = $this->setDb($database);
    $session = Yii::$app->session;
    // $session->set('vendor_db_name',$databaseName); 
    $session->set('vendor_db_name',  $database);
    $modelOrder =new OrderFeedback();
    $modelOrder->order_id=$order_id;
    $modelOrder->feedback=$feedback;
    $modelOrder->user_id=$user_id;
    $modelOrder->created_date= date('Y-m-d h:i:s');
    if($modelOrder->save()){

        $response = [
            "Success" => true,
            "message" => "Rating Succusefll",   
        ];
        return \yii\helpers\Json::encode($response); 

    }


  }

 

  
  






  public function actionAuthorize()
  {
    $all_product_array = array();

      $request = yii::$app->request;      
      $_POST = Json::decode($request->rawBody);
    //   $msisdn = $_POST['username'];
    //   $lang= $_POST['language'];

  
    //   Yii::$app->language = $lang;
      
      $model = new LoginForm();

     
      $model->attributes = $this->request;
      array_push($all_product_array, array('LoginForm'=>$_POST ));
    //   print_r(($all_product_array[0]));
    //   die;
        
      if ($model->load($all_product_array[0])  && $model->login()) {

       
// print_r("sd");
// die;
     
           //echo Yii::$app->user->identity['id'];
           //die;

          //$cus = "SELECT id FROM tbl_customer TU WHERE TU.msisdn = $msisdn";
          // $cutomer_data = Yii::$app->getDb()->createCommand($cus)->queryOne();
          // $id = json_decode(json_encode($cutomer_data))->id; 		
          //$notification_count = "SELECT COUNT as count  FROM (SELECT tr.notification_status FROM tbl_portal_user_transactions tr INNER JOIN tbl_lottery lt on tr.ticket_type = lt.code INNER JOIN tbl_draw ld on tr.draw_number = ld.draw_number WHERE tr.customer_id= $id AND tr.transaction_type = 'Win' ORDER BY tr.draw_date DESC LIMIT 10) As a WHERE notification_status =0";
    //   $notification_count = "SELECT COUNT as count FROM (SELECT tr.notification_status FROM tbl_portal_user_transactions tr INNER JOIN tbl_lottery lt on tr.ticket_type = lt.code INNER JOIN tbl_draw ld on tr.draw_number = ld.draw_number INNER JOIN tbl_customer tc on tr.customer_id = tc.id WHERE tc.msisdn= '$msisdn' AND tr.transaction_type = 'Win' ORDER BY tr.draw_date DESC LIMIT 10) As count_result WHERE notification_status =0";
    //   $notify_count = Yii::$app->db->createCommand($notification_count)->queryOne();
      
      //echo json_encode(Yii::$app->user->identity['id']);die; 
          
          $auth_code = Yii::$app->api->createAuthorizationCode(Yii::$app->user->identity['id']);

          

          $data = [];
          $data['authorization_code'] = $auth_code->code;
          $data['expires_at'] = $auth_code->expires_at;

        //   if($model->username){

        //   }

          if (!isset($auth_code->code)) {
              Yii::$app->api->sendFailedResponse("Authorization code missing");
          }
  
         // $authorization_code = $this->request["authorization_code"];
          $authorization_code = $auth_code->code;

         
          $auth_code = AuthorizationCodes::isValid($authorization_code);
          if (!$auth_code) {
              Yii::$app->api->sendFailedResponse("Invalid Authorization Code");
          }
  
          $accesstoken = Yii::$app->api->createAccesstoken($authorization_code);
  
          $data = [];
          $data['access_token'] = $accesstoken->token;
          $data['expires_at'] = $accesstoken->expires_at;
          
          
          
          
          $response = [
              "Success" => true,
              "message" => "Login Successful",
              "access_token" =>$accesstoken->token,
              "Active_User" => $model->username,
              "Active_UserId" =>Yii::$app->user->identity['id'],
              "Active_MobileNum" =>Yii::$app->user->identity['mobile_number'],
              "Email"=>Yii::$app->user->identity['email'],
            //   "Email"=>Yii::$app->user->identity['email'],
            
             
              
          ];
          return \yii\helpers\Json::encode($response); 

      } else {
          
          $response = [
              "Success" => false,
              "message" => \Yii::t('app', 'login_fail') 
              
          ];
          return \yii\helpers\Json::encode($response); 
        
      }
  }


  // methods used for tokken api -- >
  public function actionMe()
  {
      $data = Yii::$app->user->identity;
      $data = $data->attributes;
      unset($data['auth_key']);
      unset($data['password_hash']);
      unset($data['password_reset_token']);

      Yii::$app->api->sendSuccessResponse($data);
  }


  public function actionSendotpcode(){

    $request = yii::$app->request;      
    $_POST = Json::decode($request->rawBody);
    // Yii::$app->response->format = Response::FORMAT_JSON;

    $otpcodes=new OtpCodes();
    $six_digit_random_number = mt_rand(10000, 99999);
    $one_code=$six_digit_random_number;

    $otpcodes->phone_number=$_POST['phone_number'];
    $otpcodes->status=1;
    $otpcodes->created_on=time('Y-m-d h:i:s');
    $otpcodes->code=$one_code.'';
    // $otpcodes->created_on=date('Y-m-d h:i:s');

    if($_POST['phone_number']){
        if($otpcodes->validate())
        {
         $otpcodes->save();

         $response_details = [
            "code" => 1,
            "msg"=> "OK",
            "payload"=>[
                "id"=>$otpcodes->id
            ],   
        ];

    
     
      return \yii\helpers\Json::encode($response_details); 
     



         
        }else {
            $response_details = [
             "code" => 2,
             "msg"=> "Something went wrong.",
             "payload"=>null
               
            ];
      return \yii\helpers\Json::encode($response_details); 
     

            
        }


    }else{
        $response_details = [
            "code" => 3,
            "msg"=> "Mobile number cannot be empty.",
            "payload"=>null
           
        ];
        return \yii\helpers\Json::encode($response_details); 
       
    }
        

  }



  public function actionOtpvalidate(){

    $request = yii::$app->request;      
    $_POST = Json::decode($request->rawBody);
    // Yii::$app->response->format = Response::FORMAT_JSON;


       
    $model=new OtpCodeValidate();
    $modelOtpCodes=OtpCodes::find()->where(['id'=>$_POST['id']])->one();
    if($_POST['otp_code']){

        if($modelOtpCodes){

            $OtpValidet=OtpCodes::find()->where(['code'=>$_POST['otp_code']])->andWhere(['status'=>1])->andWhere(['phone_number'=>$_POST['phone_number']])->one();
            if($OtpValidet){

                $OtpValidet->status=2;
                $OtpValidet->save();
                


                $response_details = [
                    "code" => 1,
                    "msg"=> "Ok",
                    "payload"=>[
                        "id"=>$OtpValidet->id
                    ], 
                   
                ];
          
      return \yii\helpers\Json::encode($response_details); 

        
    
            }else{
                $response_details = [
                    "code" => 2,
                    "msg"=> "Something went wrong..",
                    "payload"=>null
                   
                ];
      return \yii\helpers\Json::encode($response_details); 
             
        
    
            }
    
    
        }else{
            $response_details = [
                "code" => 2,
                "msg"=> "Something went wrong..",
                "payload"=>null
               
            ];
      return \yii\helpers\Json::encode($response_details); 
         
    
        }


    }else{
        $response_details = [
            "code" => 3,
            "msg"=> "OTP number cannot be empty.",
            "payload"=>null
           
        ];
        return \yii\helpers\Json::encode($response_details); 
      
    }

    

  
}




  // methods used for tokken api -- >
  public function actionAccesstoken()
  {

      if (!isset($this->request["authorization_code"])) {
          Yii::$app->api->sendFailedResponse("Authorization code missing");
      }

      $authorization_code = $this->request["authorization_code"];

      $auth_code = AuthorizationCodes::isValid($authorization_code);
      if (!$auth_code) {
          Yii::$app->api->sendFailedResponse("Invalid Authorization Code");
      }

      $accesstoken = Yii::$app->api->createAccesstoken($authorization_code);

      $data = [];
      $data['access_token'] = $accesstoken->token;
      $data['expires_at'] = $accesstoken->expires_at;
      Yii::$app->api->sendSuccessResponse($data);

  }




  // methods used for tokken api -- >
//   public function actionAuthorize()
//   {
//       $request = yii::$app->request;      
//       $_POST = Json::decode($request->rawBody);
       
//       //$auth_code = Yii::$app->api->createAuthorizationCode(Yii::$app->user->identity['id']);
//       $auth_code = Yii::$app->api->createAuthorizationCode(1);
          

//       $data = [];
//       $data['authorization_code'] = $auth_code->code;
//       $data['expires_at'] = $auth_code->expires_at;

//       if (!isset($auth_code->code)) {
//           Yii::$app->api->sendFailedResponse("Authorization code missing");
//       }

//      // $authorization_code = $this->request["authorization_code"];
//       $authorization_code = $auth_code->code;

     
//       $auth_code = AuthorizationCodes::isValid($authorization_code);
//       if (!$auth_code) {
//           Yii::$app->api->sendFailedResponse("Invalid Authorization Code");
//       }

//       $accesstoken = Yii::$app->api->createAccesstoken($authorization_code);

//       $data = [];
//       $data['access_token'] = $accesstoken->token;
//       $data['expires_at'] = $accesstoken->expires_at;

//       $response = [
//           "Success" => true,
//           "message" => "Login Successful",
//           "access_token" =>$accesstoken->token
          
//       ];
//       return \yii\helpers\Json::encode($response); 
      
//   }
  // methods used for tokken api -- >
  public function actionLogout()
  {
      $headers = Yii::$app->getRequest()->getHeaders();
      $access_token = $headers->get('x-access-token');

      if(!$access_token){
          $access_token = Yii::$app->getRequest()->getQueryParam('access-token');
      }

      $model = AccessTokens::findOne(['token' => $access_token]);

      if ($model->delete()) {

          Yii::$app->api->sendSuccessResponse(["Logged Out Successfully"]);

      } else {
          Yii::$app->api->sendFailedResponse("Invalid Request");
      }


  }
    
    public function actionTest()
    {
        // $request = yii::$app->request;
        // $post = Json::decode($request->rawBody);
        // $database = $post['database']; 
        // $con = $this->setDb($database);


        //   $rows = (new \yii\db\Query())
        //     ->select('*')
        //     ->from('product')
        //     ->limit(5)
        //     ->offset(2) //from 2nd row
        //     ->all($con);
        $session = Yii::$app->session;
        $aa= $session["vendor_db_name"];
        return $this->asJson($aa);

        //echo "aaaaaaaaaaaa";
 
    }


    public function setDb($database_name) { 
 
           

                $connection =Yii::$app->PosDbManager->getDbConnection($database_name);
           return $connection;
    } 


    // {
    //     "date" : "Monday" ,
    //     "mealType" : "Lunch Test"
    // }

    public function actionGetMenuDetails()
    { 
        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        $selectedDate = $post['date']; 
        $mealType = $post['mealType']; 
        $database = $post['database'];
        $con = $this->setDb($database);

        $menu_details  = (new \yii\db\Query())
        ->select('product.id AS product_id , product.name  , product.rating,price_list.selling_price , price_list.buying_price')
        ->from('menu_type') 
        ->innerJoin('master_menu', 'menu_type.master_menu_id = master_menu.id')
         ->innerJoin('product', 'menu_type.id =product.menu_type_id')
        ->innerJoin('price_list', 'product.id = price_list.product_id')
        ->where(['master_menu.name' =>  $selectedDate  , 'menu_type.name' => $mealType])
        ->andWhere(['>','product.available_quantity',10])
        ->limit(2)
        ->offset(0)
        ->all($con);

        $menu_type  = (new \yii\db\Query())
        ->select('menu_type.id ,menu_type.name')
        ->innerJoin('master_menu', 'menu_type.master_menu_id = master_menu.id')
        ->from('menu_type') 
        ->where(['master_menu.name' =>  $selectedDate ])
        ->all($con);

        $response = [
            "Success" => true,
            "data" =>array("menu_type" => $menu_type , "menu_details" => $menu_details ),
            
        ];
        $con->close();


       return $this->asJson($response);
       //return $menuItems; 
       //print_r($menuItems);
        
    }

    public function actionOrderSerial(){
        Yii::$app->PosDbManager->sendMessage2('715205107','deleted_order_Serial');
        $session = Yii::$app->session; 
        $AllVendor= Vendor::find()->all();
        foreach( $AllVendor as $value ) {


           
        
            $session->set('vendor_db_name',  $value->database_name);

            OrderSerial::deleteAll();




           

            
        }

    
       return true;

    }


    public function actionMenuType()
    {
      
        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
          
        $dateSelected = $post['date'];
        $weekday = date('l', strtotime($dateSelected)); 

        $menuTypes = (new \yii\db\Query())
        ->select('menu_type.menuTypeName,menu_type.menuTypeDescription,master_menu.name AS MasterMenuName , days.name AS DayName')
        ->from('menu_type') 
        ->innerJoin('master_menu', 'menu_type.mastermenu_id = master_menu.id')
        ->innerJoin('days', 'master_menu.dayId = days.id')
        ->where(['days.name' =>  $weekday ])
        ->all();

        return $this->asJson($menuTypes);        
    }

    

    

    public function actionGetAllProduct()
     {
        $session = Yii::$app->session; 
        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        $databaseName = $post['database_name']; 
        $session->set('vendor_db_name',  $databaseName);


        // $allProduct=Product::find()
      
        // ->all();
        $con = $this->setDb($databaseName);

        $allProduct = (new \yii\db\Query())
        ->select('price_list.selling_price,product.*')
        ->from('product') 
        ->leftJoin('price_list', 'product.id = price_list.product_id')
        ->where(['price_list.is_active'=>1])
        ->andWhere(['product.status'=>1])
        ->all($con);
        $con->close($con);

          return $this->asJson($allProduct);
    
    }

    public function actionGetProductDetails()
     {
        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        $database = $post['database_name'];
        $product_id = $post['product_id']; 
        $con = $this->setDb($database);

     


          $rows = (new \yii\db\Query())
            ->select('product.name ,product.available_quantity , product.rating , product.image_path , main_category.name AS main_category_name ,sub_category.name AS sub_category_name , price_list.selling_price')
            ->from('product')
            ->innerJoin('main_category', 'main_category.id = product.main_category_id')
            ->innerJoin('sub_category', 'sub_category.id = product.sub_category_id')
            ->innerJoin('price_list', 'product.id = price_list.product_id')
            ->where(['product.id' =>  $product_id ])
            ->andWhere(['price_list.is_active' => 1 ])
            ->one($con);


         $rowsdicountr = (new \yii\db\Query())
         ->select('pay_types.id as pay_type_id ,  pay_types.discount as discount ,pay_types.status as status')
        ->from('pay_types')
        // ->where(['product_id'=>$product_id])
        ->all($con);




        $con->close();
      
           
        $response_details = [
            "code" => 1,
            "productDetailes"=>$rows,
            "discount"=>$rowsdicountr
           
        ];
  
return \yii\helpers\Json::encode($response_details); 
    
    }

    public function actionGetAllVendors()
     {
         
        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        // $database = $post['database']; 

        $vend = (new \yii\db\Query())
            ->select('*')
            ->from('vendor')
             ->where(['status'=>1])
            ->all();
           
        return $this->asJson($vend);
    
    }
    public function actionGetAllPayMethod()
    {
        
        $session = Yii::$app->session; 
        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        $databaseName = $post['database_name']; 
        $session->set('vendor_db_name',  $databaseName);


        $allPayTypes=PayTypes::find()->where(['status'=>1])->all();

    
           
        return $this->asJson($allPayTypes);
   
   }
   public function actionGetAllPayMethodPos()
   {
       
       $session = Yii::$app->session; 
       $request = yii::$app->request;
       $post = Json::decode($request->rawBody);
       $databaseName = $post['database_name']; 
       $session->set('vendor_db_name',  $databaseName);


       $allPayTypes=PayTypes::find()->all();

   
          
       return $this->asJson($allPayTypes);
  
  }


   public function actionGetOrderDetails()
   {
      $session = Yii::$app->session; 
      $request = yii::$app->request;
      $post = Json::decode($request->rawBody);
      $databaseName = $post['database_name']; 
      $orderRef = $post['orderRef']; 
      $session->set('vendor_db_name',  $databaseName);
      $con = $this->setDb($databaseName);


      $ModelOrder=Order::find()->where(['refference_id'=>$orderRef])->one();
      $OrderFeedback=OrderFeedback::find()->where(['order_id'=>$ModelOrder->id])->all();

    //  $modeOrderItem=OrderItem::find()->where(['order_id'=>$ModelOrder->id])->all();
      $modeOrderItem=(new \yii\db\Query())
      ->select('order_item.*,product.name ')
      ->from('order_item') 
      ->innerJoin('product', 'product.id = order_item.product_id')
      ->andWhere(['order_item.order_id'=>$ModelOrder->id])
     ->all($con);
      $con->close($con);
      $modeVendor=Vendor::find()->where(['database_name'=>$databaseName])->one();

      $response_details = [
        "code" => 1,
        "ModelOrder"=>$ModelOrder,
        "modeOrderItem"=>$modeOrderItem,
        'OrderFeedback'=>$OrderFeedback,
        'modelVendor'=>$modeVendor
       
    ];

return \yii\helpers\Json::encode($response_details); 
  
  }
  public function actionTicketPrint()
  {
    $session = Yii::$app->session; 
    $request = yii::$app->request;
    $post = Json::decode($request->rawBody);
   //  $databaseName = $post['database_name']; 

    $orderRef = $post['orderRef']; 

    if($orderRef==null || $orderRef==""){
       $response_details = [
            
           "success"=>false,
           "Massege" =>"Field empty error message"

          
       ];
    
    return \yii\helpers\Json::encode($response_details); 
    }

    $arr = $orderRef; // convert string to an array
      
      $ven_id=$arr['0'];
      
     


  
   //  $dataArray=explode("/",$orderRef);
   

    $modelVendor=Vendor::find()->where(['id'=>$ven_id])->one();

    if($modelVendor==null || $modelVendor==""){
       $response_details = [
            
           "success"=>false,
           "Massege" =>"Invalid Reference Number"

          
       ];
    
    return \yii\helpers\Json::encode($response_details); 
    }
   

// 

// return \yii\helpers\Json::encode($modelVendor); 


    $session->set('vendor_db_name',  $modelVendor->database_name);
    $con = $this->setDb($modelVendor->database_name);


    $ModelOrder=Order::find()->where(['refference_id'=>$orderRef])->andWhere(['pay_type_id'=>[1,2]])->one();
    if($ModelOrder==null){

       $response_details = [
            
           "success"=>false,
           "Massege" =>"Invalid Reference Number"

          
       ];
    
    return \yii\helpers\Json::encode($response_details); 



    }
    if($orderRef==null){

       $response_details = [
            
           "success"=>false,
           "Massege" =>"Invalid Reference Number"

          
       ];
    
    return \yii\helpers\Json::encode($response_details); 

    }
    if($orderRef==''){

       $response_details = [
            
           "success"=>false,
           "Massege" =>"Invalid Reference Number"

          
       ];
    
    return \yii\helpers\Json::encode($response_details); 

    }
    if($ModelOrder->print_status==1){

       $response_details = [
            
           "success"=>false,
           "Massege" =>"Already printed Number"

          
       ];
    
    return \yii\helpers\Json::encode($response_details); 


    }
    if($ModelOrder->status==0){

       $response = [
           "Success" => false,
           "Massege" =>"Your payment is pending"
           
       ];
       return \yii\helpers\Json::encode($response);  



    }
    if($ModelOrder->status==2){

       $response = [
           "Success" => false,
           "Massege" =>"Your payment was unsuccessful"
           
       ];
       return \yii\helpers\Json::encode($response);  



    }
    if($ModelOrder->status==-1){

       $response = [
           "Success" => false,
           "Massege" =>"Your payment was Rejected"
           
       ];
       return \yii\helpers\Json::encode($response);  



    }
    if($ModelOrder->status==1 || $ModelOrder->status==0){



  //   $modeOrderItem=OrderItem::find()->where(['order_id'=>$ModelOrder->id])->all();
    $modeOrderItem=(new \yii\db\Query())
    ->select('order_item.*,product.name ')
    ->from('order_item') 
    ->innerJoin('product', 'product.id = order_item.product_id')
    ->andWhere(['order_item.order_id'=>$ModelOrder->id])
   ->all($con);
    $con->close($con);


    $ModelOrder->print_status=1;
    $ModelOrder->save();
   //  $con->close();


   //  $modeVendor=Vendor::find()->where(['database_name'=>$databaseName])->one();

    $discountPrice= $ModelOrder->full_amount - $ModelOrder->total_amount;

    $response_details = [
      "Success" => true,
      
  ];

return \yii\helpers\Json::encode($response_details); 
    }

    $response = [
       "Success" => false,
       "Massege" =>"Invalid Reference Number"
       
   ];
   return \yii\helpers\Json::encode($response);  


  }
  public function actionQrScanner()
  {
     $session = Yii::$app->session; 
     $request = yii::$app->request;
     $post = Json::decode($request->rawBody);
    //  $databaseName = $post['database_name']; 

     $orderRef = $post['orderRef']; 

     if($orderRef==null || $orderRef==""){
        $response_details = [
             
            "success"=>false,
            "Massege" =>"Field empty error message"

           
        ];
     
     return \yii\helpers\Json::encode($response_details); 
     }

     $arr = $orderRef; // convert string to an array
       
       $ven_id=$arr['0'];
       
      


   
    //  $dataArray=explode("/",$orderRef);
    

     $modelVendor=Vendor::find()->where(['id'=>$ven_id])->one();

     if($modelVendor==null || $modelVendor==""){
        $response_details = [
             
            "success"=>false,
            "Massege" =>"Invalid Reference Number"

           
        ];
     
     return \yii\helpers\Json::encode($response_details); 
     }
    

// 

// return \yii\helpers\Json::encode($modelVendor); 


     $session->set('vendor_db_name',  $modelVendor->database_name);
     $con = $this->setDb($modelVendor->database_name);


     $ModelOrder=Order::find()->where(['refference_id'=>$orderRef])->andWhere(['pay_type_id'=>[1,2]])->one();
     if($ModelOrder==null){

        $response_details = [
             
            "success"=>false,
            "Massege" =>"Invalid Reference Number"

           
        ];
     
     return \yii\helpers\Json::encode($response_details); 



     }
     if($orderRef==null){

        $response_details = [
             
            "success"=>false,
            "Massege" =>"Invalid Reference Number"

           
        ];
     
     return \yii\helpers\Json::encode($response_details); 

     }
     if($orderRef==''){

        $response_details = [
             
            "success"=>false,
            "Massege" =>"Invalid Reference Number"

           
        ];
     
     return \yii\helpers\Json::encode($response_details); 

     }
     if($ModelOrder->print_status==1){

        $response_details = [
             
            "success"=>false,
            "Massege" =>"Already printed Number"

           
        ];
     
     return \yii\helpers\Json::encode($response_details); 


     }
     if($ModelOrder->status==0){

        $response = [
            "Success" => false,
            "Massege" =>"Your payment is pending"
            
        ];
        return \yii\helpers\Json::encode($response);  



     }
     if($ModelOrder->status==2){

        $response = [
            "Success" => false,
            "Massege" =>"Your payment was unsuccessful"
            
        ];
        return \yii\helpers\Json::encode($response);  



     }
     if($ModelOrder->status==-1){

        $response = [
            "Success" => false,
            "Massege" =>"Your payment was Rejected"
            
        ];
        return \yii\helpers\Json::encode($response);  



     }
     if($ModelOrder->status==1 || $ModelOrder->status==0){



   //   $modeOrderItem=OrderItem::find()->where(['order_id'=>$ModelOrder->id])->all();
     $modeOrderItem=(new \yii\db\Query())
     ->select('order_item.*,product.name ')
     ->from('order_item') 
     ->innerJoin('product', 'product.id = order_item.product_id')
     ->andWhere(['order_item.order_id'=>$ModelOrder->id])
    ->all($con);
     $con->close($con);


     $ModelOrder->print_status=1;
     $ModelOrder->save();
    //  $con->close();


    //  $modeVendor=Vendor::find()->where(['database_name'=>$databaseName])->one();

    if($ModelOrder->pay_type_id==2){

        $GetModelGenieGetTransaction=GenieGetTransaction::find()->where(['order_rf_id'=>$orderRef])->one();

        $paymentRfNo=$GetModelGenieGetTransaction->geneie_Ref_No;

    }else{

        $paymentRfNo="##L" ;
    }

     $discountPrice= $ModelOrder->full_amount - $ModelOrder->total_amount;

     $response_details = [
       "Success" => true,
       "ModelOrder"=>$ModelOrder,
       "modeOrderItem"=>$modeOrderItem,
       'modelVendor'=>$modelVendor,
       'discountPrice'=>(string)$discountPrice,
       'paymentRfNo'=>$paymentRfNo
      
   ];

return \yii\helpers\Json::encode($response_details); 
     }

     $response = [
        "Success" => false,
        "Massege" =>"Invalid Reference Number"
        
    ];
    return \yii\helpers\Json::encode($response);  

 
 }


 public function actionRefScanner()
 {
    $session = Yii::$app->session; 
    $request = yii::$app->request;
    $post = Json::decode($request->rawBody);
   //  $databaseName = $post['database_name']; 

    $orderRef = $post['orderRef']; 

    $arr = $orderRef; // convert string to an array
      
      $ven_id=$arr['0'];
      



  
   //  $dataArray=explode("/",$orderRef);

    $modelVendor=Vendor::find()->where(['id'=>$ven_id])->one();
   

// 

// return \yii\helpers\Json::encode($modelVendor); 


    $session->set('vendor_db_name',  $modelVendor->database_name);
    $con = $this->setDb($modelVendor->database_name);


    $ModelOrder=Order::find()->where(['refference_id'=>$orderRef])->andWhere(['pay_type_id'=>[1,2]])->one();
    if($ModelOrder==null){

       $response_details = [
            
           "success"=>false,
           "Massege" =>"Invalid Reference Number"

          
       ];
    
    return \yii\helpers\Json::encode($response_details); 



    }
    if($ModelOrder->print_status==1){

       $response = [
           "Success" => false,
           "Massege" =>"Order already printed"
           
       ];
       return \yii\helpers\Json::encode($response);  



    }
    if($ModelOrder->status==0){

       $response = [
           "Success" => false,
           "Massege" =>"Your payment is pending"
           
       ];
       return \yii\helpers\Json::encode($response);  



    }
    if($ModelOrder->status==2){

       $response = [
           "Success" => false,
           "Massege" =>"Your payment was unsuccessful"
           
       ];
       return \yii\helpers\Json::encode($response);  



    }
    if($ModelOrder->status==-1){

       $response = [
           "Success" => false,
           "Massege" =>"Your payment was Rejected"
           
       ];
       return \yii\helpers\Json::encode($response);  



    }
    if($ModelOrder->status==1 || $ModelOrder->status==0){



  //   $modeOrderItem=OrderItem::find()->where(['order_id'=>$ModelOrder->id])->all();
    $modeOrderItem=(new \yii\db\Query())
    ->select('order_item.*,product.name ')
    ->from('order_item') 
    ->innerJoin('product', 'product.id = order_item.product_id')
    ->andWhere(['order_item.order_id'=>$ModelOrder->id])
   ->all($con);
    $con->close($con);


    $ModelOrder->print_status=1;
    $ModelOrder->save();
   //  $con->close();


   //  $modeVendor=Vendor::find()->where(['database_name'=>$databaseName])->one();

   

    $response_details = [
      "code" => 1,
      "ModelOrder"=>$ModelOrder,
      "modeOrderItem"=>$modeOrderItem,
      'modelVendor'=>$modelVendor
     
  ];

return \yii\helpers\Json::encode($response_details); 
    }

}



    public function actionGetAllMenuType()
     {
        $session = Yii::$app->session; 
        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        $databaseName = $post['database_name']; 
        $session->set('vendor_db_name',  $databaseName);


        $allMenuType=MenuType::find()->all();

    
           
        return $this->asJson($allMenuType);
    
    }

    public function actionFavoriteProduct()
    {
       $session = Yii::$app->session; 
       $request = yii::$app->request;
       $post = Json::decode($request->rawBody);
       $databaseName = $post['database_name']; 
       $session->set('vendor_db_name',  $databaseName);

       $con = $this->setDb($databaseName);

    //   $modelFavoriteProduct= FavoriteProduct::find()->where(['status'=>1])->all();

      $rows = (new \yii\db\Query())
      ->select('product.id,product.name,price_list.*')
      ->from('product')
      ->innerJoin('favorite_product', 'favorite_product.product_id = product.id')    
      ->innerJoin('price_list', 'product.id = price_list.product_id')  
     ->where(['price_list.is_active'=>1])

      ->all($con);
     
    return $this->asJson($rows);



   
   }

    public function actionSearchProductsByQuery(){
        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        $database = $post['database'];
        $query = $post["query"]; 
        $con = $this->setDb($database);


          $rows = (new \yii\db\Query())
            ->select('*')
            ->from('product')
            ->andWhere(['like', 'name', $query])
            ->all($con);
           
          return $this->asJson($rows);
    }

    public function actionSearchProductsByKeywords(){
        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        $Keyword = $post["Keywords"]; 
        $database = $post['database'];
        $con = $this->setDb($database);

        $rows = (new \yii\db\Query())
            ->select('*')
            ->from('product')
            ->innerJoin('category', 'category.id = product.Category_Id')
            ->where(['category.id' => $Keyword])
            ->all($con);
        $con->close();
           
          return $this->asJson($rows);
    }


    public function actionPlaceOrder(){
        $client = new Client();

        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        $databaseName = $post['database_name']; 

    

      if(isset($post['Active_MobileNum'])){
        $mobileNo=$post['Active_MobileNum'];
    }

        // $mobileNo=$post['mobileNo'];
        
        // $mobileNum = $post['database_name']; 
    
    
        // return($databaseName);
    
       
        $session = Yii::$app->session;
        $session->set('vendor_db_name',$databaseName); 
        $vendorCode = (new \yii\db\Query())
        ->select('*')
        ->from('vendor')
        ->where(['database_name'=>$databaseName])
        ->one();
    
        $ModelOrder=new Order(); 
        $orderserial= $ModelOrder->getSerialNum();
    
        $yearend= substr(date("Y"), -2);
        $date_of_year=date("z", mktime(0,0,0,date("m"),date("d"),date("Y")))+1;
        $min = date("i");
        $scend = date("s");
    
       
      //  $refference_id =$vendorCode['id'].$post["customer_id"].$yearend.$min.$scend.$date_of_year.$orderserial;
          $refference_id =$vendorCode['id'].$post["customer_id"].$min.$scend.$yearend.$date_of_year.$orderserial;
    
    
        // return  $refference_id;
        $FullAmountOfodre=0; 
    
    
    
    
        foreach( $post["cart"] as $value ) {
            // $order_item->unit_price = $value["unit_price"] ;
            // $order_item->quantity = $value["quantity"]; 
            // $order_item->product_id = $value["product_id"];
    
            $FullAmountOfodre=$FullAmountOfodre+($value["unit_price"]*$value["quantity"]);     
         }


    
    
        $order = new Order();
    $GetpayType=$post["pay_type_id"];


    if($GetpayType==2){
   $set_total_amount=round($post["total_amount"]);

    }else{
        $set_total_amount=$post["total_amount"];
    }

    


      $payTypeModels =PayTypes::find()->where(['id'=>$GetpayType])->one();
      
        // return $this->asJson($order);
        $order->refference_id = $refference_id;
        $order->number_of_items = $post["number_of_items"];
        $order->total_amount =round($post["total_amount"]);
        $order->full_amount =$FullAmountOfodre;
        $order->created_on = date('Y-m-d h:i:s');
        $order->created_by= $post["customer_id"];
        $order->customer_id = $post["customer_id"];
        $order->rating = $post["rating"];;
        $order->status = 0;
        $order->pay_type_id = $GetpayType;
        $order->order_type = $post["order_type"];
        $order->order_option_id=$post["order_option_id"];
        $order->customer_req=$post["customer_req"];
        $order->discount=$payTypeModels->discount;
    
        // $order->validate();
        // print_r($order->getErrors());      
        
    
        if($order->save()){
    
    
    
             $order_details = Order::find()->where(['refference_id' => $refference_id])->one();
             $availbaleCountCheck=[];
        foreach( $post["cart"] as $value ) {
            $order_item = new OrderItem();
            $order_item->unit_price = $value["unit_price"] ;
            $order_item->quantity = $value["quantity"]; 
            $order_item->order_id = $order->id;
            $order_item->product_id = $value["product_id"];
            $order_item->created_date=date('Y-m-d h:i:s');
            $order_item->vendor_id=$vendorCode['id'];
           
            if( $order_item->save()){

                $getProdouctCount= Product::find()->where(['id'=> $value["product_id"]])->one();

                 
                if($getProdouctCount->available_quantity < $value["quantity"]){
                   array_push($availbaleCountCheck, $value["product_id"]);
                }

                if($availbaleCountCheck){
                    $productNames=[];
                           foreach($availbaleCountCheck as $values){
                               
      
                              $findProduct=Product::find()->where(['id'=>$values])->one();
                                                array_push($productNames, $findProduct->name);
                              
      
                                }
      
                              //   $array2 = (array_values($productNames)); 
      
                          
                              $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                              $afterPaiedOrderModel->status=2;
                              $afterPaiedOrderModel->save();
    
                               $responseOfPayment = [
                                    "Success" => false,
                                    "Massege" =>'The products quantity is low' . json_encode(array_values($productNames)),
                                    "orderId" => $order->refference_id 
    
                                ];
                        return \yii\helpers\Json::encode($responseOfPayment); 
      
                     
                  }
               
                
            }else{
                $response = [
                    "Success" => false,
                    "Massege" =>"Order Not complet"
                    
                ];
                return \yii\helpers\Json::encode($response); 
    
            }
         }
         if($order->pay_type_id == 2){
    ///////// to testiong withot genie
    
        
    ///////// to testiong withot genie
    
          
    
       // Get access_token genieApi
    
        $responseAuthorized = Yii::$app->GenieApi->accessToken();
    
       if ($responseAuthorized->isOk) {
    
           $AccessToken=$responseAuthorized->data['access_token'];
    
          }else{
    
            return "error";
          }
                // Get Initiate Push Transaction genieApi

                 /////////////////////////NEW1

                $phoneNumber="+94".$mobileNo;
               
                $modelGenieAccount=GenieAccount::find()->where(['vendor_id'=>$vendorCode['id']])->one();
               // $phoneNumber="+94715205107";
                $responseInitiatePushTransaction = Yii::$app->GenieApi->initiatePushTransaction($AccessToken,$phoneNumber,$order,$databaseName,$modelGenieAccount);
    
                // return $responseInitiatePushTransaction;
    
    
                if(isset($responseInitiatePushTransaction->data['response']['status']) ) {
    
    
    
                    if ($responseInitiatePushTransaction->data['response']['status']=='success') {
    
                        // GeniePushTransaction save table
    
    
            $modelGeniePushTransaction= new GeniePushTransaction();
            $modelGeniePushTransaction->status = $responseInitiatePushTransaction->data['response']['status'];
            $modelGeniePushTransaction->message = $responseInitiatePushTransaction->data['response']['message'];
            $modelGeniePushTransaction->genieTransactionId = $responseInitiatePushTransaction->data['response']['genieTransactionId'];
            $modelGeniePushTransaction->isDiscountApplied = $responseInitiatePushTransaction->data['response']['isDiscountApplied'];
            // $modelGeniePushTransaction->attempts = $responseInitiatePushTransaction->data['response']['attempts'];
            $modelGeniePushTransaction->lockRemainingTime = $responseInitiatePushTransaction->data['response']['lockRemainingTime'];
            $modelGeniePushTransaction->accountPermanentlyBlocked = $responseInitiatePushTransaction->data['response']['accountPermanentlyBlocked'];
            $modelGeniePushTransaction->nicuploadEnable = $responseInitiatePushTransaction->data['response']['nicuploadEnable'];
            $modelGeniePushTransaction->mobile_number = $phoneNumber;
            $modelGeniePushTransaction->created_at = time('Y-m-d h:i:s');
            $modelGeniePushTransaction->order_rf_id = $order->refference_id;
            $modelGeniePushTransaction->total_amount = $order->total_amount;
            $modelGeniePushTransaction->cron_status =1;
            $modelGeniePushTransaction->user_id =Yii::$app->user->identity->id;
           
            $modelGeniePushTransaction->save();
    
    
       
    
    
            if($responseInitiatePushTransaction->data['response']['status']=='success'){
                // Get Transaction Status
                for ($i=0; $i <=65; $i++) {
                // Get Transaction Status genieApi
                 /////////////////////////NEW1
     $modelGenieAccount=GenieAccount::find()->where(['vendor_id'=>$vendorCode['id']])->one();
    
                    $responseStatus = Yii::$app->GenieApi->getTransactionStatus($AccessToken,$responseInitiatePushTransaction,$order,$modelGenieAccount);  
    
                    if($responseStatus->data['response']['merchantTxnStatusName']=="Customer Reject") {

                        $ModelGenieGetTransaction=new GenieGetTransaction();
                        $ModelGenieGetTransaction->order_rf_id=$order->refference_id;
                        $ModelGenieGetTransaction->created_on= time('Y-m-d h:i:s');	
                        $ModelGenieGetTransaction->response_array= json_encode($responseStatus->data['response']);	
                     //   $ModelGenieGetTransaction->geneie_Ref_No= $responseStatus->data['response']['geneieReferenceNo'];	
                        $ModelGenieGetTransaction->save();	




                              $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                              $afterPaiedOrderModel->status=-1;
                              $afterPaiedOrderModel->save();
    
                               $responseOfPayment = [
                                    "Success" => false,
                                    "Massege" =>"Customer Reject Genie Payment",
                                    "orderId" => $order->refference_id 
    
                                ];
                        return \yii\helpers\Json::encode($responseOfPayment); 
    
                        break;
    
                    }
    
                   if($responseStatus->data['response']['merchantTxnStatusName']=="Payment Success") {

                   $ModelGenieGetTransaction=new GenieGetTransaction();
                   $ModelGenieGetTransaction->order_rf_id=$order->refference_id;
                   $ModelGenieGetTransaction->created_on= time('Y-m-d h:i:s');	
                   $ModelGenieGetTransaction->response_array= json_encode($responseStatus->data['response']);	
                   $ModelGenieGetTransaction->geneie_Ref_No= $responseStatus->data['response']['geneieReferenceNo'];	
                   $ModelGenieGetTransaction->save();	







                    $customerSMS="Dear customer payment is successful and order number'.$order->refference_id.' ";

                 

                           Yii::$app->PosDbManager->sendMessage($phoneNumber, $customerSMS);
                
                            $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                            $afterPaiedOrderModel->status=1;
                            $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
                            foreach( $orderItemmodel as $value ) {
                            $productModel=Product::find()->where(['id'=>$value->product_id])->one();

                             $newQuantity=($productModel->available_quantity - $value->quantity);
                             if($newQuantity<0){
                                 $productModel->available_quantity=0;
                                 $productModel->save();



                             }else{
                                $productModel->available_quantity=$newQuantity;
                                $productModel->save();

                             }
                            }


                        //  $afterPaiedOrderModel->print_status=1;

                            $afterPaiedOrderModel->save();
    
                                $responseOfPayment = [
                                    "Success" => true,
                                    "Massege" =>"Payment Success",
                                    "orderId" => $order->refference_id 
    
                                ];
                            return \yii\helpers\Json::encode($responseOfPayment); 
    
                            break;
    
                        }
                        if($responseStatus->data['response']['merchantTxnStatusName']=="Payment Fail") {
                            $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                            $afterPaiedOrderModel->status=-1;
                            $afterPaiedOrderModel->save();
    
                                $responseOfPayment = [
                                    "Success" => false,
                                    "Massege" =>"Payment Fail",
                                    "orderId" => $order->refference_id 
    
                                ];
                                return \yii\helpers\Json::encode($responseOfPayment); 
       //  return \yii\helpers\Json::encode($responseOfPayment); 
    
                            break;
    
                        }
                    
    
                    sleep(1); // this should halt for 3 seconds for every loop
                }
                $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                $afterPaiedOrderModel->status=-1;
               $afterPaiedOrderModel->save();
                $responseOfPayment = [
                    "Success" => false,
                    "Massege" =>"Payment Fail",
                    "orderId" => $order->refference_id 
    
                ];
                return \yii\helpers\Json::encode($responseOfPayment); 
            }else{
                return'error in number send';
    
            }
        }
        // GeniePushTransaction save table
    
        $modelGeniePushTransaction= new GeniePushTransaction();
        $modelGeniePushTransaction->status = $responseInitiatePushTransaction->data['response']['status'];
        $modelGeniePushTransaction->message = $responseInitiatePushTransaction->data['response']['message'];
       
        // $modelGeniePushTransaction->attempts = $responseInitiatePushTransaction->data['response']['attempts'];
        $modelGeniePushTransaction->lockRemainingTime = $responseInitiatePushTransaction->data['response']['lockRemainingTime'];
        $modelGeniePushTransaction->accountPermanentlyBlocked = $responseInitiatePushTransaction->data['response']['accountPermanentlyBlocked'];
        $modelGeniePushTransaction->nicuploadEnable = $responseInitiatePushTransaction->data['response']['nicuploadEnable'];
        $modelGeniePushTransaction->mobile_number = $phoneNumber;
        $modelGeniePushTransaction->created_at = time('Y-m-d h:i:s');
        $modelGeniePushTransaction->order_rf_id = $order->refference_id;
        $modelGeniePushTransaction->total_amount = $order->total_amount;
        $modelGeniePushTransaction->cron_status =0;
        $modelGeniePushTransaction->user_id =Yii::$app->user->identity->id;
        // $modelGeniePushTransaction->validate();
        // print_r($modelGeniePushTransaction->getErrors());
        $modelGeniePushTransaction->save();
    
        if ($responseInitiatePushTransaction->data['response']['status']=='FAILURE') {
    
            $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
            $afterPaiedOrderModel->status=2;
           $afterPaiedOrderModel->save();
    
            $responseOfPayment = [
                "Success" => false,
                "Massege" =>"Genie is Not Working1",
                "orderId" => $order->refference_id 
    
            ];
            return \yii\helpers\Json::encode($responseOfPayment); 
    
    
    
        }
    
        if ($responseInitiatePushTransaction->data['response']['status']=='failure') {
            $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
            $afterPaiedOrderModel->status=2;
           $afterPaiedOrderModel->save();
    
            $responseOfPayment = [
                "Success" => false,
                "Massege" =>"Customer does not exist",
                "orderId" => $order->refference_id 
    
            ];
            return \yii\helpers\Json::encode($responseOfPayment); 
    
    
    
        }
    
    
    
      return $responseInitiatePushTransaction->content; 
    
    
    
                }else{
    
                    $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                    $afterPaiedOrderModel->status=2;
                   $afterPaiedOrderModel->save();
                    $response = [
                        "Success" => false,
                        "Massege" =>"Genie is Not Working2",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 
    
                    
                }
           
         }
    
         if($order->pay_type_id == 3){

            $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
            foreach( $orderItemmodel as $value ) {
            $productModel=Product::find()->where(['id'=>$value->product_id])->one();

             $newQuantity=($productModel->available_quantity - $value->quantity);
             if($newQuantity<0){
                 $productModel->available_quantity=0;
                 $productModel->save();



             }else{
                $productModel->available_quantity=$newQuantity;
                $productModel->save();

             }
            }

            $response = [
                "Success" => true,
                "Massege" =>"Payment Success",
                "orderId" => $order->refference_id 
                
            ];
            return \yii\helpers\Json::encode($response); 
    
         }
    
         if($order->pay_type_id == 1){

          


            $responseAuthorized = Yii::$app->GenieApi->accessToken();


            // print_r($responseAuthorized);
            // die;

            if ($responseAuthorized->isOk) {

                $AccessToken=$responseAuthorized->data['access_token'];


        
              
               }else{
     
                 return "error";
               }

              // $phoneNumber=$mobileNo;
                 //ezcash New2
            //  $phoneNumber="766921091";
               $phoneNumber="+94".$mobileNo;
               $ezcash_pin = $post['ez_pin'];


               $modelEzcashAccount=EzcashAccount::find()->where(['vendor_id'=>$vendorCode['id']])->one();
     
               $responseInitiatePushTransaction=Yii::$app->EzcashApi->initiatePushTransaction($AccessToken,$phoneNumber,$order,$databaseName,$modelEzcashAccount,$ezcash_pin);

               
              
              

               if(isset($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'])){
                 
                if($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status']==5){           
                  
                 $modeEpt=new EzcashPushTransaction();
                 $modeEpt->requestId=$order->refference_id;
                 $modeEpt->response_array=json_encode($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']); 
                 $modeEpt->status=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'];
                  $modeEpt->description=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'];
                 // $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                 // $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                  $modeEpt->txAmount=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['netAmount'];
                 // $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                 $modeEpt->cron_status=1;
                 $modeEpt->user_id=Yii::$app->user->identity->id;
                 $modeEpt->vendor_name=$vendor_name;
                 $modeEpt->order_rf_id=$order->refference_id;
                 $modeEpt->mobile_number=$phoneNumber;
                 $modeEpt->created_at= time('Y-m-d h:i:s');
                 $modeEpt->save();
         //         $modeEpt->validate();
         //  print_r($modeEpt->getErrors());
         //  die;
                 
         Yii::$app->PosDbManager->sendMessage($phoneNumber,'tet');

         $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
             $afterPaiedOrderModel->status=1;
            $afterPaiedOrderModel->save();
            $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
            foreach( $orderItemmodel as $value ) {
            $productModel=Product::find()->where(['id'=>$value->product_id])->one();

             $newQuantity=($productModel->available_quantity - $value->quantity);
             if($newQuantity<0){
                 $productModel->available_quantity=0;
                 $productModel->save();



             }else{
                $productModel->available_quantity=$newQuantity;
                $productModel->save();

             }
            }

         $response = [
             "Success" => true,
             "Massege" =>$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'],
             "orderId" => $order->refference_id 
             
         ];
         return \yii\helpers\Json::encode($response); 


                }else{

                   

              

             
                 
                 $modeEpt=new EzcashPushTransaction();
                 $modeEpt->requestId=$order->refference_id;
                 $modeEpt->response_array=json_encode($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']); 
                 $modeEpt->status=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'];
                  $modeEpt->description=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'];
                 // $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                 // $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                  $modeEpt->txAmount=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['netAmount'];
                 // $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                 $modeEpt->cron_status=1;
                 $modeEpt->user_id=Yii::$app->user->identity->id;
                 $modeEpt->vendor_name=$vendor_name;
                 $modeEpt->order_rf_id=$order->refference_id;
                 $modeEpt->mobile_number=$phoneNumber;
                 $modeEpt->created_at= time('Y-m-d h:i:s');
                 $modeEpt->save();
         //         $modeEpt->validate();
         //  print_r($modeEpt->getErrors());
         //  die;
                 
         $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
         $afterPaiedOrderModel->status=2;
        $afterPaiedOrderModel->save();
         $response = [
             "Success" => false,
             "Massege" =>$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'],
             "orderId" => $order->refference_id 
             
         ];
         return \yii\helpers\Json::encode($response); 


                }
                }else{

                    $response = [
                        "Success" => false,
                        "Massege" =>"payment failed",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 

                }


              //start7
               if(isset($responseInitiatePushTransaction->data['status'])){

               if($responseInitiatePushTransaction->data['status']==62){
                //  $session->remove('add_to_cart_arrya17');              
                 

                $modeEpt=new EzcashPushTransaction();
                $modeEpt->requestId=$order->refference_id;
                $modeEpt->status=$responseInitiatePushTransaction->data['status'];
                $modeEpt->description=$responseInitiatePushTransaction->data['description'];
                $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                $modeEpt->txAmount=$responseInitiatePushTransaction->data['txAmount'];
                $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                $modeEpt->cron_status=1;
                $modeEpt->user_id=Yii::$app->user->identity->id;
                $modeEpt->vendor_name=$databaseName;
                $modeEpt->order_rf_id=$order->refference_id;
                $modeEpt->mobile_number=$phoneNumber;
                $modeEpt->created_at= time('Y-m-d h:i:s');
        //         $modeEpt->validate();
        //  print_r($modeEpt->getErrors());
        //  die;
        $modeEpt->save();

        for ($i=0; $i <=65; $i++) {
            $responseStatus = Yii::$app->EzcashApi->getTransactionStatus($AccessToken,$order->refference_id); 
            
            
            if($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']==6){
                $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                $afterPaiedOrderModel->status=2;
               $afterPaiedOrderModel->save();
                $response = [
                    "Success" => false,
                    "Massege" =>"payment failed",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 

                break;



            }

            if($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']==5){


                Yii::$app->PosDbManager->sendMessage($phoneNumber,'tet');

                $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                    $afterPaiedOrderModel->status=1;
                    // $afterPaiedOrderModel->print_status=1;
                   $afterPaiedOrderModel->save();
                   $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
                   foreach( $orderItemmodel as $value ) {
                   $productModel=Product::find()->where(['id'=>$value->product_id])->one();

                    $newQuantity=($productModel->available_quantity - $value->quantity);
                    if($newQuantity<0){
                        $productModel->available_quantity=0;
                        $productModel->save();



                    }else{
                       $productModel->available_quantity=$newQuantity;
                       $productModel->save();

                    }
                   }

                $response = [
                    "Success" => true,
                    "Massege" =>"Payment Sussess",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 

                break;



            }
            if($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']==16){
                $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                $afterPaiedOrderModel->status=2;
               $afterPaiedOrderModel->save();
                $response = [
                    "Success" => false,
                    "Massege" =>"Your Ez Cash account has been blocked.",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 
    
                break;
    
    
    
            }


            sleep(1); // this should halt for 3 seconds for every loop




        }
        $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
        $afterPaiedOrderModel->status=-1;
       $afterPaiedOrderModel->save();
        $responseOfPayment = [
            "Success" => false,
            "Massege" =>"Payment Fail",
            "orderId" => $order->refference_id 

        ];
        return \yii\helpers\Json::encode($responseOfPayment); 
                
                // if($modeEpt->save()){
                //    $modelNt=new TransactionNotification();
                //    $modelNt->transaction_id=$order->refference_id;
                //    $modelNt->created_at= time('Y-m-d h:i:s');
                //    $modelNt->pay_type=1;
                //    $modelNt->cron_status=1;
                //    $modelNt->mobile_number=$phoneNumber;
                //    $modelNt->user_id=Yii::$app->user->identity->id;
                //    $modelNt->order_rf_id=$order->refference_id;
                //    $modelNt->order_id=$order->id;
                // //    $modelNt->push_transaction_id=$push_transaction_id;
                //    $modelNt->vendor_name=$databaseName;

                // //    $modelNt->validate();
                // //    print_r($modelNt->getErrors());
                // //    die;
                //    $modelNt->save();



                //     Yii::$app->session->setFlash('success', "Check Your Mobile Phone  and Approve Payment"); 
                //     return $this->redirect(['view', 'id' => $model->id]);
                // }else{
                //     Yii::$app->session->setFlash('success', "Check Your Mobile Phone  and Approve Payment"); 
                //     return $this->redirect(['view', 'id' => $model->id]);

                // }


               }
               if($responseInitiatePushTransaction->data['status']==51){
                $modeEpt=new EzcashPushTransaction();
                $modeEpt->requestId=$order->refference_id;
                $modeEpt->status=$responseInitiatePushTransaction->data['status'];
                $modeEpt->description=$responseInitiatePushTransaction->data['description'];
                $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                $modeEpt->txAmount=$responseInitiatePushTransaction->data['txAmount'];
                $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                $modeEpt->cron_status=-1;
                $modeEpt->user_id=Yii::$app->user->identity->id;
                $modeEpt->vendor_name=$databaseName;
                $modeEpt->order_rf_id=$order->refference_id;
                $modeEpt->mobile_number=$phoneNumber;
                $modeEpt->created_at= time('Y-m-d h:i:s');
        //         $modeEpt->validate();
        //  print_r($modeEpt->getErrors());
        //  die;
                
                if($modeEpt->save()){

                   

                    $response = [
                        "Success" => false,
                        "Massege" =>"Invalid Mobile Number. Please try Again",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 
                   
                }else{
                    $response = [
                        "Success" => false,
                        "Massege" =>"Invalid Mobile Number. Please try Again",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 

                }

               }

               if($responseInitiatePushTransaction->data['status']==16){
                $modeEpt=new EzcashPushTransaction();
                $modeEpt->requestId=$order->refference_id;
                $modeEpt->status=$responseInitiatePushTransaction->data['status'];
                $modeEpt->description=$responseInitiatePushTransaction->data['description'];
                $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                $modeEpt->txAmount=$responseInitiatePushTransaction->data['txAmount'];
                $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                $modeEpt->cron_status=-1;
                $modeEpt->user_id=Yii::$app->user->identity->id;
                $modeEpt->vendor_name=$databaseName;
                $modeEpt->order_rf_id=$order->refference_id;
                $modeEpt->mobile_number=$phoneNumber;
                $modeEpt->created_at= time('Y-m-d h:i:s');
        //         $modeEpt->validate();
        //  print_r($modeEpt->getErrors());
        //  die;
                
                if($modeEpt->save()){

                    $response = [
                        "Success" => false,
                        "Massege" =>"Your Ez Cash account has been blocked. ",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 
                   
                }else{
                    $response = [
                        "Success" => false,
                        "Massege" =>"Your Ez Cash account has been blocked. ",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 

                }

               }
               
               
               
               else{
                $modeEpt=new EzcashPushTransaction();
                $modeEpt->requestId=$order->refference_id;
                $modeEpt->status=$responseInitiatePushTransaction->data['status'];
                $modeEpt->description=$responseInitiatePushTransaction->data['description'];
                $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                $modeEpt->txAmount=$responseInitiatePushTransaction->data['txAmount'];
                $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                $modeEpt->cron_status=-1;
                $modeEpt->user_id=Yii::$app->user->identity->id;
                $modeEpt->vendor_name=$databaseName;
                $modeEpt->order_rf_id=$order->refference_id;
                $modeEpt->mobile_number=$phoneNumber;
                $modeEpt->created_at= time('Y-m-d h:i:s');
        //         $modeEpt->validate();
        //  print_r($modeEpt->getErrors());
        //  die;
                
                if($modeEpt->save()){

                  
                   
                    $response = [
                        "Success" => false,
                        "Massege" =>"EZcash is Not Working 1. Please try Again.",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 
                }else{
                    $response = [
                        "Success" => false,
                        "Massege" =>"EZcash is Not Working 1. Please try Again.",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 

                }
            }
               }else{

                $response = [
                    "Success" => false,
                    "Massege" =>"EZcash is Not Working . Please try Again.",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 

               }

               //start7
              
    





    
         }
        
    
        }
        $response = [
            "Success" => false,
            "Massege" =>"Order Not complet "
            
        ];
        return \yii\helpers\Json::encode($response); 
    
    
       
    
    
       


    }

    public function actionKioskPlaceOrder(){
        
        
        $client = new Client();

        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        $databaseName = $post['database_name']; 
        $mobileNo=$post['mobile'];
        
        // $mobileNum = $post['database_name']; 
    
    
        // return($databaseName);
    
       
        $session = Yii::$app->session;
        $session->set('vendor_db_name',$databaseName); 
        $vendorCode = (new \yii\db\Query())
        ->select('*')
        ->from('vendor')
        ->where(['database_name'=>$databaseName])
        ->one();
    
        $ModelOrder=new Order(); 
        $orderserial= $ModelOrder->getSerialNum();
    
        $yearend= substr(date("Y"), -2);
        $date_of_year=date("z", mktime(0,0,0,date("m"),date("d"),date("Y")))+1;
        $min = date("i");
        $scend = date("s");
    
       
      //  $refference_id =$vendorCode['id'].$post["customer_id"].$yearend.$date_of_year.$min.$scend.$orderserial;
          $refference_id =$vendorCode['id'].$post["customer_id"].$min.$scend.$yearend.$date_of_year.$orderserial;
    
        // return  $refference_id;
        $FullAmountOfodre=0; 
    
    
    
    
        foreach( $post["cart"] as $value ) {
            // $order_item->unit_price = $value["unit_price"] ;
            // $order_item->quantity = $value["quantity"]; 
            // $order_item->product_id = $value["product_id"];
    
            $FullAmountOfodre=$FullAmountOfodre+($value["unit_price"]*$value["quantity"]);     
         }
    
    
        $order = new Order();
        $GetpayType=$post["pay_type_id"];


        $payTypeModels =PayTypes::find()->where(['id'=>$GetpayType])->one();
        // return $this->asJson($order);
        $order->refference_id = $refference_id;
        $order->number_of_items = $post["number_of_items"];
        $order->total_amount =round($post["total_amount"]);
        $order->full_amount =$FullAmountOfodre;
        $order->created_on = date('Y-m-d h:i:s');
        $order->created_by= $post["customer_id"];
        $order->customer_id = $post["customer_id"];
        $order->rating = $post["rating"];;
        $order->status = 0;
        $order->pay_type_id = $GetpayType;
        $order->order_type = $post["order_type"];
        $order->order_option_id=$post["order_option_id"];
        $order->discount=$payTypeModels->discount;
    
        // $order->validate();
        // print_r($order->getErrors());      
        
    
        if($order->save()){
    
    
    
             $order_details = Order::find()->where(['refference_id' => $refference_id])->one();
        $availbaleCountCheck=[];
        foreach( $post["cart"] as $value ) {
            $order_item = new OrderItem();
            $order_item->unit_price = $value["unit_price"] ;
            $order_item->quantity = $value["quantity"]; 
            $order_item->order_id = $order->id;
            $order_item->product_id = $value["product_id"];
            $order_item->created_date=date('Y-m-d h:i:s');
            $order_item->vendor_id=$vendorCode['id'];
           
            if( $order_item->save()){



                $getProdouctCount= Product::find()->where(['id'=> $value["product_id"]])->one();

                 
                if($getProdouctCount->available_quantity < $value["quantity"]){
                   array_push($availbaleCountCheck, $value["product_id"]);
                }

                if($availbaleCountCheck){
                    $productNames=[];
                           foreach($availbaleCountCheck as $values){
                               
      
                              $findProduct=Product::find()->where(['id'=>$values])->one();
                                                array_push($productNames, $findProduct->name);
                              
      
                                }
      
                              //   $array2 = (array_values($productNames)); 
      
                          
                              $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                              $afterPaiedOrderModel->status=2;
                              $afterPaiedOrderModel->save();
    
                               $responseOfPayment = [
                                    "Success" => false,
                                    "Massege" =>'The products quantity is low' . json_encode(array_values($productNames)),
                                    "orderId" => $order->refference_id 
    
                                ];
                        return \yii\helpers\Json::encode($responseOfPayment); 
      
                     
                  }
               
                
            }else{
                $response = [
                    "Success" => false,
                    "Massege" =>"Order Not complet"
                    
                ];
                return \yii\helpers\Json::encode($response); 
    
            }
         }
         if($order->pay_type_id == 2){
    ///////// to testiong withot genie
    
        //     $responseOfPayment = [
        //         "Success" => true,
        //         "orderId" => $order->refference_id 
    
        //     ];
        // return \yii\helpers\Json::encode($responseOfPayment); 
    ///////// to testiong withot genie
    
          
    
       // Get access_token genieApi
    
        $responseAuthorized = Yii::$app->GenieApi->accessToken();
    
       if ($responseAuthorized->isOk) {
    
           $AccessToken=$responseAuthorized->data['access_token'];
    
          }else{
    
            return "error";
          }
                // Get Initiate Push Transaction genieApi
                /////////////////////////NEW1
                $phoneNumber="+94".$mobileNo;
                $modelGenieAccount=GenieAccount::find()->where(['vendor_id'=>$vendorCode['id']])->one();
                $responseInitiatePushTransaction = Yii::$app->GenieApi->initiatePushTransaction($AccessToken,$phoneNumber,$order,$databaseName,$modelGenieAccount);
    
                // return $responseInitiatePushTransaction;
    
    
                if(isset($responseInitiatePushTransaction->data['response']['status']) ) {
    
    
    
                    if ($responseInitiatePushTransaction->data['response']['status']=='success') {
    
                        // GeniePushTransaction save table
    
    
            $modelGeniePushTransaction= new GeniePushTransaction();
            $modelGeniePushTransaction->status = $responseInitiatePushTransaction->data['response']['status'];
            $modelGeniePushTransaction->message = $responseInitiatePushTransaction->data['response']['message'];
            $modelGeniePushTransaction->genieTransactionId = $responseInitiatePushTransaction->data['response']['genieTransactionId'];
            $modelGeniePushTransaction->isDiscountApplied = $responseInitiatePushTransaction->data['response']['isDiscountApplied'];
            // $modelGeniePushTransaction->attempts = $responseInitiatePushTransaction->data['response']['attempts'];
            $modelGeniePushTransaction->lockRemainingTime = $responseInitiatePushTransaction->data['response']['lockRemainingTime'];
            $modelGeniePushTransaction->accountPermanentlyBlocked = $responseInitiatePushTransaction->data['response']['accountPermanentlyBlocked'];
            $modelGeniePushTransaction->nicuploadEnable = $responseInitiatePushTransaction->data['response']['nicuploadEnable'];
            $modelGeniePushTransaction->mobile_number = $phoneNumber;
            $modelGeniePushTransaction->created_at = time('Y-m-d h:i:s');
            $modelGeniePushTransaction->order_rf_id = $order->refference_id;
            $modelGeniePushTransaction->total_amount = $order->total_amount;
            $modelGeniePushTransaction->cron_status =1;
            $modelGeniePushTransaction->user_id =Yii::$app->user->identity->id;
           
            $modelGeniePushTransaction->save();
    
    
       
    
    
            if($responseInitiatePushTransaction->data['response']['status']=='success'){
                // Get Transaction Status
                for ($i=0; $i <=65; $i++) {
                // Get Transaction Status genieApi
     /////////////////////////NEW1
     $modelGenieAccount=GenieAccount::find()->where(['vendor_id'=>$vendorCode['id']])->one();
                    $responseStatus = Yii::$app->GenieApi->getTransactionStatus($AccessToken,$responseInitiatePushTransaction,$order,$modelGenieAccount);  
    
                    if($responseStatus->data['response']['merchantTxnStatusName']=="Customer Reject") {
                              $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                              $afterPaiedOrderModel->status=-1;
                              $afterPaiedOrderModel->save();
    
                               $responseOfPayment = [
                                    "Success" => false,
                                    "Massege" =>"Customer Reject Genie Payment",
                                    "orderId" => $order->refference_id 
    
                                ];
                        return \yii\helpers\Json::encode($responseOfPayment); 
    
                        break;
    
                    }
    
                   if($responseStatus->data['response']['merchantTxnStatusName']=="Payment Success") {
                    Yii::$app->PosDbManager->sendMessage($phoneNumber,'tet');
                            $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                            $afterPaiedOrderModel->status=1;
                         $afterPaiedOrderModel->print_status=1;

                            $afterPaiedOrderModel->save();
                            $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
                            foreach( $orderItemmodel as $value ) {
                            $productModel=Product::find()->where(['id'=>$value->product_id])->one();
         
                             $newQuantity=($productModel->available_quantity - $value->quantity);
                             if($newQuantity<0){
                                 $productModel->available_quantity=0;
                                 $productModel->save();
         
         
         
                             }else{
                                $productModel->available_quantity=$newQuantity;
                                $productModel->save();
         
                             }
                            }
         
    
                                $responseOfPayment = [
                                    "Success" => true,
                                    "Massege" =>"Payment Success",
                                    "orderId" => $order->refference_id 
    
                                ];
                            return \yii\helpers\Json::encode($responseOfPayment); 
    
                            break;
    
                        }
                        if($responseStatus->data['response']['merchantTxnStatusName']=="Payment Fail") {
                            $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                            $afterPaiedOrderModel->status=-1;
                            $afterPaiedOrderModel->save();
    
                                $responseOfPayment = [
                                    "Success" => false,
                                    "Massege" =>"Payment Fail",
                                    "orderId" => $order->refference_id 
    
                                ];
                                return \yii\helpers\Json::encode($responseOfPayment); 
       //  return \yii\helpers\Json::encode($responseOfPayment); 
    
                            break;
    
                        }
                    
    
                    sleep(1); // this should halt for 3 seconds for every loop
                }
                $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                $afterPaiedOrderModel->status=-1;
               $afterPaiedOrderModel->save();
                $responseOfPayment = [
                    "Success" => false,
                    "Massege" =>"Payment Fail",
                    "orderId" => $order->refference_id 
    
                ];
                return \yii\helpers\Json::encode($responseOfPayment); 
            }else{
                return'error in number send';
    
            }
        }
        // GeniePushTransaction save table
    
        $modelGeniePushTransaction= new GeniePushTransaction();
        $modelGeniePushTransaction->status = $responseInitiatePushTransaction->data['response']['status'];
        $modelGeniePushTransaction->message = $responseInitiatePushTransaction->data['response']['message'];
       
        // $modelGeniePushTransaction->attempts = $responseInitiatePushTransaction->data['response']['attempts'];
        $modelGeniePushTransaction->lockRemainingTime = $responseInitiatePushTransaction->data['response']['lockRemainingTime'];
        $modelGeniePushTransaction->accountPermanentlyBlocked = $responseInitiatePushTransaction->data['response']['accountPermanentlyBlocked'];
        $modelGeniePushTransaction->nicuploadEnable = $responseInitiatePushTransaction->data['response']['nicuploadEnable'];
        $modelGeniePushTransaction->mobile_number = $phoneNumber;
        $modelGeniePushTransaction->created_at = time('Y-m-d h:i:s');
        $modelGeniePushTransaction->order_rf_id = $order->refference_id;
        $modelGeniePushTransaction->total_amount = $order->total_amount;
        $modelGeniePushTransaction->cron_status =0;
        $modelGeniePushTransaction->user_id =Yii::$app->user->identity->id;
        // $modelGeniePushTransaction->validate();
        // print_r($modelGeniePushTransaction->getErrors());
        $modelGeniePushTransaction->save();
    
        if ($responseInitiatePushTransaction->data['response']['status']=='FAILURE') {
    
            $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
            $afterPaiedOrderModel->status=2;
           $afterPaiedOrderModel->save();
    
            $responseOfPayment = [
                "Success" => false,
                "Massege" =>"Genie is Not Working1",
                "orderId" => $order->refference_id 
    
            ];
            return \yii\helpers\Json::encode($responseOfPayment); 
    
    
    
        }
    
        if ($responseInitiatePushTransaction->data['response']['status']=='failure') {
            $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
            $afterPaiedOrderModel->status=2;
           $afterPaiedOrderModel->save();
    
            $responseOfPayment = [
                "Success" => false,
                "Massege" =>"Customer does not exist",
                "orderId" => $order->refference_id 
    
            ];
            return \yii\helpers\Json::encode($responseOfPayment); 
    
    
    
        }
    
    
    
      return $responseInitiatePushTransaction->content; 
    
    
    
                }else{
    
                    $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                    $afterPaiedOrderModel->status=2;
                   $afterPaiedOrderModel->save();
                    $response = [
                        "Success" => false,
                        "Massege" =>"Genie is Not Working2",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 
    
                    
                }
           
         }
    
         if($order->pay_type_id == 3){

            $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
            foreach( $orderItemmodel as $value ) {
            $productModel=Product::find()->where(['id'=>$value->product_id])->one();

             $newQuantity=($productModel->available_quantity - $value->quantity);
             if($newQuantity<0){
                 $productModel->available_quantity=0;
                 $productModel->save();



             }else{
                $productModel->available_quantity=$newQuantity;
                $productModel->save();

             }
            }

            $response = [
                "Success" => true,
                "Massege" =>"Payment Success",
                "orderId" => $order->refference_id 
                
            ];
            return \yii\helpers\Json::encode($response); 
    
         }
    
         if($order->pay_type_id == 1){

          


            $responseAuthorized = Yii::$app->GenieApi->accessToken();


            // print_r($responseAuthorized);
            // die;

            if ($responseAuthorized->isOk) {

                $AccessToken=$responseAuthorized->data['access_token'];


            // $responseStatus = Yii::$app->EzcashApi->getTransactionStatus($AccessToken);  


            // print_r($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']);
            // // return $responseStatus; 
            // die;



              
               }else{
     
                 return "error";
               }
               //ezcash New2
            //    $phoneNumber=$mobileNo;
            $phoneNumber="+94".$mobileNo;
            $ezcash_pin = $post['ez_pin'];


              // $phoneNumber="766921091";
               $responseInitiatePushTransaction=Yii::$app->EzcashApi->initiatePushTransaction($AccessToken,$phoneNumber,$order,$databaseName,$modelEzcashAccount,$ezcash_pin);

               

               if(isset($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'])){
                 
                if($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status']==5){


                  $session->remove('add_to_cart_arrya17');              
                  
                 

                 $modeEpt=new EzcashPushTransaction();
                 $modeEpt->requestId=$model->refference_id;
                 $modeEpt->response_array=json_encode($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']); 
                 $modeEpt->status=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'];
                  $modeEpt->description=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'];
                 // $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                 // $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                  $modeEpt->txAmount=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['netAmount'];
                 // $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                 $modeEpt->cron_status=1;
                 $modeEpt->user_id=Yii::$app->user->identity->id;
                 $modeEpt->vendor_name=$vendor_name;
                 $modeEpt->order_rf_id=$model->refference_id;
                 $modeEpt->mobile_number=$phoneNumber;
                 $modeEpt->created_at= time('Y-m-d h:i:s');
                 $modeEpt->save();
         //         $modeEpt->validate();
         //  print_r($modeEpt->getErrors());
         //  die;
                 
         Yii::$app->PosDbManager->sendMessage($phoneNumber,'tet');

         $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
             $afterPaiedOrderModel->status=1;
             // $afterPaiedOrderModel->print_status=1;
            $afterPaiedOrderModel->save();
            $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
            foreach( $orderItemmodel as $value ) {
            $productModel=Product::find()->where(['id'=>$value->product_id])->one();

             $newQuantity=($productModel->available_quantity - $value->quantity);
             if($newQuantity<0){
                 $productModel->available_quantity=0;
                 $productModel->save();



             }else{
                $productModel->available_quantity=$newQuantity;
                $productModel->save();

             }
            }

         $response = [
             "Success" => true,
             "Massege" =>$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'],
             "orderId" => $order->refference_id 
             
         ];
         return \yii\helpers\Json::encode($response); 


                }else{

                    $responseOfPayment = [
                        "Success" => false,
                        "Massege" =>$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'],
                        "orderId" => $order->refference_id 
            
                    ];
                return \yii\helpers\Json::encode($responseOfPayment); 

              

             
                 
                 $modeEpt=new EzcashPushTransaction();
                 $modeEpt->requestId=$model->refference_id;
                 $modeEpt->response_array=json_encode($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']); 
                 $modeEpt->status=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'];
                  $modeEpt->description=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'];
                 // $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                 // $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                  $modeEpt->txAmount=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['netAmount'];
                 // $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                 $modeEpt->cron_status=1;
                 $modeEpt->user_id=Yii::$app->user->identity->id;
                 $modeEpt->vendor_name=$vendor_name;
                 $modeEpt->order_rf_id=$model->refference_id;
                 $modeEpt->mobile_number=$phoneNumber;
                 $modeEpt->created_at= time('Y-m-d h:i:s');
                 $modeEpt->save();
         //         $modeEpt->validate();
         //  print_r($modeEpt->getErrors());
         //  die;
                 
         $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
         $afterPaiedOrderModel->status=2;
        $afterPaiedOrderModel->save();
         $response = [
             "Success" => false,
             "Massege" =>$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'],
             "orderId" => $order->refference_id 
             
         ];
         return \yii\helpers\Json::encode($response); 


                }
                }else{

                    $response = [
                        "Success" => false,
                        "Massege" =>"payment failed",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 

                }

               
             
             //start9
               if(isset($responseInitiatePushTransaction->data['status'])){

               if($responseInitiatePushTransaction->data['status']==62){
                //  $session->remove('add_to_cart_arrya17');              
                 

                $modeEpt=new EzcashPushTransaction();
                $modeEpt->requestId=$order->refference_id;
                $modeEpt->status=$responseInitiatePushTransaction->data['status'];
                $modeEpt->description=$responseInitiatePushTransaction->data['description'];
                $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                $modeEpt->txAmount=$responseInitiatePushTransaction->data['txAmount'];
                $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                $modeEpt->cron_status=1;
                $modeEpt->user_id=Yii::$app->user->identity->id;
                $modeEpt->vendor_name=$databaseName;
                $modeEpt->order_rf_id=$order->refference_id;
                $modeEpt->mobile_number=$phoneNumber;
                $modeEpt->created_at= time('Y-m-d h:i:s');
        //         $modeEpt->validate();
        //  print_r($modeEpt->getErrors());
        //  die;
        $modeEpt->save();

        for ($i=0; $i <=65; $i++) {
            $responseStatus = Yii::$app->EzcashApi->getTransactionStatus($AccessToken,$order->refference_id); 
            
            
            if($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']==6){
                $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                $afterPaiedOrderModel->status=2;
               $afterPaiedOrderModel->save();
                $response = [
                    "Success" => false,
                    "Massege" =>"payment failed",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 

                break;



            }

            if($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']==5){

                Yii::$app->PosDbManager->sendMessage($phoneNumber,'tet');

                $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                    $afterPaiedOrderModel->status=1;

                    $afterPaiedOrderModel->print_status=1;
                    
                   $afterPaiedOrderModel->save();

                   $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
                   foreach( $orderItemmodel as $value ) {
                   $productModel=Product::find()->where(['id'=>$value->product_id])->one();

                    $newQuantity=($productModel->available_quantity - $value->quantity);
                    if($newQuantity<0){
                        $productModel->available_quantity=0;
                        $productModel->save();



                    }else{
                       $productModel->available_quantity=$newQuantity;
                       $productModel->save();

                    }
                   }


                $response = [
                    "Success" => true,
                    "Massege" =>"Payment Sussess",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 

                break;



            }
            if($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']==16){
                $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                $afterPaiedOrderModel->status=2;
               $afterPaiedOrderModel->save();
                $response = [
                    "Success" => false,
                    "Massege" =>"Your Ez Cash account has been blocked.",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 
    
                break;
    
    
    
            }


            sleep(1); // this should halt for 3 seconds for every loop




        }
        $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
        $afterPaiedOrderModel->status=-1;
       $afterPaiedOrderModel->save();
        $responseOfPayment = [
            "Success" => false,
            "Massege" =>"Payment Fail",
            "orderId" => $order->refference_id 

        ];
        return \yii\helpers\Json::encode($responseOfPayment); 
                
                // if($modeEpt->save()){
                //    $modelNt=new TransactionNotification();
                //    $modelNt->transaction_id=$order->refference_id;
                //    $modelNt->created_at= time('Y-m-d h:i:s');
                //    $modelNt->pay_type=1;
                //    $modelNt->cron_status=1;
                //    $modelNt->mobile_number=$phoneNumber;
                //    $modelNt->user_id=Yii::$app->user->identity->id;
                //    $modelNt->order_rf_id=$order->refference_id;
                //    $modelNt->order_id=$order->id;
                // //    $modelNt->push_transaction_id=$push_transaction_id;
                //    $modelNt->vendor_name=$databaseName;

                // //    $modelNt->validate();
                // //    print_r($modelNt->getErrors());
                // //    die;
                //    $modelNt->save();



                //     Yii::$app->session->setFlash('success', "Check Your Mobile Phone  and Approve Payment"); 
                //     return $this->redirect(['view', 'id' => $model->id]);
                // }else{
                //     Yii::$app->session->setFlash('success', "Check Your Mobile Phone  and Approve Payment"); 
                //     return $this->redirect(['view', 'id' => $model->id]);

                // }


               }
               if($responseInitiatePushTransaction->data['status']==51){
                $modeEpt=new EzcashPushTransaction();
                $modeEpt->requestId=$order->refference_id;
                $modeEpt->status=$responseInitiatePushTransaction->data['status'];
                $modeEpt->description=$responseInitiatePushTransaction->data['description'];
                $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                $modeEpt->txAmount=$responseInitiatePushTransaction->data['txAmount'];
                $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                $modeEpt->cron_status=-1;
                $modeEpt->user_id=Yii::$app->user->identity->id;
                $modeEpt->vendor_name=$databaseName;
                $modeEpt->order_rf_id=$order->refference_id;
                $modeEpt->mobile_number=$phoneNumber;
                $modeEpt->created_at= time('Y-m-d h:i:s');
        //         $modeEpt->validate();
        //  print_r($modeEpt->getErrors());
        //  die;
                
                if($modeEpt->save()){

                   

                    $response = [
                        "Success" => false,
                        "Massege" =>"Invalid Mobile Number. Please try Again",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 
                   
                }else{
                    $response = [
                        "Success" => false,
                        "Massege" =>"Invalid Mobile Number. Please try Again",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 

                }

               }

               if($responseInitiatePushTransaction->data['status']==16){
                $modeEpt=new EzcashPushTransaction();
                $modeEpt->requestId=$order->refference_id;
                $modeEpt->status=$responseInitiatePushTransaction->data['status'];
                $modeEpt->description=$responseInitiatePushTransaction->data['description'];
                $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                $modeEpt->txAmount=$responseInitiatePushTransaction->data['txAmount'];
                $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                $modeEpt->cron_status=-1;
                $modeEpt->user_id=Yii::$app->user->identity->id;
                $modeEpt->vendor_name=$databaseName;
                $modeEpt->order_rf_id=$order->refference_id;
                $modeEpt->mobile_number=$phoneNumber;
                $modeEpt->created_at= time('Y-m-d h:i:s');
        //         $modeEpt->validate();
        //  print_r($modeEpt->getErrors());
        //  die;
                
                if($modeEpt->save()){

                    $response = [
                        "Success" => false,
                        "Massege" =>"Your Ez Cash account has been blocked. ",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 
                   
                }else{
                    $response = [
                        "Success" => false,
                        "Massege" =>"Your Ez Cash account has been blocked. ",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 

                }

               }
               
               
               
               else{
                $modeEpt=new EzcashPushTransaction();
                $modeEpt->requestId=$order->refference_id;
                $modeEpt->status=$responseInitiatePushTransaction->data['status'];
                $modeEpt->description=$responseInitiatePushTransaction->data['description'];
                $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                $modeEpt->txAmount=$responseInitiatePushTransaction->data['txAmount'];
                $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                $modeEpt->cron_status=-1;
                $modeEpt->user_id=Yii::$app->user->identity->id;
                $modeEpt->vendor_name=$databaseName;
                $modeEpt->order_rf_id=$order->refference_id;
                $modeEpt->mobile_number=$phoneNumber;
                $modeEpt->created_at= time('Y-m-d h:i:s');
        //         $modeEpt->validate();
        //  print_r($modeEpt->getErrors());
        //  die;
                
                if($modeEpt->save()){

                  
                   
                    $response = [
                        "Success" => false,
                        "Massege" =>"EZcash is Not Working . Please try Again.",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 
                }else{
                    $response = [
                        "Success" => false,
                        "Massege" =>"EZcash is Not Working . Please try Again.",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 

                }
            }
               }else{

                $response = [
                    "Success" => false,
                    "Massege" =>"EZcash is Not Working . Please try Again.",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 
               }
              
    

  //start9



    
         }
        
    
        }
        $response = [
            "Success" => false,
            "Massege" =>"Order Not complet "
            
        ];
        return \yii\helpers\Json::encode($response); 
    
    
       
    
    
       



    }

    public function actionVendorStatus(){


        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        $vendor_id = $post['vendor_id'];
        
       $ModelVendor = Vendor :: find()->where(['id'=>$vendor_id])->one();


       if($ModelVendor->status == 1){



        $response = [
            "Success" => true,
           
        ];
    return \yii\helpers\Json::encode($response); 

       }else{

        $response = [
            "Success" => false,
           
        ];
    return \yii\helpers\Json::encode($response); 

       }


        return $vendor_id;


         
    }

    public function actionCustomerOrderList()
     {

        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        $database = $post['database_name'];
        $customer_id = $post["customerID"]; 
        $con = $this->setDb($database);


          $rows = (new \yii\db\Query())
            ->select('*')
            ->from('order')
            ->andWhere(["customer_id" => $customer_id])
            ->all($con);


        $con->close();

           
          return $this->asJson($rows); 
     }

    public function actionCustomerOrderItems()
     {
         
        $request = yii::$app->request;
        $post = Json::decode($request->rawBody);
        $database = $post['database_name'];
        $order_id = $post["order_id"]; 
        $con = $this->setDb($database);


          $rows = (new \yii\db\Query())
            ->select('*')
            ->from('order_item')
            ->where(["order_id" => $order_id])
            ->all($con);
        $con->close();
           
          return $this->asJson($rows);  
    
    }

    public function actionMainCatogory()
    {
        
       $request = yii::$app->request;
       $post = Json::decode($request->rawBody);
    //    $vendor_id = $post['vendor_id'];
     $database = $post['database_name'];    


    //    $modelVendor=Vendor::find()->where(['id'=>$vendor_id])->one();

      $con = $this->setDb($database);

             $rows = (new \yii\db\Query())
           ->select('*')
           ->from('main_category')
           ->orderBy([
            'id' => SORT_DESC,
            // 'item_no'=>SORT_ASC
          ])

           ->all($con);
           
           
          $con->close();



          return $this->asJson($rows);  

   
   }


   public function actionSubCategory()
   {
       
      $request = yii::$app->request;
      $post = Json::decode($request->rawBody);
    //   $vendor_id = $post['vendor_id'];
     $database = $post['database_name'];    

      $main_category_id = $post['main_category_id'];

    //   $modelVendor=Vendor::find()->where(['id'=>$vendor_id])->one();

     $con = $this->setDb($database);

            $rows = (new \yii\db\Query())
          ->select('*')
          ->from('sub_category')
          ->where(['main_category_id'=>$main_category_id])
          ->orderBy([
           'id' => SORT_DESC,
           // 'item_no'=>SORT_AS
         ])

          ->all($con);
          
          
         $con->close();



         return $this->asJson($rows);  

  
  }

  public function actionMenuTypeProduct()
  {
      
     $request = yii::$app->request;
     $post = Json::decode($request->rawBody);
     $database = $post['database_name'];    
     $menu_type_id = $post['menu_type_id'];

     
     $con = $this->setDb($database);

  
     $rows = (new \yii\db\Query())
     ->select('price_list.selling_price,product.*')
     ->from('product') 
     ->leftJoin('price_list', 'product.id = price_list.product_id')
     ->where(['price_list.is_active'=>1])
      ->andWhere(['product.status'=>1])
     ->andWhere(['munu_type_id'=>$menu_type_id])
     ->all($con);
     $con->close($con);



        return $this->asJson($rows);  

 
 }



  public function actionSendfeedback()
   {
       
      $request = yii::$app->request;
      $post = Json::decode($request->rawBody);
      $database = $post['database_name'];
      $order_id = $post['order_id'];
      $feedback = $post['feedback'];

      $session = Yii::$app->session;
      $session->set('vendor_db_name',$database); 

      $modelOrder= Order::find()->where(['id'=>$order_id])->one();



      $orderFeedbackModel=new OrderFeedback(); 
        $orderFeedbackModel->order_id=$order_id;
        $orderFeedbackModel->feedback=$feedback;
        $orderFeedbackModel->user_id=Yii::$app->user->identity->id;
        $orderFeedbackModel->created_date=date('Y-m-d h:i:s');
        if($orderFeedbackModel->save()){

            $db_name = $session->get('vendor_db_name');
            $ved_model=Vendor::find()->where(['database_name'=>$db_name])->one();

           $modelFeedback= new Feedback();
           $modelFeedback->description=$feedback; 
           $modelFeedback->created_date=date('Y-m-d h:i:s');
           $modelFeedback->created_by=Yii::$app->user->identity->id;
           $modelFeedback->vendor_id=$ved_model->id;
           $modelFeedback->order_id=$order_id;
           $modelFeedback->order_ref_id=$modelOrder->refference_id;
           $modelFeedback->status=1;
           $modelFeedback->save();



//    $OrderFeedbackAllModel2=OrderFeedback::find()->where(['order_id'=>$order_id])->all();
//    $OrderFeedbackAllCount=OrderFeedback::find()->where(['order_id'=>$order_id])->count();



//    $data=[
//        'OrderFeedbackAllModel2'=>$OrderFeedbackAllModel2,
//        'OrderFeedbackAllCount'=>$OrderFeedbackAllCount,
//        'ModelId'=>$orderFeedbackModel->id,
//        'Modelcreated_date'=>$orderFeedbackModel->created_date,
//        'ModelFeedback'=>$orderFeedbackModel->feedback,


//    ];

$response = [
    "Success" => true,
   
];
return \yii\helpers\Json::encode($response); 

 


        }
    
     
  

     



     return $this->asJson($modelOrder);  
    //  return $feedback;  

  
  }



  ////////pos_place Order



  public function actionPosPlaceOrder(){
    $client = new Client();

    $request = yii::$app->request;
    $post = Json::decode($request->rawBody);
    $databaseName = $post['database_name']; 

    if(isset($post['mobileNo'])){
        $mobileNo=$post['mobileNo'];
    }
    

    
  
    // $mobileNum = $post['database_name']; 


    // return($databaseName);

   
    $session = Yii::$app->session;
    $session->set('vendor_db_name',$databaseName); 
    $vendorCode = (new \yii\db\Query())
    ->select('*')
    ->from('vendor')
    ->where(['database_name'=>$databaseName])
    ->one();

    $ModelOrder=new Order(); 
    $orderserial= $ModelOrder->getSerialNum();

    $yearend= substr(date("Y"), -2);
    $date_of_year=date("z", mktime(0,0,0,date("m"),date("d"),date("Y")))+1;
    $min = date("i");
    $scend = date("s");

   
  //  $refference_id =$vendorCode['id'].$post["customer_id"].$yearend.$date_of_year.$min.$scend.$orderserial;
      $refference_id =$vendorCode['id'].$post["customer_id"].$min.$scend.$yearend.$date_of_year.$orderserial;


    // return  $refference_id;
    $FullAmountOfodre=0; 




    foreach( $post["cart"] as $value ) {
        // $order_item->unit_price = $value["unit_price"] ;
        // $order_item->quantity = $value["quantity"]; 
        // $order_item->product_id = $value["product_id"];

        $FullAmountOfodre=$FullAmountOfodre+($value["unit_price"]*$value["quantity"]);     
     }


    $order = new Order();
    $GetpayType=$post["pay_type_id"];


    $payTypeModels =PayTypes::find()->where(['id'=>$GetpayType])->one();
    // return $this->asJson($order);
    $order->refference_id = $refference_id;
    $order->number_of_items = $post["number_of_items"];
    $order->total_amount =round($post["total_amount"]);
    $order->full_amount =$FullAmountOfodre;
    $order->created_on = date('Y-m-d h:i:s');
    $order->created_by= $post["customer_id"];
    $order->customer_id = $post["customer_id"];
    $order->rating = $post["rating"];;
    $order->status = 0;
    $order->pay_type_id = $GetpayType;
    $order->order_type = $post["order_type"];
    $order->order_option_id=$post["order_option_id"];
    $order->discount=$payTypeModels->discount;
    // $order->customer_req=$post["customer_req"];


    // $order->validate();
    // print_r($order->getErrors());      
    

    if($order->save()){



         $order_details = Order::find()->where(['refference_id' => $refference_id])->one();
         $availbaleCountCheck=[];
    foreach( $post["cart"] as $value ) {
        $order_item = new OrderItem();
        $order_item->unit_price = $value["unit_price"] ;
        $order_item->quantity = $value["quantity"]; 
        $order_item->order_id = $order->id;
        $order_item->product_id = $value["product_id"];
        $order_item->created_date=date('Y-m-d h:i:s');
        $order_item->vendor_id=$vendorCode['id'];
       
        if( $order_item->save()){

            $getProdouctCount= Product::find()->where(['id'=> $value["product_id"]])->one();

                 
            if($getProdouctCount->available_quantity < $value["quantity"]){
               array_push($availbaleCountCheck, $value["product_id"]);
            }

            if($availbaleCountCheck){
                $productNames=[];
                       foreach($availbaleCountCheck as $values){
                           
  
                          $findProduct=Product::find()->where(['id'=>$values])->one();
                                            array_push($productNames, $findProduct->name);
                          
  
                            }
  
                          //   $array2 = (array_values($productNames)); 
  
                      
                          $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                          $afterPaiedOrderModel->status=2;
                          $afterPaiedOrderModel->save();

                           $responseOfPayment = [
                                "Success" => false,
                                "Massege" =>'The products quantity is low' . json_encode(array_values($productNames)),
                                "orderId" => $order->refference_id 

                            ];
                    return \yii\helpers\Json::encode($responseOfPayment); 
  
                 
              }
           
            
        }else{
            $response = [
                "Success" => false,
                "Massege" =>"Order Not complet"
                
            ];
            return \yii\helpers\Json::encode($response); 

        }
     }
     if($order->pay_type_id == 2){
///////// to testiong withot genie

    //     $responseOfPayment = [
    //         "Success" => true,
    //         "orderId" => $order->refference_id 

    //     ];
    // return \yii\helpers\Json::encode($responseOfPayment); 
///////// to testiong withot genie

      

   // Get access_token genieApi

    $responseAuthorized = Yii::$app->GenieApi->accessToken();

   if ($responseAuthorized->isOk) {

       $AccessToken=$responseAuthorized->data['access_token'];

      }else{

        return "error";
      }
      
            // Get Initiate Push Transaction genieApi
              //$phoneNumber="+94".$mobileNo;
              /////////////////////////NEW1
            $phoneNumber='+94715205107';
            $modelGenieAccount=GenieAccount::find()->where(['vendor_id'=>$vendorCode['id']])->one();
            $responseInitiatePushTransaction = Yii::$app->GenieApi->initiatePushTransaction($AccessToken,$phoneNumber,$order,$databaseName);

            // return $responseInitiatePushTransaction;


            if(isset($responseInitiatePushTransaction->data['response']['status']) ) {



                if ($responseInitiatePushTransaction->data['response']['status']=='success') {

                    // GeniePushTransaction save table


        $modelGeniePushTransaction= new GeniePushTransaction();
        $modelGeniePushTransaction->status = $responseInitiatePushTransaction->data['response']['status'];
        $modelGeniePushTransaction->message = $responseInitiatePushTransaction->data['response']['message'];
        $modelGeniePushTransaction->genieTransactionId = $responseInitiatePushTransaction->data['response']['genieTransactionId'];
        $modelGeniePushTransaction->isDiscountApplied = $responseInitiatePushTransaction->data['response']['isDiscountApplied'];
        // $modelGeniePushTransaction->attempts = $responseInitiatePushTransaction->data['response']['attempts'];
        $modelGeniePushTransaction->lockRemainingTime = $responseInitiatePushTransaction->data['response']['lockRemainingTime'];
        $modelGeniePushTransaction->accountPermanentlyBlocked = $responseInitiatePushTransaction->data['response']['accountPermanentlyBlocked'];
        $modelGeniePushTransaction->nicuploadEnable = $responseInitiatePushTransaction->data['response']['nicuploadEnable'];
        $modelGeniePushTransaction->mobile_number = $phoneNumber;
        $modelGeniePushTransaction->created_at = time('Y-m-d h:i:s');
        $modelGeniePushTransaction->order_rf_id = $order->refference_id;
        $modelGeniePushTransaction->total_amount = $order->total_amount;
        $modelGeniePushTransaction->cron_status =1;
        $modelGeniePushTransaction->user_id =Yii::$app->user->identity->id;
       
        $modelGeniePushTransaction->save();


   


        if($responseInitiatePushTransaction->data['response']['status']=='success'){
            // Get Transaction Status
            for ($i=0; $i <=65; $i++) {
            // Get Transaction Status genieApi
              /////////////////////////NEW1
     $modelGenieAccount=GenieAccount::find()->where(['vendor_id'=>$vendorCode['id']])->one();

                $responseStatus = Yii::$app->GenieApi->getTransactionStatus($AccessToken,$responseInitiatePushTransaction,$order,$modelGenieAccount);  

                if($responseStatus->data['response']['merchantTxnStatusName']=="Customer Reject") {
                          $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                          $afterPaiedOrderModel->status=-1;
                          $afterPaiedOrderModel->save();

                           $responseOfPayment = [
                                "Success" => false,
                                "Massege" =>"Customer Reject Genie Payment",
                                "orderId" => $order->refference_id 

                            ];
                    return \yii\helpers\Json::encode($responseOfPayment); 

                    break;

                }

               if($responseStatus->data['response']['merchantTxnStatusName']=="Payment Success") {
                   
                        $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                        $afterPaiedOrderModel->status=1;
                         $afterPaiedOrderModel->print_status=1;
                        $afterPaiedOrderModel->save();
                        $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
                        foreach( $orderItemmodel as $value ) {
                        $productModel=Product::find()->where(['id'=>$value->product_id])->one();
     
                         $newQuantity=($productModel->available_quantity - $value->quantity);
                         if($newQuantity<0){
                             $productModel->available_quantity=0;
                             $productModel->save();
     
     
     
                         }else{
                            $productModel->available_quantity=$newQuantity;
                            $productModel->save();
     
                         }
                        }
     

                            $responseOfPayment = [
                                "Success" => true,
                                "Massege" =>"Payment Success",
                                "orderId" => $order->refference_id 

                            ];
                        return \yii\helpers\Json::encode($responseOfPayment); 

                        break;

                    }
                    if($responseStatus->data['response']['merchantTxnStatusName']=="Payment Fail") {
                        $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                        $afterPaiedOrderModel->status=-1;
                        $afterPaiedOrderModel->save();

                            $responseOfPayment = [
                                "Success" => false,
                                "Massege" =>"Payment Fail",
                                "orderId" => $order->refference_id 

                            ];
                            return \yii\helpers\Json::encode($responseOfPayment); 
   //  return \yii\helpers\Json::encode($responseOfPayment); 

                        break;

                    }
                

                sleep(1); // this should halt for 3 seconds for every loop
            }
            $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
            $afterPaiedOrderModel->status=2;
           $afterPaiedOrderModel->save();
            $responseOfPayment = [
                "Success" => false,
                "Massege" =>"Payment Fail",
                "orderId" => $order->refference_id 

            ];
            return \yii\helpers\Json::encode($responseOfPayment); 
        }else{
            return'error in number send';

        }
    }
    // GeniePushTransaction save table

    $modelGeniePushTransaction= new GeniePushTransaction();
    $modelGeniePushTransaction->status = $responseInitiatePushTransaction->data['response']['status'];
    $modelGeniePushTransaction->message = $responseInitiatePushTransaction->data['response']['message'];
   
    // $modelGeniePushTransaction->attempts = $responseInitiatePushTransaction->data['response']['attempts'];
    $modelGeniePushTransaction->lockRemainingTime = $responseInitiatePushTransaction->data['response']['lockRemainingTime'];
    $modelGeniePushTransaction->accountPermanentlyBlocked = $responseInitiatePushTransaction->data['response']['accountPermanentlyBlocked'];
    $modelGeniePushTransaction->nicuploadEnable = $responseInitiatePushTransaction->data['response']['nicuploadEnable'];
    $modelGeniePushTransaction->mobile_number = $phoneNumber;
    $modelGeniePushTransaction->created_at = time('Y-m-d h:i:s');
    $modelGeniePushTransaction->order_rf_id = $order->refference_id;
    $modelGeniePushTransaction->total_amount = $order->total_amount;
    $modelGeniePushTransaction->cron_status =0;
    $modelGeniePushTransaction->user_id =Yii::$app->user->identity->id;
    // $modelGeniePushTransaction->validate();
    // print_r($modelGeniePushTransaction->getErrors());
    $modelGeniePushTransaction->save();

    if ($responseInitiatePushTransaction->data['response']['status']=='FAILURE') {

        $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
        $afterPaiedOrderModel->status=2;
       $afterPaiedOrderModel->save();

        $responseOfPayment = [
            "Success" => false,
            "Massege" =>"Genei Not Working1",
            "orderId" => $order->refference_id 

        ];
        return \yii\helpers\Json::encode($responseOfPayment); 



    }

    if ($responseInitiatePushTransaction->data['response']['status']=='failure') {
        $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
        $afterPaiedOrderModel->status=2;
       $afterPaiedOrderModel->save();

        $responseOfPayment = [
            "Success" => false,
            "Massege" =>"Customer does not exist",
            "orderId" => $order->refference_id 

        ];
        return \yii\helpers\Json::encode($responseOfPayment); 



    }



  return $responseInitiatePushTransaction->content; 



            }else{

                $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                $afterPaiedOrderModel->status=2;
               $afterPaiedOrderModel->save();
                $response = [
                    "Success" => false,
                    "Massege" =>"Genie is Not Working2",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 

                
            }
       
     }

     if($order->pay_type_id == 3){

        $cashOrder=Order::find()->where(['id'=>$order->id])->one();
        $cashOrder->status=1;
        $cashOrder->print_status=1;
        $cashOrder->save();

        $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
        foreach( $orderItemmodel as $value ) {
        $productModel=Product::find()->where(['id'=>$value->product_id])->one();

         $newQuantity=($productModel->available_quantity - $value->quantity);
         if($newQuantity<0){
             $productModel->available_quantity=0;
             $productModel->save();



         }else{
            $productModel->available_quantity=$newQuantity;
            $productModel->save();

         }
        }

        $response = [
            "Success" => true,
            "Massege" =>"Payment Success",
            "orderId" => $order->refference_id 
            
        ];
        return \yii\helpers\Json::encode($response); 

     }
     
     if($order->pay_type_id == 4){

        $cashOrder=Order::find()->where(['id'=>$order->id])->one();
        $cashOrder->status=1;
        $cashOrder->print_status=1;
        $cashOrder->save();

        $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
        foreach( $orderItemmodel as $value ) {
        $productModel=Product::find()->where(['id'=>$value->product_id])->one();

         $newQuantity=($productModel->available_quantity - $value->quantity);
         if($newQuantity<0){
             $productModel->available_quantity=0;
             $productModel->save();



         }else{
            $productModel->available_quantity=$newQuantity;
            $productModel->save();

         }
        }

        $response = [
            "Success" => true,
            "Massege" =>"Payment Success",
            "orderId" => $order->refference_id 
            
        ];
        return \yii\helpers\Json::encode($response); 

     }

     if($order->pay_type_id == 1){
      

          


        $responseAuthorized = Yii::$app->GenieApi->accessToken();


        // print_r($responseAuthorized);
        // die;

        if ($responseAuthorized->isOk) {

            $AccessToken=$responseAuthorized->data['access_token'];

          
           }else{
 
             return "error";
           }
             //ezcash New2
            //    $phoneNumber=$mobileNo;
            $phoneNumber="+94".$mobileNo;
            $ezcash_pin = $post['ez_pin'];


              // $phoneNumber="766921091";
               $responseInitiatePushTransaction=Yii::$app->EzcashApi->initiatePushTransaction($AccessToken,$phoneNumber,$order,$databaseName,$modelEzcashAccount,$ezcash_pin);
               if(isset($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'])){
                 
                if($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status']==5){


                  $session->remove('add_to_cart_arrya17');              
               

                 $modeEpt=new EzcashPushTransaction();
                 $modeEpt->requestId=$model->refference_id;
                 $modeEpt->response_array=json_encode($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']); 
                 $modeEpt->status=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'];
                  $modeEpt->description=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'];
                 // $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                 // $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                  $modeEpt->txAmount=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['netAmount'];
                 // $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                 $modeEpt->cron_status=1;
                 $modeEpt->user_id=Yii::$app->user->identity->id;
                 $modeEpt->vendor_name=$vendor_name;
                 $modeEpt->order_rf_id=$model->refference_id;
                 $modeEpt->mobile_number=$phoneNumber;
                 $modeEpt->created_at= time('Y-m-d h:i:s');
                 $modeEpt->save();
         //         $modeEpt->validate();
         //  print_r($modeEpt->getErrors());
         //  die;
                 
         Yii::$app->PosDbManager->sendMessage($phoneNumber,'tet');

         $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
             $afterPaiedOrderModel->status=1;
             // $afterPaiedOrderModel->print_status=1;
            $afterPaiedOrderModel->save();
            $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
            foreach( $orderItemmodel as $value ) {
            $productModel=Product::find()->where(['id'=>$value->product_id])->one();

             $newQuantity=($productModel->available_quantity - $value->quantity);
             if($newQuantity<0){
                 $productModel->available_quantity=0;
                 $productModel->save();



             }else{
                $productModel->available_quantity=$newQuantity;
                $productModel->save();

             }
            }

         $response = [
             "Success" => true,
             "Massege" =>$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'],
             "orderId" => $order->refference_id 
             
         ];
         return \yii\helpers\Json::encode($response); 


                }else{

                    $responseOfPayment = [
                        "Success" => false,
                        "Massege" =>$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'],
                        "orderId" => $order->refference_id 
            
                    ];
                return \yii\helpers\Json::encode($responseOfPayment); 

              

             
                 
                 $modeEpt=new EzcashPushTransaction();
                 $modeEpt->requestId=$model->refference_id;
                 $modeEpt->response_array=json_encode($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']); 
                 $modeEpt->status=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'];
                  $modeEpt->description=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'];
                 // $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                 // $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                  $modeEpt->txAmount=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['netAmount'];
                 // $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                 $modeEpt->cron_status=1;
                 $modeEpt->user_id=Yii::$app->user->identity->id;
                 $modeEpt->vendor_name=$vendor_name;
                 $modeEpt->order_rf_id=$model->refference_id;
                 $modeEpt->mobile_number=$phoneNumber;
                 $modeEpt->created_at= time('Y-m-d h:i:s');
                 $modeEpt->save();
         //         $modeEpt->validate();
         //  print_r($modeEpt->getErrors());
         //  die;
                 
         $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
         $afterPaiedOrderModel->status=2;
        $afterPaiedOrderModel->save();
         $response = [
             "Success" => false,
             "Massege" =>$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'],
             "orderId" => $order->refference_id 
             
         ];
         return \yii\helpers\Json::encode($response); 


                }
                }else{

                    $response = [
                        "Success" => false,
                        "Massege" =>"payment failed",
                        "orderId" => $order->refference_id 
                        
                    ];
                    return \yii\helpers\Json::encode($response); 

                }

           if(isset($responseInitiatePushTransaction->data['status'])){

           if($responseInitiatePushTransaction->data['status']==62){
            //  $session->remove('add_to_cart_arrya17');              
             

            $modeEpt=new EzcashPushTransaction();
            $modeEpt->requestId=$order->refference_id;
            $modeEpt->status=$responseInitiatePushTransaction->data['status'];
            $modeEpt->description=$responseInitiatePushTransaction->data['description'];
            $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
            $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
            $modeEpt->txAmount=$responseInitiatePushTransaction->data['txAmount'];
            $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
            $modeEpt->cron_status=1;
            $modeEpt->user_id=Yii::$app->user->identity->id;
            $modeEpt->vendor_name=$databaseName;
            $modeEpt->order_rf_id=$order->refference_id;
            $modeEpt->mobile_number=$phoneNumber;
            $modeEpt->created_at= time('Y-m-d h:i:s');
    //         $modeEpt->validate();
    //  print_r($modeEpt->getErrors());
    //  die;
    $modeEpt->save();

    for ($i=0; $i <=65; $i++) {
        $responseStatus = Yii::$app->EzcashApi->getTransactionStatus($AccessToken,$order->refference_id); 
        
        
        if($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']==6){
            $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
            $afterPaiedOrderModel->status=2;
           $afterPaiedOrderModel->save();
            $response = [
                "Success" => false,
                "Massege" =>"payment failed",
                "orderId" => $order->refference_id 
                
            ];
            return \yii\helpers\Json::encode($response); 

            break;



        }
     
        if($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']==16){
            $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
            $afterPaiedOrderModel->status=2;
           $afterPaiedOrderModel->save();

            $response = [
                "Success" => false,
                "Massege" =>"Your Ez Cash account has been blocked.",
                "orderId" => $order->refference_id 
                
            ];
            return \yii\helpers\Json::encode($response); 

            break;



        }
        if($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']==5){

            $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
                $afterPaiedOrderModel->status=1;

                 $afterPaiedOrderModel->print_status=1;
                
               $afterPaiedOrderModel->save();

               $orderItemmodel=OrderItem::find()->where(['order_id'=>$order->id])->all();
               foreach( $orderItemmodel as $value ) {
               $productModel=Product::find()->where(['id'=>$value->product_id])->one();

                $newQuantity=($productModel->available_quantity - $value->quantity);
                if($newQuantity<0){
                    $productModel->available_quantity=0;
                    $productModel->save();



                }else{
                   $productModel->available_quantity=$newQuantity;
                   $productModel->save();

                }
               }


            $response = [
                "Success" => true,
                "Massege" =>"Payment Sussess",
                "orderId" => $order->refference_id 
                
            ];
            return \yii\helpers\Json::encode($response); 

            break;



        }



        sleep(1); // this should halt for 3 seconds for every loop



    }
    $afterPaiedOrderModel=Order::find()->where(['id'=>$order->id])->one();
    $afterPaiedOrderModel->status=-1;
   $afterPaiedOrderModel->save();
    $responseOfPayment = [
        "Success" => false,
        "Massege" =>"Payment Fail",
        "orderId" => $order->refference_id 

    ];
    return \yii\helpers\Json::encode($responseOfPayment); 
            
            // if($modeEpt->save()){
            //    $modelNt=new TransactionNotification();
            //    $modelNt->transaction_id=$order->refference_id;
            //    $modelNt->created_at= time('Y-m-d h:i:s');
            //    $modelNt->pay_type=1;
            //    $modelNt->cron_status=1;
            //    $modelNt->mobile_number=$phoneNumber;
            //    $modelNt->user_id=Yii::$app->user->identity->id;
            //    $modelNt->order_rf_id=$order->refference_id;
            //    $modelNt->order_id=$order->id;
            // //    $modelNt->push_transaction_id=$push_transaction_id;
            //    $modelNt->vendor_name=$databaseName;

            // //    $modelNt->validate();
            // //    print_r($modelNt->getErrors());
            // //    die;
            //    $modelNt->save();



            //     Yii::$app->session->setFlash('success', "Check Your Mobile Phone  and Approve Payment"); 
            //     return $this->redirect(['view', 'id' => $model->id]);
            // }else{
            //     Yii::$app->session->setFlash('success', "Check Your Mobile Phone  and Approve Payment"); 
            //     return $this->redirect(['view', 'id' => $model->id]);

            // }


           }
           if($responseInitiatePushTransaction->data['status']==51){
            $modeEpt=new EzcashPushTransaction();
            $modeEpt->requestId=$order->refference_id;
            $modeEpt->status=$responseInitiatePushTransaction->data['status'];
            $modeEpt->description=$responseInitiatePushTransaction->data['description'];
            $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
            $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
            $modeEpt->txAmount=$responseInitiatePushTransaction->data['txAmount'];
            $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
            $modeEpt->cron_status=-1;
            $modeEpt->user_id=Yii::$app->user->identity->id;
            $modeEpt->vendor_name=$databaseName;
            $modeEpt->order_rf_id=$order->refference_id;
            $modeEpt->mobile_number=$phoneNumber;
            $modeEpt->created_at= time('Y-m-d h:i:s');
    //         $modeEpt->validate();
    //  print_r($modeEpt->getErrors());
    //  die;
            
            if($modeEpt->save()){

               

                $response = [
                    "Success" => false,
                    "Massege" =>"Invalid Mobile Number. Please try Again",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 
               
            }else{
                $response = [
                    "Success" => false,
                    "Massege" =>"Invalid Mobile Number. Please try Again",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 

            }

           }

           if($responseInitiatePushTransaction->data['status']==16){
            $modeEpt=new EzcashPushTransaction();
            $modeEpt->requestId=$order->refference_id;
            $modeEpt->status=$responseInitiatePushTransaction->data['status'];
            $modeEpt->description=$responseInitiatePushTransaction->data['description'];
            $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
            $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
            $modeEpt->txAmount=$responseInitiatePushTransaction->data['txAmount'];
            $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
            $modeEpt->cron_status=-1;
            $modeEpt->user_id=Yii::$app->user->identity->id;
            $modeEpt->vendor_name=$databaseName;
            $modeEpt->order_rf_id=$order->refference_id;
            $modeEpt->mobile_number=$phoneNumber;
            $modeEpt->created_at= time('Y-m-d h:i:s');
    //         $modeEpt->validate();
    //  print_r($modeEpt->getErrors());
    //  die;
            
            if($modeEpt->save()){

                $response = [
                    "Success" => false,
                    "Massege" =>"Your Ez Cash account has been blocked. ",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 
               
            }else{
                $response = [
                    "Success" => false,
                    "Massege" =>"Your Ez Cash account has been blocked. ",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 

            }

           }
           
           
           
           else{
            $modeEpt=new EzcashPushTransaction();
            $modeEpt->requestId=$order->refference_id;
            $modeEpt->status=$responseInitiatePushTransaction->data['status'];
            $modeEpt->description=$responseInitiatePushTransaction->data['description'];
            $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
            $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
            $modeEpt->txAmount=$responseInitiatePushTransaction->data['txAmount'];
            $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
            $modeEpt->cron_status=-1;
            $modeEpt->user_id=Yii::$app->user->identity->id;
            $modeEpt->vendor_name=$databaseName;
            $modeEpt->order_rf_id=$order->refference_id;
            $modeEpt->mobile_number=$phoneNumber;
            $modeEpt->created_at= time('Y-m-d h:i:s');
    //         $modeEpt->validate();
    //  print_r($modeEpt->getErrors());
    //  die;
            
            if($modeEpt->save()){

              
               
                $response = [
                    "Success" => false,
                    "Massege" =>"EZcash is Not Working . Please try Again.",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 
            }else{
                $response = [
                    "Success" => false,
                    "Massege" =>"EZcash is Not Working . Please try Again.",
                    "orderId" => $order->refference_id 
                    
                ];
                return \yii\helpers\Json::encode($response); 

            }
        }
           }else{

            $response = [
                "Success" => false,
                "Massege" =>"EZcash is Not Working . Please try Again.",
                "orderId" => $order->refference_id 
                
            ];
            return \yii\helpers\Json::encode($response); 

           }
          





     }
    

    }else{

        $response = [
            "Success" => false,
            "Massege" =>"Order Not complet "
            
        ];
        return \yii\helpers\Json::encode($response); 

    }


    $cashOrder=Order::find()->where(['id'=>$order->id])->one();
    $cashOrder->status=1;
    $cashOrder->print_status=1;
    $cashOrder->save();

    $response = [
        "Success" => true,
        "Massege" =>"Payment Success",
        "orderId" => $order->refference_id 
        
    ];
    return \yii\helpers\Json::encode($response); 
   


   


}




  /////////////////////////


  public function actionPaymentUpdate()
  {

    $request = yii::$app->request;
    $post = Json::decode($request->rawBody);
  
    $TraNotiModel=TransactionNotification::find()->where(['cron_status'=>1])->all();
    foreach ($TraNotiModel as $TraNotiModel) {

        if($TraNotiModel->pay_type==1){
            $responseAuthorized = Yii::$app->GenieApi->accessToken();

            if ($responseAuthorized->isOk) {
    
                $AccessToken=$responseAuthorized->data['access_token'];

                $responseStatus = Yii::$app->EzcashApi->getTransactionStatus($AccessToken,$TraNotiModel->transaction_id);
               

                if($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']==6){

                    $EzCashPuModel=EzcashPushTransaction::find()->where(['requestId'=>$TraNotiModel->transaction_id])->one();
                    $EzCashPuModel->cron_status=3;
                    $EzCashPuModel->save();

                    $TraNotiModelnext=TransactionNotification::find()->where(['id'=>$TraNotiModel->id])->one();
                    $TraNotiModelnext->cron_status=-1;
                    $TraNotiModelnext->save();

                    $con = $this->setDb($TraNotiModel->vendor_name);

                    $orderModel=Order::find()->where(['refference_id'=>$TraNotiModel->order_rf_id])->one($con);
                    $orderModel->status=2;
                    $orderModel->save();


                  

                    $con->close($con);

                   

                   
                    //print_r($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']);

    
                }
                if($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']==5){


                    $EzCashPuModel=EzcashPushTransaction::find()->where(['requestId'=>$TraNotiModel->transaction_id])->one();
                    $EzCashPuModel->cron_status=2;
                    $EzCashPuModel->save();
                    $TraNotiModelnext=TransactionNotification::find()->where(['id'=>$TraNotiModel->id])->one();
                    $TraNotiModelnext->cron_status=2;
                    $TraNotiModelnext->save();
                    $con = $this->setDb($TraNotiModel->vendor_name);

                    $orderModel=Order::find()->where(['refference_id'=>$TraNotiModel->order_rf_id])->one($con);
                    $orderModel->status=1;
                    $orderModel->save();


                  

                    $con->close($con);
                   
                   // print_r($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']);
    
        
                    }
                    if($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']==16){

                        $EzCashPuModel=EzcashPushTransaction::find()->where(['requestId'=>$TraNotiModel->transaction_id])->one();
                        $EzCashPuModel->cron_status=3;
                        $EzCashPuModel->save();
                        $TraNotiModelnext=TransactionNotification::find()->where(['id'=>$TraNotiModel->id])->one();
                    $TraNotiModelnext->cron_status=-1;
                    $TraNotiModelnext->save();
                    $con = $this->setDb($TraNotiModel->vendor_name);

                    $orderModel=Order::find()->where(['refference_id'=>$TraNotiModel->order_rf_id])->one($con);
                    $orderModel->status=2;
                    $orderModel->save();


                  

                    $con->close($con);
                   
                   
                       // print_r($responseStatus->data['getTransactionStatusViaRequestIdResponse']['return']['status']);
        
            
                        }
                        
               }else{
         
                 return "error";
               }

           

        }


        if($TraNotiModel->pay_type==2){

            $responseAuthorized = Yii::$app->GenieApi->accessToken();

            if ($responseAuthorized->isOk) {
                $AccessToken=$responseAuthorized->data['access_token'];
                $responseStatus = Yii::$app->GenieApi->getTransactionStatusUpdate($AccessToken,$TraNotiModel->transaction_id,"12");
                 print_r($responseStatus['merchantTxnStatusName']);
             
                if($responseStatus['merchantTxnStatusName']=="Payment Success") {

                 //   print_r($TraNotiModel->transaction_id)



                    $GeniePuModel=GeniePushTransaction::find()->where(['genieTransactionId'=>$TraNotiModel->transaction_id])->one();
                    $GeniePuModel->cron_status=2;
                    $GeniePuModel->save();

                    $TraNotiModelnext=TransactionNotification::find()->where(['id'=>$TraNotiModel->id])->one();
                    $TraNotiModelnext->cron_status=2;
                    $TraNotiModelnext->save();

                    $con = $this->setDb($TraNotiModel->vendor_name);

                    $orderModel=Order::find()->where(['refference_id'=>$TraNotiModel->order_rf_id])->one($con);
                    $orderModel->status=1;
                    $orderModel->save();


                  

                    $con->close($con);
                  
                }
                if($responseStatus['merchantTxnStatusName']=="Payment Fail") {
                    $GeniePuModel=GeniePushTransaction::find()->where(['genieTransactionId'=>$TraNotiModel->transaction_id])->one();
                    $GeniePuModel->cron_status=3;
                    $GeniePuModel->save();

                    $TraNotiModelnext=TransactionNotification::find()->where(['id'=>$TraNotiModel->id])->one();
                    $TraNotiModelnext->cron_status=-1;
                    $TraNotiModelnext->save();

                    $con = $this->setDb($TraNotiModel->vendor_name);

                    $orderModel=Order::find()->where(['refference_id'=>$TraNotiModel->order_rf_id])->one($con);
                    $orderModel->status=2;
                    $orderModel->save();


                  

                    $con->close($con);
                    //print_r("ssssssaaaaa")
                }
                if($responseStatus['merchantTxnStatusName']=="Customer Reject") {

                    $GeniePuModel=GeniePushTransaction::find()->where(['genieTransactionId'=>$TraNotiModel->transaction_id])->one();
                    $GeniePuModel->cron_status=-1;
                    $GeniePuModel->save();

                    $TraNotiModelnext=TransactionNotification::find()->where(['id'=>$TraNotiModel->id])->one();
                    $TraNotiModelnext->cron_status=-1;
                    $TraNotiModelnext->save();

                    $con = $this->setDb($TraNotiModel->vendor_name);

                    $orderModel=Order::find()->where(['refference_id'=>$TraNotiModel->order_rf_id])->one($con);
                    $orderModel->status=-1;
                    $orderModel->save();


                  

                    $con->close($con);
                    //print_r("Customer Reject");
                }






            

              
            }


        }
        sleep(3);
      }

  }




  public function actionSubCategoryProducts()
   {
       
    $request = yii::$app->request;
    $post = Json::decode($request->rawBody);
    $database = $post['database_name'];
    $sub_category_id = $post['sub_category_id'];

    $con = $this->setDb($database);

//     $rows = (new \yii\db\Query())
//     ->select('*')
//     ->from('product')
//     ->where(['sub_category_id'=>$sub_category_id])
//     ->orderBy([
//      'id' => SORT_DESC,
//      // 'item_no'=>SORT_AS
//    ])

//     ->all($con);


    $rows = (new \yii\db\Query())
    ->select('price_list.selling_price,product.*')
    ->from('product') 
    ->leftJoin('price_list', 'product.id = price_list.product_id')
    ->where(['price_list.is_active'=>1])
    ->andWhere(['product.status'=>1])
    ->andWhere(['sub_category_id'=>$sub_category_id])
    ->all($con);
    $con->close($con);


        return $this->asJson($rows);  


  
  }

    public function actionSession()
     {
        $session = Yii::$app->session;
        $session->set('vendor_db_name', "aaaaaaaaaaa"); 
        $aa= $session["vendor_db_name"];

        return $this->asJson($aa);  
          
    
    }


    public function beforeAction($action) 
    { 
        $this->enableCsrfValidation = false; 
        return parent::beforeAction($action); 
    } 
}
