<?php

namespace backend\controllers;

use Yii;
use backend\models\Product;
use tpmanc\imagick\Imagick;
use backend\models\ProductSearch;
use backend\models\PriceList;
use backend\models\Feedback;
use backend\models\Discount;
use backend\models\Notification;
use backend\models\DailyProdcutUpdate;
use backend\models\FavoriteProduct;
use backend\models\UpdateProdcut;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use backend\models\Vendor;
use backend\models\SubCategory;
use yii\helpers\Url;
use yii\filters\ContentNegotiator;
use yii\web\Response;
use yii\web\UploadedFile;
use backend\models\MainCategory;
use backend\models\MainCategorySearch;
use yii\filters\AccessControl;









/**
 * ProductController implements the CRUD actions for Product model.
 */
class ProductController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [

            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['login', 'error'],
                        'allow' => true,
                    ],
                    [
                        'actions' => ['create', 'index','view','deactivate','activate','getvendor','setsecession','getmaincategory','pricechange','requchange','setsecessionindex','dailycount','update','feedbackview','responseview','favoriteproduct','checkedfavorite','uncheckedfavorite'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                    // 'deactivate' => ['POST'],
                    'getvendor'=> ['POST'],
                    'setsecession'=> ['POST'],
                    'getmaincategory'=> ['POST'],
                    'pricechange'=> ['POST'],
                    'requchange'=> ['POST'],
                    'feedbackview'=> ['POST'],
                    'responseview'=>['POST'],
                    'checkedfavorite'=>['POST'],
                    'uncheckedfavorite'=>['POST'],
                ],
            ],

            'contentNegotiator' => [
                'class' => ContentNegotiator::className(),
                'only' => ['getvendor','setsecession','getmaincategory','pricechange','requchange','feedbackview','responseview','checkedfavorite','uncheckedfavorite'], 
                'formats' => [
                    'application/json' => Response::FORMAT_JSON,
                ],
            ]
        ];
    }

    /**
     * Lists all Product models.
     * @return mixed
     */

    public function setDb($database_name) { 
 
        $connection = new \yii\db\Connection([
            'dsn' => 'mysql:host=localhost;dbname='.$database_name,
            'username' => 'eimuser',
            'password' => 'Welcome1',
           
            'charset' => 'utf8',
            ]);
            $connection->open();
       return $connection;
} 

            public function actionSetsecession() { 
            
                $id = ($_POST['vendor_id']);
                $vandor_deataile=Vendor::find()->where(['id'=>$id])->one();

                if($vandor_deataile->database_name){

                    $session = Yii::$app->session;
                    $session->set('vendor_db_name',  $vandor_deataile->database_name);
                    $model = new Product();


                    return $this->redirect('create');
                    
                    return true;

                }
                
                return false;
                // return $all_vandor;
            } 

            public function actionSetsecessionindex() { 
            
                $id = ($_POST['vendor_id']);
                $vandor_deataile=Vendor::find()->where(['id'=>$id])->one();

                if($vandor_deataile->database_name){

                    $session = Yii::$app->session;
                    $session->set('vendor_db_name',  $vandor_deataile->database_name);
                    $model = new Product();


                    return true;
                    
                    // return true;

                }
                
                return false;
                // return $all_vandor;
            } 

            public function actionCheckedfavorite() { 
            
                $status2 = ($_POST['status']);
                $product_id = ($_POST['product_id']);

                $modelFavoriteProduct=new FavoriteProduct();
                $modelFavoriteProduct->product_id=$product_id;
                $modelFavoriteProduct->created_by=Yii::$app->user->identity->id;
                $modelFavoriteProduct->created_on= date('Y-m-d h:i:s');
                $modelFavoriteProduct->status=1;
                
                if($modelFavoriteProduct->save()){
                    return "ee";

                }

              
                return "ss";
            } 
            public function actionUncheckedfavorite() { 
            
                $status = ($_POST['status']);
                $product_id = ($_POST['product_id']);

                $modelFavoriteProduct=FavoriteProduct::find()->where(['product_id'=>$product_id])->andWhere(['status'=>1])->one();

                $modelFavoriteProduct->status=0;
                $modelFavoriteProduct->save();

                


              
                return $status;
            } 

            public function actionGetvendor() { 
            
                $id = ($_POST['organization_id']);
                $all_vandor=Vendor::find()->where(['organization_id'=>$id])->all();
              
                return $all_vandor;
            } 

            public function actionRequchange() {     
                $session = Yii::$app->session;            
                $notification_id = ($_POST['notification_id']);
                
                $notificationModel=Notification::find()->where(['id'=>$notification_id])->one();
                $vandor_deataile=Vendor::find()->where(['id'=>$notificationModel->vendor_id])->one();

                $session->set('vendor_db_name',  $vandor_deataile->database_name);
                 return $this->redirect(['price-list/requestprice', 'id' => $notificationModel->each_id , 'notif_id'=>$notificationModel->id]);
                 
            // return $notification_id;
            } 

            public function actionResponseview() {    
                
                
                $session = Yii::$app->session;            
                $notification_id = ($_POST['notification_id']);

                $notificationModel=Notification::find()->where(['id'=>$notification_id])->one();
                $notificationModel->status="3";
                $notificationModel->save();
                $vandor_deataile=Vendor::find()->where(['id'=>$notificationModel->vendor_id])->one();

                $session->set('vendor_db_name',  $vandor_deataile->database_name);
                 return $this->redirect(['price-list/responsview', 'id' => $notificationModel->each_id , 'notif_id'=>$notificationModel->id]);
                 
            // return $notification_id;
            } 


            public function actionGetmaincategory() { 
            
                $id = ($_POST['main_category_id']);
                $all_subcategory=SubCategory::find()->where(['main_category_id'=>$id])->all();
              
                return $all_subcategory;
            } 



            public function actionFeedbackview() { 
            
                $feedback_id = ($_POST['feedback_id']);
                $database_name=($_POST['database_name']);

                // return $database_name;
                $session = Yii::$app->session;
                $session->set('vendor_db_name',  $database_name);
                $modelFeedback= Feedback::find()->where(['id'=>$feedback_id])->one();
                $modelFeedback->status=0;
                $modelFeedback->save();


                return $this->redirect(['order/view/', 'id' => $modelFeedback->order_id."/#fdbk"]);



               
              
                return $feedback_id;
            } 


            public function actionPricechange() { 
                $session = Yii::$app->session;
                $buying_price = $_POST['buying_price'];
                $product_id = $_POST['product_id'];
                $selling_price = $_POST['selling_price'];
                // $all_subcategory=SubCategory::find()->where(['main_category_id'=>$id])->all();

                 $model_pricelist = PriceList::find()->where(['product_id'=>$product_id , 'is_active' => 1])->one();

                

                 $db_name = $session->get('vendor_db_name');
                 $ved_model=Vendor::find()->where(['database_name'=>$db_name])->one();
                // $model_pricelist2 = PriceList::find()->where(['product_id'=>$product_id , 'is_active' => 1])->one();

                // $model_pricelist2->updated_date= date('Y-m-d h:i:s');
                // $model_pricelist2->is_active= 0;
                // $model_pricelist2->save();
                // // PriceList::updateAll(['is_active' => 0], ['=', 'id', $model_pricelist->id]);
                if($buying_price==null){
                    $buying_price=$model_pricelist->buying_price;

                }
                if($selling_price==null){
                    $selling_price=$model_pricelist->selling_price;

                }

                $priceList = new PriceList();
                $priceList->description = "description";
                $priceList->is_active = -1;
                $priceList->product_id = $product_id;
                $priceList->selling_price = $selling_price;
                $priceList->buying_price = $buying_price;
                $priceList->created_date =date('Y-m-d h:i:s');
                
                if($priceList->save()){

                    $Notification= new Notification();
                    $Notification->type=1;
                    $Notification->status=0;
                    $Notification->created_on=date('Y-m-d h:i:s');
                    $Notification->created_by=Yii::$app->user->identity->id;
                    $Notification->each_id=$priceList->id;
                    $Notification->vendor_id=$ved_model->id;

                    if($Notification->save()){

                        return true;

                    }

                    return false;


                }else {
                    return false;
                    
                }

              
                
            } 




    public function actionIndex()
    {
      
        $session = Yii::$app->session;

        $db_name = $session->get('vendor_db_name');
        $ved_model=Vendor::find()->where(['database_name'=>$db_name])->one();
        
       
        $searchModel = new ProductSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
           
        ]);
    }


    public function actionFavoriteproduct()
    {
      
        $all_Product= Product::find()->all();
       
        

        if (isset($_POST['submit'])) { 
// print_r($_POST['newcountproduct']);
//                 die;

           $modelDailyProdcutUpdate =new DailyProdcutUpdate();
           $modelDailyProdcutUpdate->create_on=date('Y-m-d h:i:s');
           $modelDailyProdcutUpdate->create_by=Yii::$app->user->identity->id;
           $modelDailyProdcutUpdate->save();

           foreach ($_POST['newcountproduct'] as $key => $value) {

            
            $modeUpdateProdcut = new UpdateProdcut();
            if(! $value==null){

                // print_r($_POST['CountAdd']);
                // die;
                $modelProduct=Product::find()->where(['id'=>$key])->one();

                $modeUpdateProdcut->daily_prodcut_update_id=$modelDailyProdcutUpdate->id;
                $modeUpdateProdcut->prodcut_id=$key;
                $modeUpdateProdcut->product_count=$value;
                if($modeUpdateProdcut->save()){

                    if(isset($_POST['CountAdd'][$key])){


                        // print_r($_POST['CountAdd'][$key]);
                        // die;

                        $final_count=($modelProduct->available_quantity+$value);

                               $modelProduct->available_quantity=$final_count;
                               if($modelProduct->save()){
                                //    break;
                               }




                    }else{


                        $modelProduct->available_quantity=$value;
                        if($modelProduct->save()){
                            // break;
                        }



                    }
                   


                }


            }



           }






           return $this->redirect('favoriteproduct');
           


           
            
        }



        return $this->render('favoriteproduct', [
            'all_Product' => $all_Product,
            // 'dataProvider' => $dataProvider,
           
        ]);
    }

    public function actionDailycount()
    {
      
        $all_Product= Product::find()->all();

        

        if (isset($_POST['submit'])) { 
// print_r($_POST['newcountproduct']);
//                 die;

           $modelDailyProdcutUpdate =new DailyProdcutUpdate();
           $modelDailyProdcutUpdate->create_on=date('Y-m-d h:i:s');
           $modelDailyProdcutUpdate->create_by=Yii::$app->user->identity->id;
           $modelDailyProdcutUpdate->save();

           foreach ($_POST['newcountproduct'] as $key => $value) {

            
            $modeUpdateProdcut = new UpdateProdcut();
            if(! $value==null){

                // print_r($_POST['CountAdd']);
                // die;
                $modelProduct=Product::find()->where(['id'=>$key])->one();

                $modeUpdateProdcut->daily_prodcut_update_id=$modelDailyProdcutUpdate->id;
                $modeUpdateProdcut->prodcut_id=$key;
                $modeUpdateProdcut->product_count=$value;
                if($modeUpdateProdcut->save()){

                    if(isset($_POST['CountAdd'][$key])){


                        // print_r($_POST['CountAdd'][$key]);
                        // die;

                        $final_count=($modelProduct->available_quantity+$value);

                               $modelProduct->available_quantity=$final_count;
                               if($modelProduct->save()){
                                //    break;
                               }




                    }else{


                        $modelProduct->available_quantity=$value;
                        if($modelProduct->save()){
                            // break;
                        }



                    }
                   


                }


            }



           }






           return $this->redirect('dailycount');
           


           
            
        }



        return $this->render('dailycount', [
            'all_Product' => $all_Product,
            // 'dataProvider' => $dataProvider,
           
        ]);
    }

    /**
     * Displays a single Product model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
       
        $price = PriceList:: find()->where(['product_id' => $id , 'is_active' => 1])->one() ;


        

      
        $session = Yii::$app->session;
        $selected_dbname= $session->get('vendor_db_name');
        $con = $this->setDb($selected_dbname);

        $aa = Product::find()->where(['id'=>$id])->one($con);
        $all_price = PriceList:: find()->where(['product_id' => $id])->andWhere(['is_active'=>[0,1]])->all($con) ;

        $con->close();



        // print_r($price->selling_price);
        //die;

        return $this->render('view', [
            'model' => Product::find()->where(['id'=>$id])->one($con),
            'all_price'=>$all_price,

            'price' => $price
        ]);
    }

    /**
     * Creates a new Product model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $session = Yii::$app->session;

        $model = new Product();
        $model_pricelist = new PriceList();
        if (Yii::$app->request->isPost) {
   //    need to add session vendor id
            $selected_dbname= $session->get('vendor_db_name');

            
            
            $vendor_details=Vendor::find()->Where(['database_name'=>$selected_dbname])->one();
            $fill_name_image_path="image_path".date('Ymdhis');
            $fill_name_details_image_path="details_image_path".date('Ymdhis');

        
            $model->file = UploadedFile::getInstance($model, 'file');
            if($model->file){
           
                $model->file->saveAs('../image/'.$vendor_details->database_name.'/' . $fill_name_image_path . '.' . $model->file->extension);
               
          
                
                Imagick::open('../image/'.$vendor_details->database_name.'/' . $fill_name_image_path . '.' . $model->file->extension)->resize(300,300)->saveTo('../image/'.$vendor_details->database_name.'/' . $fill_name_image_path . '_m.' . $model->file->extension);
                // echo($img);
                // die;
                //save databases
                $model->image_path='../image/'.$vendor_details->database_name.'/' . $fill_name_image_path . '.' . $model->file->extension; 


           }

        //    $model->file2 = UploadedFile::getInstance($model, 'file2');
        //    if($model->file2){
                
        //        $model->file2->saveAs('../image/'.$vendor_details->database_name.'/' . $fill_name_details_image_path . '.' . $model->file2->extension);

        //        //save databases
        //        $model->details_image_path='../image/'.$vendor_details->database_name.'/' . $fill_name_details_image_path . '.' . $model->file2->extension; 


        //   }
        }
      

        if ($model->load(Yii::$app->request->post()) ) {
            $session = Yii::$app->session;
        
           $vendordetails= Vendor:: find()->where(['database_name'=>$session->get('vendor_db_name')])->one() ;


                
            $model->status="0";
            $model->rating="0";
            // $model->buying_price="0";
            
            $model->created=date('Y-m-d h:i:s');
            $model->details_image_path='null';
            
            $model->created_by=Yii::$app->user->identity->id;

          
            if( $model->save()){


                //// for  eZcach


                $modelDiscount=new Discount();

                $modelDiscount->product_id=$model->id;
                $modelDiscount->status=1;
                $modelDiscount->activate_on= date('Y-m-d h:i:s');
                $modelDiscount->deactivate_on= date('Y-m-d h:i:s');
                $modelDiscount->discount=13;
                $modelDiscount->pay_type_id=1;
                
                $modelDiscount->save();


                //// for  genie

                $modelDiscount2=new Discount();

                $modelDiscount2->product_id=$model->id;
                $modelDiscount2->status=1;
                $modelDiscount2->activate_on= date('Y-m-d h:i:s');
                $modelDiscount2->deactivate_on= date('Y-m-d h:i:s');
                $modelDiscount2->discount=10;
                $modelDiscount2->pay_type_id=2;
                
                $modelDiscount2->save();


                // die;

                if ($model_pricelist->load(Yii::$app->request->post())  ) {
                    $priceList = new PriceList();
                    $priceList->description = $model->name;
                    $priceList->is_active = 1;
                    $priceList->product_id = $model->id;
                    $priceList->selling_price ='0';
                    $priceList->buying_price = $model_pricelist->buying_price;
                    $priceList->created_date =date('Y-m-d h:i:s');
                    $priceList->save();
                }
               
                
                return $this->redirect(['view', 'id' => $model->id , 've_id'=>$vendordetails->id]);
             
            }else{
                return $this->redirect(['create']);
            }
        

 
         

          
        }

        return $this->render('create', [
            'model' => $model,
            'model_pricelist' => $model_pricelist
        ]);
    }

    /**
     * Updates an existing Product model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $session = Yii::$app->session;
        $model = $this->findModel($id);
        $selelctedSubCatogry=$model->sub_category_id;
       
        $model_pricelist = PriceList::find()->where(['product_id'=>$id , 'is_active' => 1])->one();
        $model_pricelist2 = PriceList::find()->where(['product_id'=>$id , 'is_active' => 1])->one();
  
        $vendordetails= Vendor:: find()->where(['database_name'=>$session->get('vendor_db_name')])->one() ;

        if (Yii::$app->request->isPost) {
             //    need to add session vendor id
            $selected_dbname= $session->get('vendor_db_name');

            $vendor_details=Vendor::find()->Where(['database_name'=>$selected_dbname])->one();
            $fill_name_image_path="image_path".date('Ymdhis');
            $fill_name_details_image_path="details_image_path".date('Ymdhis');

            $model->file = UploadedFile::getInstance($model, 'file');
            if($model->file){
                $model->file->saveAs('../image/'.$vendor_details->database_name.'/' . $fill_name_image_path . '.' . $model->file->extension);
                Imagick::open('../image/'.$vendor_details->database_name.'/' . $fill_name_image_path . '.' . $model->file->extension)->resize(300,300)->saveTo('../image/'.$vendor_details->database_name.'/' . $fill_name_image_path . '_m.' . $model->file->extension);
       
                //save databases
                $model->image_path='../image/'.$vendor_details->database_name.'/' . $fill_name_image_path . '.' . $model->file->extension; 


           }
       
        }



       
    

       
        if ($model->load(Yii::$app->request->post()) && $model->save()) {

            if ($model_pricelist->load(Yii::$app->request->post())) {

                
                if($model_pricelist->selling_price != $model_pricelist2->selling_price || $model_pricelist->buying_price != $model_pricelist2->buying_price ){
                    
                    $model_pricelist2->updated_date= date('Y-m-d h:i:s');
                    $model_pricelist2->save();


                    PriceList::updateAll(['is_active' => 0], ['=', 'id', $model_pricelist->id]);

                    $priceList = new PriceList();
                    $priceList->description = $model_pricelist->description;
                    $priceList->is_active = 1;
                    $priceList->product_id = $model_pricelist->product_id;
                    $priceList->selling_price = $model_pricelist->selling_price;
                    $priceList->buying_price = $model_pricelist->buying_price;
                    $priceList->created_date =date('Y-m-d h:i:s');
                    $priceList->save();



                }




               
                    
               
            }
            return $this->redirect(['view', 'id' => $model->id , 've_id'=>$vendordetails->id]);
        
        }

       

        return $this->render('update', [
             'model' => $model,
             'model_pricelist' =>  $model_pricelist,
       
             'update'=>true
             
        ]);
    }

    /**
     * Deletes an existing Product model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Product model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Product the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Product::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }

    public function actionDeactivate()
    {
        $id = $_POST['id'];

         $a =  Product::updateAll(['status' => 0], ['=', 'id', $id]);
           
        return  $id;
    }

    public function actionActivate()
    {
        $id = $_POST['id'];

         $a =  Product::updateAll(['status' => 1], ['=', 'id', $id]);
           
        return  $id;
    }


    public function beforeAction($action) 
    { 
        $this->enableCsrfValidation = false; 
        return parent::beforeAction($action); 
    } 
    
}
