<?php

namespace backend\models;

use Yii;

/**
 * This is the model class for table "discount".
 *
 * @property int $id
 * @property int $product_id
 * @property int $status
 * @property string $activate_on
 * @property string $deactivate_on
 * @property double $discount
 * @property int $pay_type_id
 *
 * @property Product $product
 * @property PayTypes $payType
 */
class Discount extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'discount';
    }

    /**
     * @return \yii\db\Connection the database connection used by this AR class.
     */
    public static function getDb()
    {
        $session = Yii::$app->session;

        $db_name = $session->get('vendor_db_name');

        if(! $session->get($db_name) ){



            $connection =Yii::$app->PosDbManager->getDbConnection($db_name);

            


            

         $dbcon= $session->set($db_name,  $connection);



        
         return $connection;



        }else{
            $dbcon= $session->get($db_name);
          

            return $dbcon;
        }
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['product_id', 'status', 'discount', 'pay_type_id'], 'required'],
            [['product_id', 'status', 'pay_type_id'], 'integer'],
            [['activate_on', 'deactivate_on'], 'safe'],
            [['discount'], 'number'],
            [['product_id'], 'exist', 'skipOnError' => true, 'targetClass' => Product::className(), 'targetAttribute' => ['product_id' => 'id']],
            [['pay_type_id'], 'exist', 'skipOnError' => true, 'targetClass' => PayTypes::className(), 'targetAttribute' => ['pay_type_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'product_id' => 'Product ID',
            'status' => 'Status',
            'activate_on' => 'Activate On',
            'deactivate_on' => 'Deactivate On',
            'discount' => 'Discount(%)',
            'pay_type_id' => 'Pay Type ID',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getProduct()
    {
        return $this->hasOne(Product::className(), ['id' => 'product_id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPayType()
    {
        return $this->hasOne(PayTypes::className(), ['id' => 'pay_type_id']);
    }
}
