<?php

namespace backend\models;

use Yii;

/**
 * This is the model class for table "ezcash_account".
 *
 * @property int $id
 * @property int $vendor_id
 * @property string $username
 * @property string $password
 * @property string $subscriberMobile
 *
 * @property Vendor $vendor
 */
class EzcashAccount extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'ezcash_account';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['vendor_id', 'username', 'password', 'subscriberMobile'], 'required'],
            [['vendor_id'], 'integer'],
            [['username', 'password', 'subscriberMobile'], 'string', 'max' => 500],
            [['vendor_id'], 'exist', 'skipOnError' => true, 'targetClass' => Vendor::className(), 'targetAttribute' => ['vendor_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'vendor_id' => 'Vendor ID',
            'username' => 'Username',
            'password' => 'Password',
            'subscriberMobile' => 'Subscriber Mobile',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getVendor()
    {
        return $this->hasOne(Vendor::className(), ['id' => 'vendor_id']);
    }
}
