<?php

namespace backend\models;

use Yii;

/**
 * This is the model class for table "feedback".
 *
 * @property int $id
 * @property string $description
 * @property string $created_date
 * @property int $created_by
 * @property int $vendor_id
 * @property int $order_id
 * @property int $status
 * @property string $order_ref_id
 *
 * @property Vendor $vendor
 * @property User $createdBy
 */
class Feedback extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'feedback';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['description', 'created_date', 'created_by', 'vendor_id', 'order_id', 'status', 'order_ref_id'], 'required'],
            [['description'], 'string'],
            [['created_date'], 'safe'],
            [['created_by', 'vendor_id', 'order_id', 'status'], 'integer'],
            [['order_ref_id'], 'string', 'max' => 250],
            [['vendor_id'], 'exist', 'skipOnError' => true, 'targetClass' => Vendor::className(), 'targetAttribute' => ['vendor_id' => 'id']],
            [['created_by'], 'exist', 'skipOnError' => true, 'targetClass' => User::className(), 'targetAttribute' => ['created_by' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'description' => 'Description',
            'created_date' => 'Created Date',
            'created_by' => 'Created By',
            'vendor_id' => 'Vendor ID',
            'order_id' => 'Order ID',
            'status' => 'Status',
            'order_ref_id' => 'Order Ref ID',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getVendor()
    {
        return $this->hasOne(Vendor::className(), ['id' => 'vendor_id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getCreatedBy()
    {
        return $this->hasOne(User::className(), ['id' => 'created_by']);
    }
}
