<?php

namespace backend\models;

use Yii;

/**
 * This is the model class for table "genie_account".
 *
 * @property int $id
 * @property int $vendor_id
 * @property string $password
 * @property string $secret_code
 * @property string $pg_identifier
 * @property int $counter_id
 * @property string $store_name
 * @property string $vendor_db_name
 *
 * @property Vendor $vendor
 */
class GenieAccount extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'genie_account';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['vendor_id', 'password', 'secret_code', 'pg_identifier', 'counter_id', 'store_name', 'vendor_db_name'], 'required'],
            [['vendor_id', 'counter_id'], 'integer'],
            [['password', 'pg_identifier', 'store_name', 'vendor_db_name'], 'string', 'max' => 250],
            [['secret_code'], 'string', 'max' => 500],
            [['vendor_id'], 'exist', 'skipOnError' => true, 'targetClass' => Vendor::className(), 'targetAttribute' => ['vendor_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'vendor_id' => 'Vendor ID',
            'password' => 'Password',
            'secret_code' => 'Secret Code',
            'pg_identifier' => 'Pg Identifier',
            'counter_id' => 'Counter ID',
            'store_name' => 'Store Name',
            'vendor_db_name' => 'Vendor Db Name',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getVendor()
    {
        return $this->hasOne(Vendor::className(), ['id' => 'vendor_id']);
    }
}
