<?php

namespace backend\models;

use Yii;
use backend\models\Vendor;


/**
 * This is the model class for table "master_menu".
 *
 * @property int $id
 * @property string $name
 * @property int $createdBy
 * @property string $createtdON
 * @property int $status
 *
 * @property MenuType[] $menuTypes
 */
class MasterMenu extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'master_menu';
    }

    /**
     * @return \yii\db\Connection the database connection used by this AR class.
     */
    public static function getDb()
    {
        $session = Yii::$app->session;

        $db_name = $session->get('vendor_db_name');

        if(! $session->get($db_name) ){



            $connection =Yii::$app->PosDbManager->getDbConnection($db_name);


            


            

         $dbcon= $session->set($db_name,  $connection);



        
         return $connection;



        }else{
            $dbcon= $session->get($db_name);
          

            return $dbcon;
        }
 
      
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name', 'createdBy', 'createtdON', 'status'], 'required'],
            [['createdBy', 'status'], 'integer'],
            [['createtdON'], 'safe'],
            [['name'], 'string', 'max' => 250],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'createdBy' => 'Created By',
            'createtdON' => 'Createtd On',
            'status' => 'Status',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getMenuTypes()
    {
        return $this->hasMany(MenuType::className(), ['master_menu_id' => 'id']);
    }
}
