<?php

namespace backend\models;

use Yii;
use backend\models\Vendor;
use yii\helpers\ArrayHelper;


/**
 * This is the model class for table "menu_type".
 *
 * @property int $id
 * @property string $name
 * @property string $description
 * @property int $master_menu_id
 *
 * @property MasterMenu $masterMenu
 * @property MenuTypeItems[] $menuTypeItems
 */
class MenuType extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'menu_type';
    }

    /**
     * @return \yii\db\Connection the database connection used by this AR class.
     */
    public static function getDb()
    {
        $session = Yii::$app->session;

        $db_name = $session->get('vendor_db_name');

        if(! $session->get($db_name) ){



            $connection = new \yii\db\Connection([
                'dsn' => 'mysql:host=localhost;dbname='.$db_name.'',
            'username' => 'eimuser',
            'password' => 'Welcome1',
            'charset' => 'utf8',
         
            
            ]);

            


            

         $dbcon= $session->set($db_name,  $connection);



        
         return $connection;



        }else{
            $dbcon= $session->get($db_name);
          

            return $dbcon;
        }
 
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name', 'description', 'master_menu_id'], 'required'],
            [['master_menu_id'], 'integer'],
            [['name', 'description'], 'string', 'max' => 150],
            [['master_menu_id'], 'exist', 'skipOnError' => true, 'targetClass' => MasterMenu::className(), 'targetAttribute' => ['master_menu_id' => 'id']],
            [['image_path'], 'string', 'max' => 250], 
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'description' => 'Description',
            'master_menu_id' => 'Master Menu ID',
            'image_path' =>'Image Path'
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getMasterMenu()
    {
        return $this->hasOne(MasterMenu::className(), ['id' => 'master_menu_id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getMenuTypeItems()
    {
        return $this->hasMany(MenuTypeItems::className(), ['menu_type_id' => 'id']);
    }

    public static function getList()
    {
       
            return array('' => '') + ArrayHelper::map(self::find()->all(), 'id', 'name');
       
    }
}
