<?php

namespace backend\models;

use Yii;
use backend\models\Vendor;


/**
 * This is the model class for table "menu_type_items".
 *
 * @property int $id
 * @property string $name
 * @property int $menu_type_id
 * @property int $product_id
 *
 * @property MenuType $menuType
 * @property Product $product
 */
class MenuTypeItems extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'menu_type_items';
    }

    /**
     * @return \yii\db\Connection the database connection used by this AR class.
     */
    public static function getDb()
    {
        $session = Yii::$app->session;

        $db_name = $session->get('vendor_db_name');

        if(! $session->get($db_name) ){



            $connection = new \yii\db\Connection([
                'dsn' => 'mysql:host=localhost;dbname='.$db_name.'',
            'username' => 'eimuser',
            'password' => 'Welcome1',
            'charset' => 'utf8',
         
            
            ]);

            


            

         $dbcon= $session->set($db_name,  $connection);



        
         return $connection;



        }else{
            $dbcon= $session->get($db_name);
          

            return $dbcon;
        }
      
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name', 'menu_type_id', 'product_id'], 'required'],
            [['menu_type_id', 'product_id'], 'integer'],
            [['name'], 'string', 'max' => 150],
            [['menu_type_id'], 'exist', 'skipOnError' => true, 'targetClass' => MenuType::className(), 'targetAttribute' => ['menu_type_id' => 'id']],
            [['product_id'], 'exist', 'skipOnError' => true, 'targetClass' => Product::className(), 'targetAttribute' => ['product_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'menu_type_id' => 'Menu Type ID',
            'product_id' => 'Product ID',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getMenuType()
    {
        return $this->hasOne(MenuType::className(), ['id' => 'menu_type_id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getProduct()
    {
        return $this->hasOne(Product::className(), ['id' => 'product_id']);
    }
}
