<?php

namespace backend\models;

use Yii;

/**
 * This is the model class for table "notification".
 *
 * @property int $id
 * @property int $type
 * @property int $status
 * @property string $created_on
 * @property string $approved_on
 * @property int $approved_by
 * @property int $created_by
 * @property int $each_id
 * @property int $vendor_id
 *
 * @property Vendor $vendor
 */
class Notification extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'notification';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['type', 'status', 'created_on', 'created_by', 'each_id', 'vendor_id'], 'required'],
            [['type', 'status', 'approved_by', 'created_by', 'each_id', 'vendor_id'], 'integer'],
            [['created_on', 'approved_on'], 'safe'],
            [['vendor_id'], 'exist', 'skipOnError' => true, 'targetClass' => Vendor::className(), 'targetAttribute' => ['vendor_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'type' => 'Type',
            'status' => 'Status',
            'created_on' => 'Created On',
            'approved_on' => 'Approved On',
            'approved_by' => 'Approved By',
            'created_by' => 'Created By',
            'each_id' => 'Each ID',
            'vendor_id' => 'Vendor ID',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getVendor()
    {
        return $this->hasOne(Vendor::className(), ['id' => 'vendor_id']);
    }
}
