<?php

namespace backend\models;

use Yii;

use backend\models\Vendor;
use backend\models\OrderSerial;
use backend\models\User;



/**
 * This is the model class for table "order".
 *
 * @property int $id
 * @property string $refference_id
 * @property int $number_of_items
 * @property string $total_amount
 * @property int $status
 * @property string $created_on
 * @property int $created_by
 * @property int $customer_id
 * @property int $rating
 *
 * @property OrderItem[] $orderItems
 */
class Order extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'order';
    }

    /**
     * @return \yii\db\Connection the database connection used by this AR class.
     */
    public static function getDb()
    {
        
        $session = Yii::$app->session;

        $db_name = $session->get('vendor_db_name');

        if(! $session->get($db_name) ){



            $connection =Yii::$app->PosDbManager->getDbConnection($db_name);

            


            

         $dbcon= $session->set($db_name,  $connection);



        
         return $connection;



        }else{
            $dbcon= $session->get($db_name);
          

            return $dbcon;
        }
 
      
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['refference_id', 'number_of_items', 'total_amount', 'status', 'created_on', 'created_by', 'customer_id', 'rating', 'order_type'], 'required'],
            [['number_of_items', 'status', 'created_by', 'customer_id', 'rating', 'pay_type_id', 'order_type', 'order_option_id','print_status','view_status'], 'integer'],
            [['total_amount','full_amount','discount'], 'number'],
            [['created_on'], 'safe'],
            [['customer_req'], 'string'], 
            [['refference_id'], 'string', 'max' => 150],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'refference_id' => 'Refference ID',
            'number_of_items' => 'Number Of Items',
            'total_amount' => 'Total Amount',
            'status' => 'Status',
            'created_on' => 'Created On',
            'created_by' => 'Created By',
            'customer_id' => 'Customer ID',
            'rating' => 'Rating',
            'full_amount'=>'Full Amount',
            'order_option_id'=>'Order Option',
            'print_status'=>'print_status',
            'customer_req'=>'Customer Req',
            'view_status'=>'View Status',
            'discount'=>'Discount'
        ];
    }


     /** 
    * @return \yii\db\ActiveQuery 
    */ 
   public function getOrderType() 
   { 
       return $this->hasOne(OrderType::className(), ['id' => 'order_type']); 
   } 
    /**
     * @return \yii\db\ActiveQuery
     */
    public function getOrderItems()
    {
        return $this->hasMany(OrderItem::className(), ['order_id' => 'id']);
    }

    public function getPayType() 
    { 
        return $this->hasOne(PayTypes::className(), ['id' => 'pay_type_id']); 
    }

   
   /**
    * @return \yii\db\ActiveQuery
    */
   public function getOrderOption()
   {
       return $this->hasOne(OrderOption::className(), ['id' => 'order_option_id']);
   }
   /**
    * @return \yii\db\ActiveQuery
    */
   public function getOrderFeedbacks()
   {
       return $this->hasMany(OrderFeedback::className(), ['order_id' => 'id']);
   }


   public function getSerialNum()
   {
       $lastmodelOrderSerial = OrderSerial::find()->orderBy(['id'=> SORT_DESC])->one();
       $modeOrderSerial=new OrderSerial();

       if($lastmodelOrderSerial==null){
           $modeOrderSerial->serial_num=1;
           $modeOrderSerial->order_id=12;
           $modeOrderSerial->save();

           return $modeOrderSerial->serial_num;
          
       }else{
           $modeOrderSerial->serial_num=$lastmodelOrderSerial->serial_num+1;
           $modeOrderSerial->order_id=12;
           $modeOrderSerial->save();
           return $modeOrderSerial->serial_num;

       }

       
   }
 
}
