<?php

namespace backend\models;

use Yii;

/**
 * This is the model class for table "order_feedback".
 *
 * @property int $id
 * @property int $order_id
 * @property string $feedback
 * @property int $user_id
 * @property string $created_date
 *
 * @property Order $order
 */
class OrderFeedback extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'order_feedback';
    }

    /**
     * @return \yii\db\Connection the database connection used by this AR class.
     */
    public static function getDb()
    {
        $session = Yii::$app->session;

        $db_name = $session->get('vendor_db_name');

        if(! $session->get($db_name) ){


            $connection =Yii::$app->PosDbManager->getDbConnection($db_name);


            


            

         $dbcon= $session->set($db_name,  $connection);



        
         return $connection;



        }else{
            $dbcon= $session->get($db_name);
          

            return $dbcon;
        }
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['order_id', 'feedback', 'user_id', 'created_date'], 'required'],
            [['order_id', 'user_id'], 'integer'],
            [['created_date'], 'safe'],
            [['feedback'], 'string', 'max' => 500],
            [['order_id'], 'exist', 'skipOnError' => true, 'targetClass' => Order::className(), 'targetAttribute' => ['order_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'order_id' => 'Order ID',
            'feedback' => 'Feedback',
            'user_id' => 'User ID',
            'created_date' => 'Created Date',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getOrder()
    {
        return $this->hasOne(Order::className(), ['id' => 'order_id']);
    }
}
