<?php

namespace backend\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\models\Order;

/**
 * OrderSearch represents the model behind the search form of `backend\models\Order`.
 */
class OrderSearch extends Order
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'number_of_items', 'status', 'created_by', 'customer_id', 'rating', 'pay_type_id', 'order_type', 'order_option_id','print_status'], 'integer'],
            [['refference_id', 'created_on'], 'safe'],
            [['total_amount', 'full_amount'], 'number'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Order::find()->orderBy([
            'id' => SORT_DESC,
            // 'item_no'=>SORT_ASC
          ]);

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'number_of_items' => $this->number_of_items,
            'total_amount' => $this->total_amount,
            'status' => $this->status,
            'created_on' => $this->created_on,
            'created_by' => $this->created_by,
            'customer_id' => $this->customer_id,
            'rating' => $this->rating,
            'pay_type_id' => $this->pay_type_id,
            'order_type' => $this->order_type,
            'order_option_id' => $this->order_option_id,
           'full_amount' => $this->full_amount,
           'print_status'=>$this->print_status,
        ]);

        $query->andFilterWhere(['like', 'refference_id', $this->refference_id]);

        return $dataProvider;
    }
}
