<?php

namespace backend\models;

use Yii;
use backend\models\Vendor;

use yii\helpers\ArrayHelper;

/**
 * This is the model class for table "organization".
 *
 * @property int $id
 * @property string $name
 * @property string $address
 * @property string $description
 * @property string $created
 * @property string $image_path
 * @property int $status
 * @property string $code
 *
 * @property Vendor[] $vendors
 */
class Organization extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'organization';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name', 'address', 'description', 'created', 'image_path', 'status', 'code'], 'required'],
            [['created'], 'safe'],
            [['status'], 'integer'],
            [['name'], 'string', 'max' => 150],
            [['address', 'description', 'image_path'], 'string', 'max' => 250],
            [['code'], 'string', 'max' => 100],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'address' => 'Address',
            'description' => 'Description',
            'created' => 'Created',
            'image_path' => 'Image Path',
            'status' => 'Status',
            'code' => 'Code',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getVendors()
    {
        return $this->hasMany(Vendor::className(), ['organization_id' => 'id']);
    }

    public static function getList()
    {
       
            return array('' => '') + ArrayHelper::map(self::find()->all(), 'id', 'name');
       
    }
}
