<?php

namespace backend\models;

use Yii;
use backend\models\Vendor;

/**
 * This is the model class for table "price_list".
 *
 * @property int $id
 * @property string $description
 * @property int $is_active
 * @property int $product_id
 * @property string $selling_price
 * @property string $buying_price
 *
 * @property Product $product
 */
class PriceList extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'price_list';
    }

    /**
     * @return \yii\db\Connection the database connection used by this AR class.
     */
    public static function getDb()
    {
       
    
        $session = Yii::$app->session;

        $db_name = $session->get('vendor_db_name');

        if(! $session->get($db_name) ){

        $connection =Yii::$app->PosDbManager->getDbConnection($db_name);

         $dbcon= $session->set($db_name,  $connection);
         return $connection;
        }else{
            $dbcon= $session->get($db_name);
          

            return $dbcon;
        }
 
      
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [[ 'description', 'is_active', 'product_id', 'selling_price', 'buying_price'], 'required'],
            [['is_active', 'product_id'], 'integer'],
            [['selling_price', 'buying_price'], 'number'],
            [['updated_date','created_date'], 'safe'],

            [['description'], 'string', 'max' => 1024],
            [['product_id'], 'exist', 'skipOnError' => true, 'targetClass' => Product::className(), 'targetAttribute' => ['product_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'description' => 'Description',
            'is_active' => 'Is Active',
            'product_id' => 'Product',
            'selling_price' => 'Selling Price',
            'buying_price' => 'Buying Price',
            'updated_date' => 'Updated Date',
            'created_date' => 'Created Date',

        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getProduct()
    {
        return $this->hasOne(Product::className(), ['id' => 'product_id']);
    }
}
