<?php

namespace backend\models;

use Yii;
use backend\models\Vendor;
use yii\helpers\ArrayHelper;

/**
 * This is the model class for table "sub_category".
 *
 * @property int $id
 * @property string $name
 * @property int $rating
 * @property int $status
 * @property string $image_path
 * @property string $created_on
 * @property int $created_by
 * @property int $main_category_id
 *
 * @property Product[] $products
 * @property MainCategory $mainCategory
 */
class SubCategory extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sub_category';
    }

    /**
     * @return \yii\db\Connection the database connection used by this AR class.
     */
    public static function getDb()
    {
        $session = Yii::$app->session;

        $db_name = $session->get('vendor_db_name');

        if(! $session->get($db_name) ){



            $connection = new \yii\db\Connection([
                'dsn' => 'mysql:host=localhost;dbname='.$db_name.'',
            'username' => 'eimuser',
            'password' => 'Welcome1',
            'charset' => 'utf8',
         
            
            ]);

            


            

         $dbcon= $session->set($db_name,  $connection);



        
         return $connection;



        }else{
            $dbcon= $session->get($db_name);
          

            return $dbcon;
        }
 
      
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name', 'rating', 'status', 'image_path', 'created_on', 'created_by', 'main_category_id'], 'required'],
            [['rating', 'status', 'created_by', 'main_category_id','menu_type_id'], 'integer'],
            [['created_on'], 'safe'],
            [['name'], 'string', 'max' => 150],
            [['image_path'], 'string', 'max' => 250],
            [['main_category_id'], 'exist', 'skipOnError' => true, 'targetClass' => MainCategory::className(), 'targetAttribute' => ['main_category_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'rating' => 'Rating',
            'status' => 'Status',
            'image_path' => 'Image Path',
            'created_on' => 'Created On',
            'created_by' => 'Created By',
            'main_category_id' => 'Main Category',
            'menu_type_id'=>'Menu Type'
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getProducts()
    {
        return $this->hasMany(Product::className(), ['sub_category_id' => 'id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getMainCategory()
    {
        return $this->hasOne(MainCategory::className(), ['id' => 'main_category_id']);
    }


    public static function getList()
    {
       
            return array('' => '') + ArrayHelper::map(self::find()->all(), 'id', 'name');
       
    }
}
