<?php

namespace backend\models;

use Yii;

/**
 * This is the model class for table "update_prodcut".
 *
 * @property int $id
 * @property int $daily_prodcut_update_id
 * @property int $prodcut_id
 * @property int $product_count
 *
 * @property DailyProdcutUpdate $dailyProdcutUpdate
 * @property Product $prodcut
 */
class UpdateProdcut extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'update_prodcut';
    }

    /**
     * @return \yii\db\Connection the database connection used by this AR class.
     */
    public static function getDb()
    {
        $session = Yii::$app->session;

        $db_name = $session->get('vendor_db_name');

        if(! $session->get($db_name) ){



            $connection =Yii::$app->PosDbManager->getDbConnection($db_name);


            


            

         $dbcon= $session->set($db_name,  $connection);



        
         return $connection;



        }else{
            $dbcon= $session->get($db_name);
          

            return $dbcon;
        }
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['daily_prodcut_update_id', 'prodcut_id', 'product_count'], 'required'],
            [['daily_prodcut_update_id', 'prodcut_id', 'product_count'], 'integer'],
            [['daily_prodcut_update_id'], 'exist', 'skipOnError' => true, 'targetClass' => DailyProdcutUpdate::className(), 'targetAttribute' => ['daily_prodcut_update_id' => 'id']],
            [['prodcut_id'], 'exist', 'skipOnError' => true, 'targetClass' => Product::className(), 'targetAttribute' => ['prodcut_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'daily_prodcut_update_id' => 'Daily Prodcut Update ID',
            'prodcut_id' => 'Prodcut ID',
            'product_count' => 'Product Count',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getDailyProdcutUpdate()
    {
        return $this->hasOne(DailyProdcutUpdate::className(), ['id' => 'daily_prodcut_update_id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getProdcut()
    {
        return $this->hasOne(Product::className(), ['id' => 'prodcut_id']);
    }
}
