<?php

namespace backend\models;

use Yii;
use yii\helpers\ArrayHelper;


/**
 * This is the model class for table "vendor".
 *
 * @property int $id
 * @property string $name
 * @property string $description
 * @property int $organization_id
 * @property string $created
 * @property int $status
 * @property string $code
 * @property string $database_name
 *
 * @property Organization $organization
 */
class Vendor extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'vendor';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name', 'description', 'organization_id', 'created', 'status', 'code', 'database_name'], 'required'],
            [['organization_id', 'status'], 'integer'],
            [['created'], 'safe'],
            [['name'], 'string', 'max' => 150],
            [['description', 'database_name','image_path'], 'string', 'max' => 250],
            [['code'], 'string', 'max' => 100],
            [['organization_id'], 'exist', 'skipOnError' => true, 'targetClass' => Organization::className(), 'targetAttribute' => ['organization_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'description' => 'Description',
            'organization_id' => 'Organization ID',
            'created' => 'Created',
            'status' => 'Status',
            'code' => 'Code',
            'database_name' => 'Database Name',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getOrganization()
    {
        return $this->hasOne(Organization::className(), ['id' => 'organization_id']);
    }

    public static function getList()
    {
       
            return array('' => '') + ArrayHelper::map(self::find()->all(), 'id', 'name');
       
    }
}
