<?php
namespace app\modules\api\controllers;

use Yii;
use yii\web\Controller;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;
use yii\filters\ContentNegotiator;
use yii\web\Response;
use webvimark\modules\UserManagement\models\User;
use webvimark\modules\UserManagement\models\forms\LoginForm;
use yii\helpers\Json;
use webvimark\modules\UserManagement\components\UserIdentity;
use app\models\Userinstitute;
use app\models\Course;
use app\models\Courseregistration;
use app\models\Card;

class MobileController extends Controller
{

    public $enableCsrfValidation = false;

	public function behaviors()
	{
		return [
			'verbs' => [
				'class' => VerbFilter::className(),
		        'actions' => [
                    'institute-courses' => ['post'],
                    'teacher-courses' => ['post'],
                    'register-courses' => ['post'],
                    'get-student-by-nfc' => ['post'],
		        ]
			],
			'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' => true,
						'actions' => ['institute-courses','teacher-courses','register-courses','get-student-by-nfc'],
                        //'roles' => ['*'],
                    ],
                ],
            ],
			'contentNegotiator' => [
	            'class' => ContentNegotiator::className(),
	            'formats' => [
	                'application/json' => Response::FORMAT_JSON,
	            ],
	        ]
		];
    }
    
    public function actionInstituteCourses()
    {
        $request = Yii::$app->request;
        if ($request->isPost) 
        {
            $post = Json::decode($request->rawBody);
          
            $instituteid = $post['instituteid'];
            
            $courses = Course::find()->where(['Institute_id' => $instituteid])->all();

            return $courses;
            
        }
    }

    public function actionTeacherCourses()
    {
        $request = Yii::$app->request;
        if ($request->isPost) 
        {
            $post = Json::decode($request->rawBody);
          
            $instituteid = $post['instituteid'];
            $teacherid = $post['teacherid'];
            
            $courses = Course::find()->where(['Institute_id' => $instituteid,'Teacher_id' => $teacherid])->all();

            return $courses;
            
        }
    }

    public function actionRegisterCourses()
    {
        $request = Yii::$app->request;
        if ($request->isPost) 
        {
            $post = Json::decode($request->rawBody);
                     
            $studentid = $post['studentid'];
            $courseids = $post['courseids'];

            foreach($courseids as $course){

                $existingCR = Courseregistration::find()->where(['Course_id' => $course,'Student_id' => $studentid])->one();

                if(empty($existingCR)){
                    $cr = new Courseregistration;
                    $cr->paymentType = 1;
                    $cr->status = "1";
                    $cr->Course_id = $course;
                    $cr->Student_id = $studentid;
                    $cr->save();
                }
            }
           
            return [
                "Status"=>1,
                "Message" => "Successfully Registered",
            ];
        }
    }

    public function actionGetStudentByNfc(){

        $request = Yii::$app->request;
        if ($request->isPost) 
        {
            $post = Json::decode($request->rawBody);
            
            $card = Card::find()->where(['tid' => $post['Uid']])->one();
            $student  = $card->getStudent();
            return $student->one();
        }
    }
}