<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use backend\models\Vendor;
use backend\models\MainCategory;
use backend\models\MenuType;
use backend\models\PayTypes;
use backend\models\OrderOption;
use backend\models\OrderType;
use backend\models\Uom;
use backend\models\Product;
use backend\models\SubCategory;
use webvimark\modules\UserManagement\components\GhostHtml;
use webvimark\modules\UserManagement\UserManagementModule;
use webvimark\modules\UserManagement\models\User;
use yii\helpers\ArrayHelper;


/* @var $this yii\web\View */
/* @var $searchModel backend\models\MainCategorySearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Order';
$this->params['breadcrumbs'][] = $this->title;
$session = Yii::$app->session;
$vendordetails= Vendor:: find()->where(['database_name'=>$session->get('vendor_db_name')])->one()  
?>
<div class="order-index">
<div class="mt-bootstrap-tables">
        <div>
       
            <div class="portlet light ">

            <div class="row">


            <?php if(Yii::$app->user->isSuperadmin){?>
          
            <div class="portlet-body">

                <div class="col-md-6">

                    <div class="form-group field-selectUser required has-success">
                        <label class="control-label" for="selectUser">Organization Name</label>
                        <select id="organization_id" class="form-control" name="vendor_id_selected"
                            onchange="javascript:Getorganization(this.value)" aria-required="true" aria-invalid="false">

                            <!-- <option>Organization Vendor</option>    -->
                            <option value="3">Dialog</option>
                        </select>


                    </div>
                </div>

                <script>
                    // function Getorganization(e) {
                    //     console.log(e)

                        $.ajax({
                            url: '<?php echo Url::to(['/./product/getvendor']);?>',
                            type: 'post',
                            dataType: 'json',
                            data: {
                                "organization_id": 3
                            },
                            //type:JSON,
                            success: function (data) {
                                // alert(data);
                                console.log(data['0'].id);
                                for (var i = 0; i < data.length; i++) {
                                    $("#vendor_id").append("<option value='" + data[i].id + "'>" + data[i]
                                        .id + "</option>");
                                }
                            }
                        });

                    
                </script>


                <div class="col-md-6">

                    <div class="form-group field-selectUser required has-success">
                        <label class="control-label" for="selectUser">Vendor Name</label>
                        <select id="vendor_id" class="form-control" name="vendor_id_selected"
                            onchange="javascript:Getvendor(this.value)" aria-required="true" aria-invalid="false">

                            <option>Select Vendor</option>
                        </select>


                    </div>

                    <script>
                        function Getvendor(e) {
                            console.log(e)

                            $.ajax({
                                url: '<?php echo Url::to(['/./product/setsecessionindex']);?>',
                                type: 'post',
                                dataType: 'json',
                                data: {
                                    "vendor_id": e
                                },
                                //type:JSON,
                                success: function (data) {
                                    if (data == true) {
                                        console.log("datee");
                                        location.reload();


                                    } else {

                                    }

                                }
                            });

                        }
                    </script>
                </div>
            </div>

                    <?php }?>
        </div>
      
                <div class="portlet-title">


                
                
                    <div class="caption">
                        <i class="icon-social-dribbble font-dark hide"></i>
                        <span class="caption-subject font-dark bold uppercase"><?= Html::encode($this->title) ?></span>
                    </div>

                    

                 
                    
                   
                </div>

                 <div class="row">
                        <div class="col-md-4">
                           Selected Organization: <b><?php echo($vendordetails->organization->name)  ?>  </b>
                        </div>
                        <div class=" col-md-4">
                            Selected Vendor:<b><?php echo($vendordetails->name)  ?> </b>
                        </div>
                    </div>
                <div class="portlet-body">

                

                
                <div class="table table-scrollable">

                
     
                <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            [
                'attribute'=>'id',
                'value'=>'id',
                'contentOptions'=>['style'=>'width:50px;'],

                
               
            ],
            'refference_id',
            
            'number_of_items',
            'total_amount',
            // 'pay_type_id',
            [
                'attribute'=>'pay_type_id',
                'filter' => ArrayHelper::map(PayTypes::find()->asArray()->all(), 'id', 'name'),
                'value'=>'payType.name',

                'contentOptions'=>['style'=>'width:120px;'],

                
               
            ],
            'created_on',
           
            // 'order_type',
            [
                'attribute'=>'order_type',
                'filter' => ArrayHelper::map(OrderType::find()->asArray()->all(), 'id', 'name'),
                'value'=>'orderType.name',

                'contentOptions'=>['style'=>'width:120px;'],

                
               
            ],
            // 'order_option_id',

            [
                'attribute'=>'order_option_id',
                'filter' => ArrayHelper::map(OrderOption::find()->asArray()->all(), 'id', 'name'),
                'value'=>'orderOption.name',

                'contentOptions'=>['style'=>'width:120px;'],

                
               
            ],
            [
                'class'=>'webvimark\components\StatusColumn',
                'attribute'=>'status',
              
                
              
                'optionsArray'=>[
                    
 
 
                            [User::STATUS_ACTIVE, UserManagementModule::t('back', 'Paid'), 'success'],
                            [User::STATUS_INACTIVE, UserManagementModule::t('back', 'Pending'), 'warning'],
                            [User::STATUS_BANNED, UserManagementModule::t('back', 'Reject'), 'danger'],
                            [User::STATUS_FAILURE, UserManagementModule::t('back', 'Failure'), 'default'],
                        ],
               

                    ],
            // 'print_status',
            [
                'class'=>'webvimark\components\StatusColumn',
                'attribute'=>'print_status',
              
                
              
                'optionsArray'=>[
                    
 
 
                            [User::STATUS_ACTIVE, UserManagementModule::t('back', 'Token printed '), 'success'],
                            [User::STATUS_INACTIVE, UserManagementModule::t('back', 'Token not print'), 'warning'],
                           
                        ],
               

                    ],
            //'rating',

            ['class' => 'yii\grid\ActionColumn',
                            'contentOptions' => ['style' => 'width:50px;'],


                            'template' => '{view}  {delete} {link}',
                            'buttons' => [
                                   
                                    
                         
                                    
                            ],
                    
                        ],
        ],
    ]); ?>

                    </div>
                </div>
            </div>
        </div>
    </div>

</div>