<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use webvimark\modules\UserManagement\models\User;
use backend\models\Product;
use backend\models\Discount;
use backend\models\PayTypes;
use backend\models\PriceList;


/* @var $this yii\web\View */
/* @var $model backend\models\Order */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Orders', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
$createdBy=User::find()->where(['id'=>$model->created_by])->one();
?>
<div class="order-view">
<div class="portlet light ">


<div class="portlet-title">
            <p style="margin-top:8px;margin-bottom:8px;">
              
                <?= Html::a('Manage', ['index'], ['class' => 'btn btn-success']) ?>
                <?= Html::a('Delete', ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
            </p>
            <div class="caption">
                <i class="icon-social-dribbble font-dark hide"></i>
                <span class="caption-subject font-dark bold uppercase">overview</span>
            </div>
            <div class="caption pull-right">
                <i class="icon-social-dribbble font-dark hide"></i>
                <span class="caption-subject font-dark bold uppercase">Order Type: <?php echo($model->orderType->name)  ?></span>
            </div>

        </div>
        <div class="portlet-body">
            <div>


            
                     <div class="invoice">
                        <div class="row invoice-logo">
                            <div class="col-md-6 invoice-logo-space">
                                </div>
                            <div class="col-md-6" style="    text-align: end; font-size:18px">
                                <p> 
                                   
                                </p>
                            </div>
                        </div>
               
                        <div class="row">
                           
                 
                            <div class="col-md-6 invoice-payment">
                                <!-- <h4>Order Details:</h4>
                                <ul class="list-unstyled">
                                    <li>
                                        <strong>Number of Items : </strong>  <?php echo $model->number_of_items ?> </li>
                                    <li>
                                        <strong>Created By : </strong> <?php echo($createdBy->username)  ?> </li>
                                    <li> 
            <?php if($model->pay_type_id){?>

                                        <strong>Payment Method : </strong> <?php echo($model->payType->name)  ?>
            <?php }else{?>
                <strong>Payment Method : </strong> Cash
            <?php }?>
                                        
                                         </li>
                                
                                </ul> -->

                                <div class="col-md-12 col-sm-12">
                                                        <div class="portlet yellow-crusta box">
                                                            <div class="portlet-title">
                                                                <div class="caption">
                                                                    <i class="fa fa-cogs"></i>Order Details </div>
                                                              
                                                            </div>
                                                            <div class="portlet-body">
                                                                <div class="row static-info">
                                                                    <div class="col-md-5 name"> Order #: </div>
                                                                    <div class="col-md-7 value"> <?php echo($model->refference_id)  ?>
                                                                        <!-- <span class="label label-info label-sm"> Email confirmation was sent </span> -->
                                                                    </div>
                                                                </div>
                                                                <div class="row static-info">
                                                                    <div class="col-md-5 name"> Order Date &amp; Time: </div>
                                                                    <div class="col-md-7 value"> <?php echo($model->created_on)  ?></div>
                                                                </div>
                                                                <div class="row static-info">
                                                                    <div class="col-md-5 name"> Order Status: </div>
                                                                    <div class="col-md-7 value">
                                                  <?php if($model->status==1){?>

                                                                        <span class="label label-success"> Paid </span>
                                                      <?php }?>
                                                      <?php if($model->status==0){?>

                                                                        <span class="label label-warning"> pending </span>
                                                                        <?php }?>

                                                                        <?php if($model->status==2){?>

                                                            <span class="label label-default"> Failure </span>
                                                            <?php }?>
                                                            <?php if($model->status==-1){?>

                                                            <span class="label label-danger"> Reject </span>
                                                            <?php }?>

                                                                    </div>
                                                                </div>
                                                                <div class="row static-info">
                                                                    <div class="col-md-5 name"> Grand Total: </div>
                                                                    <div class="col-md-7 value"><?php echo($model->total_amount)  ?></div>
                                                                </div>
                                                                <div class="row static-info">
                                                                    <div class="col-md-5 name"> Payment Information: </div>
                                                                    <div class="col-md-7 value">   <?php if($model->pay_type_id){?>

                                                                    <?php echo($model->payType->name)  ?>
                                                                    <?php }else{?>
                                                                    Cash
                                                                    <?php }?> </div>
                                                                </div>
                                                                <div class="row static-info">
                                                                    <div class="col-md-5 name"> Order Type: </div>
                                                                    <div class="col-md-7 value"> 

                                                                    <?php echo($model->orderType->name)  ?>
                                                                     </div>
                                                                </div>
                                                                
                                                            </div>
                                                        </div>
                                                    </div>
                            </div>
                            <div class="col-md-6">
                            <div class="col-md-12 col-sm-12">
                                                        <div class="portlet blue-hoki box">
                                                            <div class="portlet-title">
                                                                <div class="caption">
                                                                    <i class="fa fa-cogs"></i>Customer Information </div>
                                                           
                                                            </div>
                                                            <div class="portlet-body">
                                                            <div class="row static-info">
                                                                    <div class="col-md-5 name"> Supplier: </div>
                                                                    <div class="col-md-7 value">   <?php echo($selectedVendor->name)  ?></div>
                                                                </div>
                                                                <div class="row static-info">
                                                                    <div class="col-md-5 name"> Customer Name: </div>
                                                                    <div class="col-md-7 value">  <?php echo($createdBy->username)  ?> </div>
                                                                </div>
                                                                <div class="row static-info">
                                                                    <div class="col-md-5 name"> Email: </div>
                                                                    <div class="col-md-7 value"> <?php echo($createdBy->email)  ?>  </div>
                                                                </div>
                                                                <div class="row static-info">
                                                                    <div class="col-md-5 name"> State: </div>
                                                                    <div class="col-md-7 value"> Colombo </div>
                                                                </div>
                                                                <div class="row static-info">
                                                                    <div class="col-md-5 name"> Phone Number: </div>
                                                                    <div class="col-md-7 value"> <?php echo($createdBy->mobile_number)  ?> </div>
                                                                </div>

                                                                <div class="row static-info">
                                                                    <div class="col-md-5 name"> Order Option: </div>
                                                                    <div class="col-md-7 value"> <?php echo($model->orderOption->name)  ?> </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                <!-- <h4>Supplier: <?php echo($selectedVendor->name)  ?> </h4>
                              
                                <h4>Created By : <?php echo($createdBy->username)  ?> </h4> -->
                               
                            </div>
                        </div>
                        <hr>
                        <div class="row">
                            <div class="col-xs-12">
                                <table class="table table-striped table-hover">
                                    <thead>
                                        <tr>
                                            <th style="text-align: end;"> # </th>
                                            <th style="text-align: end;"> Name </th>
                                            
                                            <th class="hidden-xs" style="text-align: end;"> Quantity </th>
                                            <th class="hidden-xs " style="text-align: end;"> Unit Cost(Rs) </th>
                                            <th class="hidden-xs" style="text-align: end;"> Dicount </th>
                                            <th style="    text-align: end;"> Amount(Rs) </th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                    <?php  
                                    $wihtoutDicountTotal=0;
                                    $allDiscoutAmount=0;
                                    $AmountOfodre=0;
                                    ?>
                                    <?php $count = 0; foreach ($selectedOrderItem as $selectedOrderItem): ?>
                                        <?php $count++; ?>
                                        <?php
																			$productModel=Product::find()->where(['id'=>$selectedOrderItem->product_id])->one();
																				$discountModel=Discount::find()->where(['product_id'=>$selectedOrderItem->product_id])->andWhere(['pay_type_id'=>$model->pay_type_id])->one();
																				$payTypestModel=PayTypes::find()->where(['id'=>$model->pay_type_id])->one();
																				$priceListModel=PriceList::find()->where(['product_id'=>$selectedOrderItem->product_id])->andWhere(['is_active'=>1])->one();

																					?>
                                        <tr>
                                            <td style="text-align: end;"> <?php echo($count) ?> </td>
                                            <td style="text-align: end;"> <?php echo($selectedOrderItem->product->name)  ?> </td>
                                        
                                        
                                            <td class="hidden-xs" style="text-align: end;"> <?php echo($selectedOrderItem->quantity)  ?>  </td>
                                            <td class="hidden-xs" style="text-align: end;"> <?php echo($selectedOrderItem->unit_price) ?> </td>
                                           
                                            <td  style="    text-align: end;"><?php echo($payTypestModel->discount) ?> %</td>
                                          


                                            <?php if($discountModel && $payTypestModel){?>
											

                                           
                                        

                                            <?php }?>

                                            <?php  
												$lastprice= $priceListModel->selling_price  * $selectedOrderItem->quantity;
												$uniqlastprice= $lastprice - ($lastprice*$model->discount/100)
						           ?>

<?php  
																						
																						
																						$wihtoutDicountTotal= $wihtoutDicountTotal+($priceListModel->selling_price* $selectedOrderItem->quantity); 

                            
												?>
											

                            
                                        





                                            <td style="text-align: end;"> <?php echo($uniqlastprice) ?> </td>
                                        </tr>
				<?php endforeach?>
                              
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    
                        <div class="row">

                        
                     
                            <div class="col-xs-12 invoice-block" style="    text-align: end;">
                                <ul class="list-unstyled amounts">
                                    <li>
                                        <strong>Sub - Total amount : </strong> <?php  echo(Yii::$app->formatter->asCurrency($model->full_amount))  ?> </li>
                                    <li>
                                        <strong>Discount amount : </strong><?php  echo(Yii::$app->formatter->asCurrency($model->full_amount - $model->total_amount))  ?> </li>

                                    <li>
                                        <strong>Total amount : </strong><?php  echo(Yii::$app->formatter->asCurrency($model->total_amount))  ?> </li>


                                        <?php if($model->pay_type_id == 2){?>

                                            <li style="    font-size: 20px;">
                                        <strong>Grand Total (round)  : </strong> <?php  echo(Yii::$app->formatter->asCurrency(round($model->total_amount)))  ?></li>


                                            <?php }else{?>

                                                <li style="    font-size: 20px;">
                                        <strong>Grand Total  : </strong> <?php  echo(Yii::$app->formatter->asCurrency($model->total_amount))  ?></li>

                                                <?php }?>

                                        
                                
                                  
                                </ul>
                                <br>
                                <!-- <a class="btn btn-lg blue hidden-print margin-bottom-5" onclick="javascript:window.print();"> Print
                                    <i class="fa fa-print"></i>
                                </a>
                                <a class="btn btn-lg green hidden-print margin-bottom-5"> Submit Your Invoice
                                    <i class="fa fa-check"></i>
                                </a> -->
                            </div>
                        </div>
                    </div>
               

              


            </div>
            <div class="tabbable-line tabbable-custom-profile" id="fdbk">
                <ul class="nav nav-tabs">
                    <li class="active">
                        <a href="#tab_1_11" data-toggle="tab"> Customer Feedback </a>
                    </li>
                    <li>
                        <a href="#tab_1_22" data-toggle="tab">  </a>
                    </li>
                </ul>
                <div class="tab-content">
                    <div class="tab-pane active" id="tab_1_11">
                        <div class="tab-pane active" id="tab_1_1_1">
                            <div class="portlet light">


                            <div class="mt-element-list">
                                        
                                        <div class="mt-list-container list-news">
                                            <ul>
                                            <?php  foreach ($orderFeedbackModel as $orderFeedbackModel): ?>
                                                <li class="mt-list-item">
                                                    <div class="list-icon-container">
                                                        <a href="javascript:;">
                                                            <i class="fa fa-angle-right"></i>
                                                        </a>
                                                    </div>
                                                    <div class="list-datetime bold uppercase font-green"> <?php echo($orderFeedbackModel->created_date) ?></div>
                                                    <div class="list-item-content">
                                                        <h3 class="uppercase">
                                                            <a href="javascript:;"> <?php echo($createdBy->username)  ?> </a>
                                                        </h3>
                                                        <p><?php echo($orderFeedbackModel->feedback) ?> </p>
                                                    </div>
                                                </li>
			                            	<?php endforeach?>
                                               
                                            </ul>
                                        </div>
                                    </div>
                               

                            </div>

                        </div>
                    </div>
                    <div class="tab-pane " id="tab_1_22">
                        <div class="portlet light">



                            <div class="portlet-body">
                                bbbbbbbbbbb
                            </div>

                        </div>


                        <div class="p_scents">
                            <div id='stack1' class='modal fade' style='width:4000px;'>
                                <div id='xxx' class='modal-header'>88</div>
                            </div>
                        </div>




                    </div>


                </div>



            </div>
        </div>


    </div>

</div>
</div>
