<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use yii\grid\GridView;
use yii\helpers\BaseUrl;
use yii\helpers\Url;
use backend\models\User;

/* @var $this yii\web\View */
/* @var $model backend\models\Organization */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => 'Organizations', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>

<style>
    .switch {
        position: relative;
        display: inline-block;
        width: 60px;
        height: 34px;
    }

    .switch input {
        opacity: 0;
        width: 0;
        height: 0;
    }

    .slider {
        position: absolute;
        cursor: pointer;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        background-color: #bf7c5c;
        -webkit-transition: .4s;
        transition: .4s;
        display: block;
        margin: 0px 0px;
        min-height: 34px;
    }

    /* .slider {
    border: 0;
    padding: 0;
   
} */

    .slider:before {
        position: absolute;
        content: "";
        height: 26px;
        width: 26px;
        left: 4px;
        bottom: 4px;
        background-color: white;
        -webkit-transition: .4s;
        transition: .4s;
    }

    input:checked+.slider {
        background-color: #50a21c;
    }

    input:focus+.slider {
        box-shadow: 0 0 1px #2196F3;
    }

    input:checked+.slider:before {
        -webkit-transform: translateX(26px);
        -ms-transform: translateX(26px);
        transform: translateX(26px);
    }

    /* Rounded sliders */
    .slider.round {
        border-radius: 34px;
    }

    .slider.round:before {
        border-radius: 50%;
    }
</style>
<div class="organization-view">
    <div class="portlet light ">
        <div class="portlet-title">
            <p style="margin-top:8px;margin-bottom:8px;">
                <?= Html::a('Update', ['update', 'id' => $model->id], ['class' => 'btn btn-success']) ?>
                <?= Html::a('Create', ['create'], ['class' => 'btn btn-success ']) ?>
                <?= Html::a('Manage', ['index'], ['class' => 'btn btn-success']) ?>
                <?= Html::a('Delete', ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
                <?php if($model->status == 1){?>


                <!-- <a class="btn btn-warning pull-right" onclick="shop_close(<?= Html::encode($model->id) ?>)" href="#">Shop Close</a> -->
                <div class="pull-right" style="    margin-top: -41px;">
                    <label class="switch">
                        <div style="    margin-left: -46px; margin-top: 8px;">
                            <b> Open </b>
                        </div>
                        <input type="checkbox" id="checkboxVendor" onclick="payMethodStatus(<?= Html::encode($model->id) ?>) "
                            checked>
                        <span class="slider round">

                        </span>
                    </label>

                </div>
                <?php }?>

                <?php if($model->status == 0){?>


                <!-- <a class="btn btn-success pull-right" onclick="shop_opne(<?= Html::encode($model->id) ?>)" href="#">Shop Open</a> -->
                <div class="pull-right" style="    margin-top: -41px;">
                    <label class="switch">
                        <div style="    margin-left: -50px;
    margin-top: 8px;">
                            <b> Closed </b>
                        </div>
                        <input type="checkbox" id="checkboxVendor" onclick="payMethodStatus(<?= Html::encode($model->id) ?>) ">
                        <span class="slider round">

                        </span>
                    </label>

                </div>
                <?php }?>


            </p>





            <div class="caption">
                <i class="icon-social-dribbble font-dark hide"></i>
                <span class="caption-subject font-dark bold uppercase">overview</span>
            </div>

        </div>
        <div class="portlet-body">
            <div class="row">
                <div class="col-md-2 price-table-pricing">
                    <ul class="list-unstyled profile-nav">
                        <li>
                            <a data-toggle="modal" data-target="">
                                <img src="/smart_pos/backend/image/<?= Html::encode($model->image_path)?>" alt="chinese"
                                    class="img-responsive animation"
                                    onerror="this.onerror=null; this.src='https://mamadips.com/wp-content/uploads/2016/11/defimage.gif'">
                            </a>
                        </li>
                    </ul>
                </div>
                <div class="col-md-6 profile-info">
                    <p class="uppercase bold">
                        <?= Html::encode($model->name) ?> </p>
                        <p class="uppercase bold">
                        Discount: <?= Html::encode($model->discount) ?> %</p>

                  


                </div>
                <!--end col-md-8-->
                <div class="col-md-4">
                    <div class="dashboard-stat2 bg-grey-gallery-opacity">
                        <div class="display">
                            <div class="number">
                                
                                <small class="status font-white">Today Order</small>
                            </div>
                            <div class="icon">
                                <i class="icon-map"></i>
                            </div>
                        </div>
                        <div class="progress-info">
                            <div class="progress">
                                <span style="width: 100%;" class="progress-bar progress-bar-success green-sharp">
                                    <span class="sr-only">100% progress</span>
                                </span>
                            </div>
                            <div class="status font-white">
                                <div class="status-title">
                                    <?= Html::encode($model->name) ?> </div>
                            </div>
                        </div>
                    </div>
                </div>

            </div>


        </div>
       
        <!-- END CONTENT BODY -->
    </div>

    <!-- END CONTENT -->
</div>
<script>


function readURL(input) {
                    if (input.files && input.files[0]) {
                        var reader = new FileReader();
                        reader.onload = function (e) {
                            $('#blah')
                                .attr('src', e.target.result)
                                .width(250);
                        };

                        reader.readAsDataURL(input.files[0]);
                    }
                }



                function shop_close(id){


        //             console.log(id)
        //             $.ajax({
		// 	url: '<?= Html::encode( Url::to(['/./vendor/shopclose']));?>',
		// 	type: 'post',
		// 	dataType: 'json',
		// 	data: {
		// 		"vendor_id": id,
		// 	},
		// 	//type:JSON,
		// 	success: function (data) {
			
		// 		location.reload();
		// 	}
		// });



                }


                function shop_opne(id){


                        console.log(id)
                        $.ajax({
                        url: '<?= Html::encode (Url::to(['/./vendor/shopopne']));?>',
                        type: 'post',
                        dataType: 'json',
                        data: {
                        "vendor_id": id,
                        },
                        //type:JSON,
                        success: function (data) {

                        location.reload();
                        }
                        });



                        }



function payMethodStatus(id) {
	console.log('#checkCategory'+id)

// var $loading = $('#waitbox').show();


      
            var checked = $('#checkboxVendor').is(':checked');
            if (checked) {

                
                console.log(id +"checked")
                $.ajax({
                url: '<?= Html::encode (Url::to(['/./pay-types/methodopne']));?>',
                type: 'post',
                dataType: 'json',
                data: {
                "method_id": id,
                },
                //type:JSON,
                success: function (data) {

                location.reload();
                }
                });

            } else {

                
                console.log(id+"unchecked")
                    $.ajax({
			url: '<?= Html::encode (Url::to(['/./pay-types/methodclose']));?>',
			type: 'post',
            dataType: 'json',

			data: {
				"method_id": id,
			},
			//type:JSON,
			success: function (data) {
			
				location.reload();
			}
		});



            }
}




</script>