<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use backend\models\MainCategory;
use backend\models\Product;
use backend\models\MenuType;
use backend\models\SubCategory;
use yii\helpers\Url;



/* @var $this yii\web\View */
/* @var $model backend\models\PriceList */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Price Lists', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);

$productModel=Product::find()->where(['id'=>$model->product_id])->one();
$mainCategory=MainCategory::find()->where(['id'=>$productModel->main_category_id])->one();
$modelMenuType=MenuType::find()->where(['id'=>$productModel->munu_type_id])->one();
$modelSubCategory=SubCategory::find()->where(['id'=>$productModel->sub_category_id])->one();
?>
<div class="price-list-view">
    <style>
        textarea {
            margin-top: 10px;
            margin-left: 13px;
            width: 541px;
            height: 100px;
            -moz-border-bottom-colors: none;
            -moz-border-left-colors: none;
            -moz-border-right-colors: none;
            -moz-border-top-colors: none;
            background: none repeat scroll 0 0 rgba(0, 0, 0, 0.07);
            border-color: -moz-use-text-color #FFFFFF #FFFFFF -moz-use-text-color;
            border-image: none;
            border-radius: 6px 6px 6px 6px;
            border-style: none solid solid none;
            border-width: medium 1px 1px medium;
            box-shadow: 0 1px 2px rgba(0, 0, 0, 0.12) inset;
            color: #555555;
            font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;
            font-size: 1em;
            line-height: 1.4em;
            padding: 5px 8px;
            transition: background-color 0.2s ease 0s;
        }


        textarea:focus {
            background: none repeat scroll 0 0 #FFFFFF;
            outline-width: 0;
        }
    </style>





    <div class="row">
        <div class="col-md-12">
            <!-- BEGIN PROFILE SIDEBAR -->
            <div class="profile-sidebar">
                <!-- PORTLET MAIN -->

                <!-- END PORTLET MAIN -->
            </div>
            <!-- END BEGIN PROFILE SIDEBAR -->
            <!-- BEGIN PROFILE CONTENT -->
            <div class="profile-content">
                <div class="row">
                    <div class="col-md-12">
                        <!-- BEGIN PORTLET -->
                        <div class="portlet light ">
                            <div class="portlet-title">
                                <div class="caption caption-md">
                                    <i class="icon-bar-chart theme-font hide"></i>

                                    <span
                                        class="caption-subject font-blue-madison bold uppercase"><?php echo($model->product->name) ?></span>
                                    <span class="caption-helper hide">weekly stats...</span>
                                </div>
                                <div class="actions">
                                    <div class="mt-action-buttons ">
                                        <div class="btn-group btn-group-circle">
                <?php if($modelPriceChangeNotice->status==-1){?>

                                            <span class="label  label-warning " style="font-size:20px"> Rejected </span>
                <?php }?>
                <?php if($modelPriceChangeNotice->status==1){?>

                    <span class="label  label-success " style="font-size:20px"> Approved </span>
                    <?php }?>


                                        </div>
                                    </div>

                                </div>
                            </div>

                            <div class="portlet-body">

                            <?php if($modelPriceChangeNotice->status == -1){?>
                                <div class="col-md-6 row number-stats margin-bottom-30">
                                    <div class="col-md-12 col-sm-6 col-xs-6 ">

                                        <div class="stat-left">
                                            <div class="stat-chart">
                                                <!-- do not line break "sparkline_bar" div. sparkline chart has an issue when the container div has line break -->

                                            </div>
                                            <div class="stat-number">
                                                <div class="title" style="font-size:18px"> Current selling price </div>
                                                <div class="number" style="font-size:30px;">
                                                    Rs.<?php echo($current_pricelist->selling_price)  ?> </div>
                                            </div>
                                        </div>
                                    </div>

                                </div>
                                <div class="col-md-6  row number-stats margin-bottom-30 ">
                                    <div class="col-md-12 col-sm-6 col-xs-6 ">
                                        <div class="stat-right">
                                            <div class="stat-chart">
                                                <!-- do not line break "sparkline_bar" div. sparkline chart has an issue when the container div has line break -->

                                            </div>
                                            <div class="stat-number">
                                                <div class="title" style="font-size:18px; color:#da3131"> Request
                                                    selling price </div>
                                                <div class="number" style="font-size:30px;">
                                                    Rs.<?php echo($model->selling_price)  ?> </div>
                                            </div>
                                        </div>
                                    </div>

                                </div>

                            <?php }?>

                            <?php if($modelPriceChangeNotice->status == 1){?>

                                <div class="col-md-6 row number-stats margin-bottom-30">
                                    <div class="col-md-12 col-sm-6 col-xs-6 ">

                                        <div class="stat-left">
                                            <div class="stat-chart">
                                                <!-- do not line break "sparkline_bar" div. sparkline chart has an issue when the container div has line break -->

                                            </div>
                                            <div class="stat-number">
                                                  <h3>  Price Have been Change </h3>
                                            </div>
                                        </div>
                                    </div>

                                </div>
                                <div class="col-md-6  row number-stats margin-bottom-30 ">
                                    <div class="col-md-12 col-sm-6 col-xs-6 ">
                                        <div class="stat-right">
                                            <div class="stat-chart">
                                                <!-- do not line break "sparkline_bar" div. sparkline chart has an issue when the container div has line break -->

                                            </div>
                                            <div class="stat-number">
                                                <div class="title" style="font-size:18px;"> Request
                                                    selling price </div>
                                                <div class="number" style="font-size:30px;">
                                                    Rs.<?php echo($model->selling_price)  ?> </div>
                                            </div>
                                        </div>
                                    </div>

                                </div>




                                <?php }?>

                                <div class="table-scrollable table-scrollable-borderless">
                                 
                                    <div class="tabbable-line tabbable-custom-profile" id="fdbk">
                                        <ul class="nav nav-tabs">
                                            <li class="active">
                                                <a href="#tab_1_11" data-toggle="tab"> Description </a>
                                            </li>
                                            <li>
                                                <a href="#tab_1_22" data-toggle="tab"> </a>
                                            </li>
                                        </ul>
                                        <div class="tab-content">
                                            <div class="tab-pane active" id="tab_1_11">
                                                <div class="tab-pane active" id="tab_1_1_1">
                                                    <div class="portlet light">


                                                        <div class="mt-element-list">
                                                            <?php echo($modelPriceChangeNotice->description) ?>
                                                        </div>


                                                    </div>

                                                </div>
                                            </div>
                                            <div class="tab-pane " id="tab_1_22">
                                                <div class="portlet light">



                                                    <div class="portlet-body">
                                                        bbbbbbbbbbb
                                                    </div>

                                                </div>


                                                <div class="p_scents">
                                                    <div id="stack1" class="modal fade" style="width:4000px;">
                                                        <div id="xxx" class="modal-header">88</div>
                                                    </div>
                                                </div>




                                            </div>


                                        </div>



                                    </div>
                                </div>
                            </div>
                        </div>
                        <!-- END PORTLET -->
                    </div>

                </div>


            </div>
            <!-- END PROFILE CONTENT -->
        </div>
    </div>

</div>


<div class="modal fade" id="reject" tabindex="-1" role="reject" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
                <h4 class="modal-title">Reason for reject</h4>
            </div>
            <div class="modal-body">

                <textarea placeholder="comment here " rows="20" name="comment[text]" id="comment_text_reject" cols="40"
                    class="ui-autocomplete-input" autocomplete="off" role="textbox" aria-autocomplete="list"
                    aria-haspopup="true"></textarea>



            </div>
            <div class="modal-footer">
                <button type="button" class="btn dark btn-outline" data-dismiss="modal">Close</button>
                <button type="button" onclick="changeReject(<?php echo($notif_id) ?>)" class="btn green">Ok</button>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

<div class="modal fade" id="appove" tabindex="-1" role="appove" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
                <h4 class="modal-title">Reason for Appove</h4>
            </div>
            <div class="modal-body">
                <!-- <form> -->

                <textarea placeholder="comment here " rows="20" name="comment[text]" id="comment_text_approve" cols="40"
                    class="ui-autocomplete-input" autocomplete="off" role="textbox" aria-autocomplete="list"
                    aria-haspopup="true"></textarea>



            </div>
            <div class="modal-footer">
                <button type="button" class="btn dark btn-outline" data-dismiss="modal">Close</button>
                <button type="button" onclick="changeApprove(<?php echo($notif_id) ?>)" class="btn green">Ok</button>
            </div>
            <!-- </form> -->

        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>