<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use yii\grid\GridView;
use yii\helpers\BaseUrl;
use yii\helpers\Url;
use kartik\rating\StarRating;
/* @var $this yii\web\View */
/* @var $model backend\models\Organization */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => 'Products', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);

?>



<div class="organization-view">
    <div class="portlet light ">
        <div class="portlet-title">
            <p style="margin-top:8px;margin-bottom:8px;">
                <?= Html::a('Update', ['update', 'id' => $model->id], ['class' => 'btn btn-success']) ?>
                <?= Html::a('Create', ['create'], ['class' => 'btn btn-success ']) ?>
                <?= Html::a('Manage', ['index'], ['class' => 'btn btn-success' ]) ?>
                <?= Html::a('Delete', ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    
                <!-- <a class="btn btn-success pull-right" data-toggle="modal" href="#responsive"> Request to change price </a> -->
                <a class="btn btn-success btn-outline sbold pull-right" data-toggle="modal" href="#basic"> Request to change price </a>
            </p>
            <div class="caption">
                <i class="icon-social-dribbble font-dark hide"></i>
                <span class="caption-subject font-dark bold uppercase">overview</span>
            </div>

        </div>
        <div class="portlet-body">

                          <div class="modal fade" id="basic" tabindex="-1" role="basic" aria-hidden="true">
                                        <div class="modal-dialog">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
                                                    <h4 class="modal-title">Change Product Price</h4>
                                                </div>
                                               <div class="col-md-12">
                                  
                                          
                                            
                                                <div class="row number-stats margin-bottom-30">
                                                    <div class="col-md-6 col-sm-6 col-xs-6">
                                                        <div class="stat-left">
                                                            <div class="stat-chart">
                                                                <!-- do not line break "sparkline_bar" div. sparkline chart has an issue when the container div has line break -->
                                                                <div id="sparkline_bar"><canvas width="90" height="45" style="display: inline-block; width: 90px; height: 45px; vertical-align: top;"></canvas></div>
                                                            </div>
                                                            <div class="stat-number">
                                                                <div class="title" style="font-size:15px"> Current selling price </div>
                                                                <div class="number">Rs.<?php echo($price->selling_price ) ?> </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="table-scrollable table-scrollable-borderless">

                                                
                                                <div class="" style="text-align: center;">
                                                        <h4>New Prices</h4>
                                                        <form class="form-inline" role="form">
                                                            <div class="form-group">
                                                            <div class="input-icon">
                                                            <i class="fa fa-envelope">Rs.</i>
                                                                        <input type="email" oninput="InputsellingFnn(event)" class="form-control" id="Inputselling_price" placeholder="Enter new selling price "> </div>
                                                              </div>
                                                            
                                                            
                                                        </form>
                                                        <hr>
                                                    
                                                    
                                                    
                                                    </div>
                                                </div>

                                                
                                            </div>
                                                
                                                <div class="modal-footer">
                                                    <button type="button" class="btn dark btn-outline" data-dismiss="modal">Close</button>
                                                    <button type="button" class="btn green" id="saveChanges"  onclick="priceChang()" disabled>Save changes</button>
                                                </div>
                                            </div>
                                            <!-- /.modal-content -->
                                        </div>
                                        <!-- /.modal-dialog -->
                                    </div>
                                    <script>

                                            function InputsellingFnn(event) {
                                                document.getElementById('saveChanges').disabled = false;
                                            }
                                            function InputbuyingFnn(event) {
                                                document.getElementById('saveChanges').disabled = false;
                                            }
                                    </script>

            <div class="row">
                <div class="col-md-8">
                    <img class="col-md-12" class="img-fluid"
                        src="<?php echo Yii::$app->getUrlManager()->getBaseUrl(); ?>/<?php echo($model->image_path) ?> "
                        alt="">
                </div>

                <div class="col-md-4">

                    <div>
                        <!-- BEGIN UNORDERED LISTS PORTLET-->
                        <div class="portlet">
                            <div class="portlet-title">
                                <div class="caption">
                                    
                                    <div class="col-md-9" >
                                    <h3> <i class="fa fa-gift"></i> <?php echo($model->name) ?>     </h3>
                                    </div>
                                    <div class="col-md-3" >



                                    <p style="font-size:14px"> 

                                    <?php if($model->status == 1){?>
                                        
                                        <span style="font-size:85%; background-color: #45b122;" class="label label-info" > Available </span>
                                        <?php }?>  

                                    <?php if($model->status == 0){?>
                                        <span style="font-size:85%;" class="label label-warning"> Unavailable </span>
                                        

                                            <?php } ?>  


<!--                                  -->
                                    </div>
                                </div>

                            </div>
                            <div class="mt-element-ribbon bg-grey-steel">
                                <div class="ribbon ribbon-border-hor ribbon-clip ribbon-color-danger uppercase">
                                    <div class="ribbon-sub ribbon-clip"></div> Price Of The
                                    <?php echo($model->mainCategory->name) ?>
                                </div>
                                <?php echo (!empty($price))  ? "<h2 style='text-align : center' class='ribbon-content'> Rs . $price->selling_price </h2>" : "<h2 style='text-align : center' class='ribbon-content'> No Price List</h2>" ?>

                                <!--  -->
                            </div>

                            <div class="portlet-body">
                                <ul>
                                    <li> Available Quantity : <?php echo($model->available_quantity) ?> </li>
                                    <li> Uom ID : <?php echo($model->mainCategory->name) ?> </li>

                                    <li> Master Details
                                        <ul>
                                            <li> Main Category : <?php echo($model->mainCategory->name) ?> </li>
                                            <li> Sub Category : <?php echo($model->subCategory->name) ?> </li>
                                        </ul>
                                    </li>
                                    <br>

                                </ul>
                            </div>
                            <div>
                                <?php  
                                            echo StarRating::widget([
                                                'name' => 'rating_1',
                                                'pluginOptions' => [
                                                    'stars' => 6, 
                                                    'min' => 0,
                                                    'max' => 6,
                                                    'step' => 0.1,
                                                    'filledStar' => '<i class="glyphicon glyphicon-heart"></i>',
                                                    'emptyStar' => '<i class="glyphicon glyphicon-heart-empty"></i>',
                                                    'defaultCaption' => '{rating} hearts',
                                                    'displayOnly' => true,
                                                    'size'=>'sm'
                                                    
                                                ],
                                                'value' => 2.8,
                                                'disabled' => true
                                            ]);
                                            
                                            ?>
                            </div>
                            <br />

                            <?php echo ($model->status == 1)  ? "<div id='btn_deactivate' class='profile-userbuttons'>
                                            <button  onclick='deactivate_product($model->id)' type='button' class='btn btn-circle red btn-sm'> Unavailable</button>
                                          </div>" : 
                                          "<div id='btn_activate' class='profile-userbuttons'>
                                        <button  onclick='activate_product($model->id)' type='button' class='btn btn-circle green-haze'>Available</button>
                                           </div>" ?>

                        </div>
                        <!-- END UNORDERED LISTS PORTLET-->

                    </div>



                </div>



            </div>
            <div class="tabbable-line tabbable-custom-profile">
                <ul class="nav nav-tabs">
                    <li class="active">
                        <a href="#tab_1_11" data-toggle="tab"> Price List </a>
                    </li>
                    <li>
                        <a href="#tab_1_22" data-toggle="tab">  </a>
                    </li>
                </ul>
                <div class="tab-content">
                    <div class="tab-pane active" id="tab_1_11">
                        <div class="tab-pane active" id="tab_1_1_1">
                            <div class="portlet light">
                               

                                    
                                            <div class="table-scrollable">
                                                <table class="table table-bordered table-hover">
                                                    <thead>
                                                        <tr>
                                                            <th> # </th>
                                                            <th> Created Date</th>
                                                            <th> Updated Date </th>
                                                            <th> Selling Price </th>
                                                            
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                    <?php foreach ($all_price as $all_price): ?>  

                                    <?php if($all_price['is_active']=='0'){?>

                                        <tr class="danger">
                                                            <td> 1 </td>
                                                            <td> <?php echo($all_price['created_date']) ?> </td>
                                                            <td> <?php echo($all_price['updated_date']) ?></td>
                                                            <td> <?php echo($all_price['selling_price']) ?></td>
                                                           
                                                        </tr>
                                        <?php }else{ ?>  
                                            <tr class="active">
                                                            <td> 1 </td>
                                                            <td> <?php echo($all_price['created_date']) ?> </td>
                                                            <td> <?php echo($all_price['updated_date']) ?></td>
                                                            <td> <?php echo($all_price['selling_price']) ?></td>
                                                           
                                                        </tr>
                                        
                                          <?php } ?>


                                                        
                                 <?php endforeach?>
                                                       
                                                    </tbody>
                                                </table>
                                            </div>
                            </div>

                        </div>
                    </div>
                    <div class="tab-pane " id="tab_1_22">
                        <div class="portlet light">



                            <div class="portlet-body">
                                bbbbbbbbbbb
                            </div>

                        </div>


                        <div class="p_scents">
                            <div id='stack1' class='modal fade' style='width:4000px;'>
                                <div id='xxx' class='modal-header'>88</div>
                            </div>
                        </div>




                    </div>


                </div>



            </div>
        </div>


    </div>

    

    <!-- END CONTENT BODY -->
</div>

<!-- END CONTENT -->
</div>


<script>

function deactivate_product(id){
    $.ajax({
				url: '<?php echo Url::to(['product/deactivate']); ?>',
				type: 'post',
				data: {'id':id},
				success: function(data) {
					setTimeout(function() {
                        $.bootstrapGrowl("Successfully Deactivated", { type: 'danger' });
                    }, 1000);
                    window.location.reload(1);
				}
			
			});
}

function activate_product(id){
    $.ajax({
            url: '<?php echo Url::to(['product/activate']); ?>',
            type: 'post',
            data: {'id':id},
            success: function(data) {
                setTimeout(function() {
                    $.bootstrapGrowl("Successfully Activated", { type: 'success' });
                }, 1000);
                window.location.reload(1);
            }
        
        });
}

function priceChang(){
    document.getElementById('saveChanges').disabled = true ;

    $.ajax({
            url: '<?php echo Url::to(['product/pricechange']); ?>',
            type: 'post',
            data: {'product_id':<?php echo($model->id) ?>,
                   'selling_price': document.getElementById("Inputselling_price").value,
                    'buying_price': ''
            
            },
            success: function(data) {
                
                location.reload();
            }
        
        });

}

</script>