<?php

use yii\helpers\Html;
use yii\grid\GridView;
use kartik\datetime\DateTimePicker;
use kartik\date\DatePicker;
use backend\models\Vendor;
use backend\models\PayTypes;
use yii\bootstrap\ActiveForm;
use yii\helpers\Url;



/* @var $this yii\web\View */
/* @var $searchModel backend\models\OrganizationSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Sales Report';
$this->params['breadcrumbs'][] = $this->title;

$session = Yii::$app->session;            


if($session->get('vendor_db_name')){
    $db_name =  $session->get('vendor_db_name');
    $modelVendor=Vendor::find()->where(['database_name'=>$db_name])->one();
}


?>
<div class="warehouse-index">
<style>
.form-horizontal .form-group {
    margin-left: 0px;
    margin-right: 0px;
}
</style>


    <div class="portlet light ">
        <div class="portlet-title">
            <div class="caption ">
                <i class="icon-settings"></i>
                <span class="caption-subject bold uppercase">
                    Sales Report <?php if(!Yii::$app->user->isSuperadmin){?> 

                    (<?php echo($modelVendor->name)  ?>)
                    <?php }?>
                    
                    
                    </span>
            </div>
            <div class="actions">
                <div class="btn-group">
                    <a class="btn blue btn-outline btn-circle btn-sm" href="javascript:;" data-toggle="dropdown"
                        data-hover="dropdown" data-close-others="true" aria-expanded="false"> Export
                        <i class="fa fa-angle-down"></i>
                    </a>
                    <ul class="dropdown-menu pull-right" style="    min-width: 80px;">

                        <li>

                            <a href="/AssetsTracking/web/index.php/asset/visit/site_wise_visit_pdf" target="_blank"> Pdf
                            </a>
                        </li>


                    </ul>
                </div>
            </div>
        </div>
        <div class="portlet-body" style="    margin-top: 30px;">
            <form role="form" action="moving-food" method="post" class="form-horizontal">

                <div class="form-actions">
                    <div class="row ">

                    <div class="col-md-11">
                    <!-- <input type="checkbox" id="checkboxVendor_1"  name="vehicle1" value="Bike" onclick="orderType(1) "> Take Away /
                    <input type="checkbox" id="checkboxVendor_2"  name="vehicle1" value="Bike" onclick="orderType(2) ">  Dine In -->
                    <!-- <input type="checkbox" name="vehicle1" value="Bike"> Dine In -->

                    </div>

                        <div class="col-md-1 pull-right">
                            <input type="submit" name="submit" value="Search " class="btn btn-success">
                        </div>


                    </div>
                </div>

                <br>
                <div class="row">
                    <?php $form = ActiveForm::begin(); ?>

                    <div class="col-md-3">
                        <label>Start Date/Time <span style="color:red">*</span></label>
                        <?php  echo DatePicker::widget([
                            'name' => 'start_date',
                            // 'value'=>$start_day,
                            'convertFormat' => true,
                            
                            
                            'options' => ['placeholder' => 'Select Start date ...'],
                            'pluginOptions' => [
                                'autoclose'=>true,

                                'format' => 'yyyy-MM-dd',
                                
                            ]
                        ]);?>
                    </div>

                    <div class="col-md-3">
                        <label>End Date/Time<span style="color:red">*</span></label>
                        <?php echo DatePicker::widget([
                                'name' => 'end_date',
                                // 'value'=>$end_day,
                                'options' => ['placeholder' => 'Select End date ...'],
                                'convertFormat' => true,
                                'pluginOptions' => [
                                    'autoclose'=>true,
                                    'format' => 'yyyy-MM-dd',
                                ]
                            ]); ?>
                    </div>
                
                </div>

                <?php ActiveForm::end(); ?>

                <br>



            </form>
        </div>
        <div class="portlet-body flip-scroll">





            <div class="">
                <table style=" margin-left: 1px;"
                    class="table tableCompany_View-striped table-bordered table-advance table-hover">
                    <thead>
                        <tr>
                            <th scope="col" style="min-width:140px !important"><b>Refference ID</b> </th>
                            <th scope="col" style="min-width:140px !important"><b>Number Of Items</b> </th>
                            <th scope="col" style="min-width:105px !important"><b>Total Amount</b> </th>
                            <th scope="col" style="min-width:105px !important"><b>Created On</b> </th>
                            <!-- <th scope="col" style="min-width:105px !important"><b>Created By</b> </th> -->
                            <th scope="col" style="min-width:105px !important"><b>Pay Type</b> </th>
                            <th scope="col" style="min-width:105px !important"><b>Order Type</b> </th>
                            <th scope="col" style="min-width:105px !important"><b>Order Option</b> </th>
                            <th scope="col" style="min-width:105px !important"><b>Full Amount</b> </th>

                        </tr>
                    </thead>
                    <tbody id="tbody" class="table table-scrollable">
                    <?php if(isset($allOrder)){?>

                    <?php foreach ($allOrder as $allOrder): ?>  

                        <tr>
                            <td>
                            <?php echo($allOrder['AllDate']['refference_id'])?>
                            </td>
                          
                            <td>
                            <?php echo($allOrder['AllDate']['number_of_items'])?>
                            
                            </td>
                            <td>
                            <?php echo($allOrder['AllDate']['total_amount'])?>
                            
                            </td>
                            <td>
                            <?php echo($allOrder['AllDate']['created_on'])?>
                            
                            </td>
                           
                            <td>
                            <?php echo($allOrder['PayTypes'])?>
                            
                            </td>
                            <td>
                            <?php echo($allOrder['OrderType'])?>
                            
                            </td>
                            <td>
                            <?php echo($allOrder['OrderOption'])?>
                            
                            </td>
                            <td>
                            <?php echo($allOrder['AllDate']['full_amount'])?>
                            
                            </td>



                        </tr>

                        <?php endforeach?>

                    <?php }?>






                    </tbody>

                </table>
                <?php if(! isset($allOrder)){?>
               
                <div class="alert alert-warning"
                    style="display: block; margin-top: 20px; margin-right: 50px; margin-left: 50px; text-align: center;"
                    id="WarningAlert">
                    <strong>Warning!!</strong> <a class="alert-link">No Record Found</a>.</div>
            </div>
           
                <?php }?>
               

        </div>

    </div>




</div>
<script>
function orderType(id){
    console.log(id);

    var checked = $('#checkboxVendor_'+id).is(':checked');
            if (checked) {

    console.log("checked");
    console.log(id)
                $.ajax({
                url: '<?php echo Url::to(['/./site/set-order-type']);?>',
                type: 'post',
                dataType: 'json',
                data: {
                "type_id": id,
                },
                //type:JSON,
                success: function (data) {

                location.reload();
                }
                });
                
                

            } else {

                
    console.log("Unchecked");
            



            }
}





</script>