<?php

use yii\helpers\Html;
use yii\grid\GridView;
use kartik\datetime\DateTimePicker;
use kartik\date\DatePicker;
use backend\models\Vendor;
use backend\models\PayTypes;
use yii\bootstrap\ActiveForm;
use yii\helpers\Url;



/* @var $this yii\web\View */
/* @var $searchModel backend\models\OrganizationSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Sales Report';
$this->params['breadcrumbs'][] = $this->title;

$all_total_amount=0;
$all_full_amount=0;
$card_total_amount=0;
$card_full_amount=0;
$geine_total_amount=0;
$geine_full_amount=0;
$ezcash_total_amount=0;
$ezcash_full_amount=0;
$cash_total_amount=0;
$cash_full_amount=0;

$session = Yii::$app->session;            


if($session->get('vendor_db_name')){
    $db_name =  $session->get('vendor_db_name');
    $modelVendor=Vendor::find()->where(['database_name'=>$db_name])->one();
}


?>
<div class="warehouse-index">
<style>
.form-horizontal .form-group {
    margin-left: 0px;
    margin-right: 0px;
}
</style>


    <div class="portlet light ">
        <div class="portlet-title">
            <div class="caption ">
                <i class="icon-settings"></i>
                <span class="caption-subject bold uppercase">
                    Sales Report <?php if(!Yii::$app->user->isSuperadmin){?> 

                    (<?php echo($modelVendor->name)  ?>)
                    <?php }?>
                    
                    
                    </span>
            </div>
            <div class="actions">
                <div class="btn-group">
                    <a class="btn blue btn-outline btn-circle btn-sm" href="javascript:;" data-toggle="dropdown"
                        data-hover="dropdown" data-close-others="true" aria-expanded="false"> Export
                        <i class="fa fa-angle-down"></i>
                    </a>
                    <ul class="dropdown-menu pull-right" style="    min-width: 80px;">

                        <li>
                        <?php if(Yii::$app->user->isSuperadmin){?>

                            <a onclick="excelDowNoVendor()" > Excel
                            </a>
                            <?php }else{ ?>
                                <a onclick="excelDow()" > Excel
                            </a>
                            <?php } ?>
                        </li>


                    </ul>
                </div>
            </div>
        </div>
        <div class="portlet-body" style="    margin-top: 30px;">
            <form role="form" action="sales-report" method="post" class="form-horizontal">

                <div class="form-actions">
                    <div class="row ">

                    <div class="col-md-11">
                    <!-- <input type="checkbox" id="checkboxVendor_1"  name="vehicle1" value="Bike" onclick="orderType(1) "> Take Away /
                    <input type="checkbox" id="checkboxVendor_2"  name="vehicle1" value="Bike" onclick="orderType(2) ">  Dine In -->
                    <!-- <input type="checkbox" name="vehicle1" value="Bike"> Dine In -->

                    </div>

                        <div class="col-md-1 pull-right">
                            <input type="submit" name="submit" value="Search " class="btn btn-success">
                        </div>


                    </div>
                </div>

                <br>
                <div class="row">
                    <?php $form = ActiveForm::begin(); ?>

                    <div class="col-md-3">
                        <label>Start Date/Time <span style="color:red">*</span></label>
                        <?php  echo DatePicker::widget([
                            'name' => 'start_date',
                            'id'=>'start_date',
                            'value'=>$start_day,
                            'convertFormat' => true,
                            
                            
                            'options' => ['placeholder' => 'Select Start date ...'],
                            'pluginOptions' => [
                                'autoclose'=>true,

                                'format' => 'yyyy-MM-dd',
                                
                            ]
                        ]);?>
                    </div>

                    <div class="col-md-3">
                        <label>End Date/Time<span style="color:red">*</span></label>
                        <?php echo DatePicker::widget([
                                'name' => 'end_date',
                                'id'=>'end_date',
                                'value'=>$end_day,
                                'options' => ['placeholder' => 'Select End date ...'],
                                'convertFormat' => true,
                                'pluginOptions' => [
                                    'autoclose'=>true,
                                    'format' => 'yyyy-MM-dd',
                                ]
                            ]); ?>
                    </div>
                    <?php if(Yii::$app->user->isSuperadmin){?>

                    <div class="col-md-3">
                        <label >Select Vendor</label>
                        <?= $form->field($model, 'id')->dropDownList(Vendor::getList(), ['id' => 'selectUser','style' => 'padding: inherit;','value'=>$vendor_id])->label(false)  ?>
                    </div>

                    <?php } ?>

                    <div class="col-md-3">
                        <label >Select Paymethod</label>
                        <?= $form->field($modelPayTypes2, 'id')->dropDownList(PayTypes::getList(), ['id' => 'selectUser2','value'=>$paymethod_id])->label(false)  ?>
                    </div>
                </div>

                <?php ActiveForm::end(); ?>

                <br>



            </form>
        </div>
        <div class="portlet-body flip-scroll">





            <div class="">
                <table style=" margin-left: 1px;"
                    class="table tableCompany_View-striped table-bordered table-advance table-hover">
                    <thead>
                        <tr>
                            <th scope="col" style="min-width:140px !important"><b>Refference ID</b> </th>
                            <th scope="col" style="min-width:140px !important"><b>Number Of Items</b> </th>
                            <th scope="col" style="min-width:105px !important"><b>Total Amount</b> </th>
                            <th scope="col" style="min-width:105px !important"><b>Created On</b> </th>
                            <!-- <th scope="col" style="min-width:105px !important"><b>Created By</b> </th> -->
                            <th scope="col" style="min-width:105px !important"><b>Pay Type</b> </th>
                            <th scope="col" style="min-width:105px !important"><b>Order Type</b> </th>
                            <th scope="col" style="min-width:105px !important"><b>Order Option</b> </th>
                            <th scope="col" style="min-width:105px !important"><b>Full Amount</b> </th>

                        </tr>
                    </thead>
                    <tbody id="tbody" class="table table-scrollable">
                    <?php if(isset($allOrder)){?>

                    <?php foreach ($allOrder as $allOrder): ?>  
                    <?php 
                    $all_total_amount=$all_total_amount+$allOrder['AllDate']['total_amount'];
                    $all_full_amount=$all_full_amount+$allOrder['AllDate']['full_amount'];


                    if($allOrder['PayTypes_id']==1){


                        $ezcash_total_amount=$ezcash_total_amount+$allOrder['AllDate']['total_amount'];
                         $ezcash_full_amount=$ezcash_full_amount+$allOrder['AllDate']['full_amount'];
                        

                    }


                    ?>


                        <tr>
                            <td>
                            <?php echo($allOrder['AllDate']['refference_id'])?>
                            </td>
                          
                            <td>
                            <?php echo($allOrder['AllDate']['number_of_items'])?>
                            
                            </td>
                            <td>
                            <?php echo($allOrder['AllDate']['total_amount'])?>
                            
                            </td>
                            <td>
                            <?php echo($allOrder['AllDate']['created_on'])?>
                            
                            </td>
                           
                            <td>
                            <?php echo($allOrder['PayTypes'])?>
                            
                            </td>
                            <td>
                            <?php echo($allOrder['OrderType'])?>
                            
                            </td>
                            <td>
                            <?php echo($allOrder['OrderOption'])?>
                            
                            </td>
                            <td>
                            <?php echo($allOrder['AllDate']['full_amount'])?>
                            
                            </td>



                        </tr>

                        <?php endforeach?>



               
                  




                        <?php }?>

                    </tbody>

                </table>

               
                <?php if(! isset($allOrder)){?>

                
               
                <div class="alert alert-warning"
                    style="display: block; margin-top: 20px; margin-right: 50px; margin-left: 50px; text-align: center;"
                    id="WarningAlert">
                    <strong>Warning!!</strong> <a class="alert-link">No Record Found</a>.</div>
            </div >
           
                <?php }?>

                
                <div > 
               
               <h4> All full Amount : Rs.<?php echo($all_full_amount) ?></h4>
               <h4> Full Discount : Rs.<?php echo($all_full_amount-$all_total_amount) ?></h4>
               <h4> Total Amount : Rs.<?php echo($all_total_amount) ?></h4>
               </div>

               
        </div>

    </div>




</div>
<script>

function excelDow(){

    var end_date = document.getElementById("end_date").value;
    var start_date = document.getElementById("start_date").value;
    // var vendor = document.getElementById("selectUser").value;
    var paymentMethod = document.getElementById("selectUser2").value;

                // var type = 1;
 var url = 'sales-report-exl';
    gotoUrl(url, {'end_date':end_date,'start_date':start_date,'paymentMethod':paymentMethod,});


}
function excelDowNoVendor(){

var end_date = document.getElementById("end_date").value;
var start_date = document.getElementById("start_date").value;
var vendor = document.getElementById("selectUser").value;
var paymentMethod = document.getElementById("selectUser2").value;

            // var type = 1;
var url = 'sales-report-exl';
gotoUrl(url, {'end_date':end_date,'start_date':start_date,'vendor':vendor,'paymentMethod':paymentMethod,});


}
function orderType(id){
    console.log(id);

    var checked = $('#checkboxVendor_'+id).is(':checked');
            if (checked) {

    console.log("checked");
    console.log(id)
                $.ajax({
                url: '<?php echo Url::to(['/./site/set-order-type']);?>',
                type: 'post',
                dataType: 'json',
                data: {
                "type_id": id,
                },
                //type:JSON,
                success: function (data) {

                location.reload();
                }
                });
                
                

            } else {

                
    console.log("Unchecked");
            



            }
}

function gotoUrl(path, params, method) {
        //Null check
        method = method || "post"; // Set method to post by default if not specified.

        var form = document.createElement("form");
        form.setAttribute("method", method);
        form.setAttribute("action", path);

        //Fill the hidden form
        if (typeof params === 'string') {
            var hiddenField = document.createElement("input");
            hiddenField.setAttribute("type", "hidden");
            hiddenField.setAttribute("name", 'data');
            hiddenField.setAttribute("value", params);
            form.appendChild(hiddenField);
        } else {
            for (var key in params) {
                if (params.hasOwnProperty(key)) {
                    var hiddenField = document.createElement("input");
                    hiddenField.setAttribute("type", "hidden");
                    hiddenField.setAttribute("name", key);
                    if (typeof params[key] === 'object') {
                        hiddenField.setAttribute("value", JSON.stringify(params[key]));
                    } else {
                        hiddenField.setAttribute("value", params[key]);
                    }
                    form.appendChild(hiddenField);
                }
            }
        }
        form.target = '_blank';
        document.body.appendChild(form);
        form.submit();
        return false;
    }



</script>