<?php
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Style\Border;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use PhpOffice\PhpSpreadsheet\Style\Fill;
use backend\models\Vendor;
use backend\models\PayTypes;
 $spreadsheet = new Spreadsheet();
        $sheet = $spreadsheet->getActiveSheet();
        $styleArrayTitle = array(
            'font'  => array(
                'bold'  => true,
                'color' => array('rgb' => '4040C4'),
                'size'  => 15,
                'name'  => 'Verdana'
            ));


            $styleArrayBorder = array(
                'borders' => array(
                    'allBorders' => [
                        'borderStyle' => Border::BORDER_THIN,
                        'color' => ['rgb' => '000000'],
                    ],
                ),
            );

          
        $sheet->setCellValue('C2', 'Dialog Smart Cafe  Sales Report');

        $sheet->setCellValue('A4', 'Start Date:'.$start_day);
        $sheet->setCellValue('C4', 'End Date:'.$end_day);

        if(isset($vendor_id) && !empty($vendor_id) ){
            $modelVendor=Vendor::find()->where(['id'=>$vendor_id])->one();
            $sheet->setCellValue('E4', 'Vendor:'.$modelVendor->name);
        }
        if(isset($paymethod_id) && !empty($paymethod_id)){
            $modePay=PayTypes::find()->where(['id'=>$paymethod_id])->one();
            $sheet->setCellValue('G4', 'Paymethod:'.$modePay->name);
        }

        $sheet->setCellValue('A6', 'Refference ID') ;
        $sheet->setCellValue('B6', 'No Of Items');
        $sheet->setCellValue('C6', 'Total Amount');
        $sheet->setCellValue('D6', 'Created On');
        $sheet->setCellValue('E6', 'Pay Type');
        $sheet->setCellValue('F6', 'Order Type');
        $sheet->setCellValue('G6', 'Order Option');
        $sheet->setCellValue('H6', 'Full Amount');
        // $sheet->setCellValue('C4',$start_day);
        $sheet->getColumnDimension('A')->setWidth(18);       
        $sheet->getColumnDimension('B')->setWidth(12);       
        $sheet->getColumnDimension('C')->setWidth(13);       
        $sheet->getColumnDimension('D')->setWidth(20);       
        $sheet->getColumnDimension('E')->setWidth(13);       
        $sheet->getColumnDimension('F')->setWidth(15);       
        $sheet->getColumnDimension('G')->setWidth(15);       
        $sheet->getColumnDimension('H')->setWidth(13);    
        
        $count=7;
        $all_total_amount=0;
        $all_full_amount=0;
        $card_total_amount=0;
        $card_full_amount=0;
        $geine_total_amount=0;
        $geine_full_amount=0;
        $ezcash_total_amount=0;
        $ezcash_full_amount=0;
        $cash_total_amount=0;
        $cash_full_amount=0;
        foreach ($allOrder as $allOrder){

                    $all_total_amount=$all_total_amount+$allOrder['AllDate']['total_amount'];
                    $all_full_amount=$all_full_amount+$allOrder['AllDate']['full_amount'];



                    if($allOrder['PayTypes_id']==1){


                        $ezcash_total_amount=$ezcash_total_amount+$allOrder['AllDate']['total_amount'];
                         $ezcash_full_amount=$ezcash_full_amount+$allOrder['AllDate']['full_amount'];
                        

                    }
                    if($allOrder['PayTypes_id']==2){
                    
                    
                


                        $geine_total_amount=$geine_total_amount+$allOrder['AllDate']['total_amount'];
                         $geine_full_amount=$geine_full_amount+$allOrder['AllDate']['full_amount'];
                        

                    }
                    if($allOrder['PayTypes_id']==3){

       
                        $cash_total_amount=$cash_total_amount+$allOrder['AllDate']['total_amount'];
                         $cash_full_amount=$cash_full_amount+$allOrder['AllDate']['full_amount'];
                        

                    }
                    if($allOrder['PayTypes_id']==4){


                        $card_total_amount=$card_total_amount+$allOrder['AllDate']['total_amount'];
                         $card_full_amount=$card_full_amount+$allOrder['AllDate']['full_amount'];
                        

                    }
            
            $sheet->setCellValue('A'.$count, $allOrder['AllDate']['refference_id']) ;
            $sheet->setCellValue('B'.$count, $allOrder['AllDate']['number_of_items']);
            $sheet->setCellValue('C'.$count, $allOrder['AllDate']['total_amount']);
            $sheet->setCellValue('D'.$count, $allOrder['AllDate']['created_on']);
            $sheet->setCellValue('E'.$count, $allOrder['PayTypes']);
            $sheet->setCellValue('F'.$count, $allOrder['OrderType']);
            $sheet->setCellValue('G'.$count, $allOrder['OrderOption']);
            $sheet->setCellValue('H'.$count, $allOrder['AllDate']['full_amount']);
            ++$count;
        }

        // $sheet->setCellValue('G6', 'Order Option');
        $sheet->setCellValue('H'.$count, $all_full_amount);
        $sheet->setCellValue('C'.$count, $all_total_amount);

        $sheet->getStyle('A6:H'.$count)->applyFromArray($styleArrayBorder);
        $sheet->setCellValue('A'.$count+=2, "All full Amount");
        $sheet->setCellValue('B'.$count, 'Rs. '. $all_full_amount);

        $sheet->setCellValue('A'.++$count, "Total Amount");
        $sheet->setCellValue('B'.$count, 'Rs. '. $all_total_amount);


        $sheet->setCellValue('A'.++$count, "Full Discount");
        $sheet->setCellValue('B'.$count,'Rs. '. ($all_full_amount-$all_total_amount));


        // $sheet->setCellValue('C4',$start_day);
        // $sheet->setCellValue('G4', $end_day);
     

       
      
        $sheet->getStyle('C2')->applyFromArray($styleArrayTitle);
        // $writer = new Xlsx($spreadsheet);
        // $writer->save('hello world.xlsx');
        
        $filename = "FARE COLLECTION POS WISE DETAILED REPORT". date("Y-m-d-H-i-s").".xlsx";
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename='.$filename);
        header('Cache-Control: max-age=0');
        $writer = new Xlsx($spreadsheet);
        $writer->save('php://output');
        exit; 