<?php
return [
    'aliases' => [
        '@bower' => '@vendor/bower-asset',
        '@npm'   => '@vendor/npm-asset',
    ],
    'vendorPath' => dirname(dirname(__DIR__)) . '/vendor',
    'components' => [
        'user' => [
            'class' => 'webvimark\modules\UserManagement\components\UserConfig',
    
            // Comment this if you don't want to record user logins
            'on afterLogin' => function($event) {
                    \webvimark\modules\UserManagement\models\UserVisitLog::newVisitor($event->identity->id);
                }
        ],
        'cache' => [
            'class' => 'yii\caching\FileCache',
        ]
        ,
        // 'response' => [
        //     'class' => 'backend\components\SafeResponse'
        // ],
        'PosDbManager' => [
            'class' => 'backend\components\PosDbManager'
        ],
        'GenieApi' => [
            'class' => 'backend\components\GenieApi'
        ],
        'EzcashApi' => [
            'class' => 'backend\components\EzcashApi'
        ],
        'Chat3WebsocketDaemonHandler' => [
            'class' => 'backend\components\Chat3WebsocketDaemonHandler'
        ],
        'SortArray' => [
            'class' => 'backend\components\SortArray'
        ],
    ],
    'modules'=>[
        'user-management' => [
            'class' => 'webvimark\modules\UserManagement\UserManagementModule',
    
            // 'enableRegistration' => true,
    
            // Add regexp validation to passwords. Default pattern does not restrict user and can enter any set of characters.
            // The example below allows user to enter :
            // any set of characters
            // (?=\S{8,}): of at least length 8
            // (?=\S*[a-z]): containing at least one lowercase letter
            // (?=\S*[A-Z]): and at least one uppercase letter
            // (?=\S*[\d]): and at least one number
            // $: anchored to the end of the string
    
            //'passwordRegexp' => '^\S*(?=\S{8,})(?=\S*[a-z])(?=\S*[A-Z])(?=\S*[\d])\S*$',
            
    
            // Here you can set your handler to change layout for any controller or action
            // Tip: you can use this event in any module
            'on beforeAction'=>function(yii\base\ActionEvent $event) {
                    if ( $event->action->uniqueId == 'user-management/auth/login' )
                    {
                        $event->action->controller->layout = 'loginLayout.php';
                    };
                },
        ],
    ],
];
