<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "ezcash_push_transaction".
 *
 * @property int $id
 * @property string $requestId
 * @property int $status
 * @property string $description
 * @property int $ownerAlias
 * @property int $recipientAlias
 * @property string $txAmount
 * @property string $responseId
 * @property int $cron_status
 * @property int $user_id
 * @property string $vendor_name
 * @property string $order_rf_id
 * @property string $mobile_number
 * @property int $created_at
 * @property string $response_array
 */
class EzcashPushTransaction extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'ezcash_push_transaction';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['status', 'ownerAlias', 'recipientAlias', 'cron_status', 'user_id', 'created_at'], 'integer'],
            [['description'], 'string'],
            [['txAmount', 'order_rf_id', 'mobile_number', 'created_at', 'response_array'], 'required'],
            [['txAmount'], 'number'],
            [['requestId'], 'string', 'max' => 200],
            [['responseId', 'order_rf_id'], 'string', 'max' => 100],
            [['vendor_name', 'mobile_number'], 'string', 'max' => 50],
            [['response_array'], 'string', 'max' => 900],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'requestId' => 'Request ID',
            'status' => 'Status',
            'description' => 'Description',
            'ownerAlias' => 'Owner Alias',
            'recipientAlias' => 'Recipient Alias',
            'txAmount' => 'Tx Amount',
            'responseId' => 'Response ID',
            'cron_status' => 'Cron Status',
            'user_id' => 'User ID',
            'vendor_name' => 'Vendor Name',
            'order_rf_id' => 'Order Rf ID',
            'mobile_number' => 'Mobile Number',
            'created_at' => 'Created At',
            'response_array' => 'Response Array',
        ];
    }
}
