<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "genie_push_transaction".
 *
 * @property int $id
 * @property string $status
 * @property string $message
 * @property string $genieTransactionId
 * @property string $isDiscountApplied
 * @property int $attempts
 * @property int $lockRemainingTime
 * @property int $accountPermanentlyBlocked
 * @property int $nicuploadEnable
 * @property int $created_at
 * @property string $mobile_number
 * @property string $order_rf_id
 * @property string $total_amount
 * @property int $cron_status
 */
class GeniePushTransaction extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'genie_push_transaction';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['attempts', 'lockRemainingTime','created_at','cron_status','user_id'], 'integer'],
            [['status', 'message', 'isDiscountApplied','order_rf_id'], 'string', 'max' => 250],
            [['accountPermanentlyBlocked','nicuploadEnable'], 'boolean', 'trueValue' => true, 'falseValue' => false, 'strict' => true],
            [['genieTransactionId','vendor_name'], 'string', 'max' => 500],
            [['total_amount'], 'number'],
            [['mobile_number'], 'string', 'max' => 20], 
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'status' => 'Status',
            'message' => 'Message',
            'genieTransactionId' => 'Genie Transaction ID',
            'isDiscountApplied' => 'Is Discount Applied',
            'attempts' => 'Attempts',
            'lockRemainingTime' => 'Lock Remaining Time',
            'accountPermanentlyBlocked' => 'Account Permanently Blocked',
            'nicuploadEnable' => 'Nicupload Enable',
            'created_at' => 'Created At',
            'mobile_number' => 'Mobile Number',
            'order_rf_id' => 'Order Rf ID',
            'total_amount' => 'Total Amount',
            'cron_status' => 'Cron Status',
            'vendor_name' => 'Vendor Name'
        ];
    }
}
