<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "otp_codes".
 *
 * @property int $id
 * @property string $phone_number
 * @property int $status
 * @property string $created_on
 * @property string $activated_on
 * @property string $code
 */
class OtpCodes extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'otp_codes';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['phone_number', 'status', 'created_on'], 'required'],
            [['status','code','phone_number'], 'integer'],
            [['created_on', 'activated_on'], 'safe'],

            [['phone_number'], 'string', 'min' => 9 ,'max'=>9],
            [['phone_number'], 'custom_validation_rule']
            // [['phone_number'], 'string', 'max' => 20],
            // ['phone_number', 'unique', 'targetClass' => '\common\models\OtpCodes', 'message' => 'This number address has already been taken.'],
           
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'phone_number' => 'Phone Number',
            'status' => 'Status',
            'created_on' => 'Created On',
            'activated_on' => 'Activated On',
            'code' => 'Code',
        ];
    }


    public function custom_validation_rule($attribute, $params){
        $otpvalidate=$this::find()->where(['phone_number'=>$this->phone_number])->andWhere(['status'=>3])->one();
        if($otpvalidate){
            $this->addError($attribute,'This number has already been taken');
        }
    
    }
}
