<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "transaction_notification".
 *
 * @property int $id
 * @property string $transaction_id
 * @property int $created_at
 * @property int $pay_type
 * @property string $mobile_number
 * @property int $user_id
 * @property int $cron_status
 * @property string $order_rf_id
 * @property string $vendor_name
 */
class TransactionNotification extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'transaction_notification';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['transaction_id', 'created_at', 'pay_type', 'mobile_number', 'user_id', 'cron_status', 'order_rf_id', 'vendor_name'], 'required'],
            [['created_at', 'pay_type', 'user_id', 'cron_status','order_id'], 'integer'],
            [['transaction_id', 'order_rf_id', 'vendor_name'], 'string', 'max' => 100],
            [['mobile_number'], 'string', 'max' => 20],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'transaction_id' => 'Transaction ID',
            'created_at' => 'Created At',
            'pay_type' => 'Pay Type',
            'mobile_number' => 'Mobile Number',
            'user_id' => 'User ID',
            'cron_status' => 'Cron Status',
            'order_rf_id' => 'Order Rf ID',
            'order_id'=>'Order ID',
            'vendor_name' => 'Vendor Name',
        ];
    }
}
