<?php
$params = array_merge(
    require __DIR__ . '/../../common/config/params.php',
    require __DIR__ . '/../../common/config/params-local.php',
    require __DIR__ . '/params.php',
    require __DIR__ . '/params-local.php'
);

return [
    'id' => 'app-frontend',
    'basePath' => dirname(__DIR__),
    'bootstrap' => ['log'],
    'controllerNamespace' => 'frontend\controllers',
    'components' => [
        'headers' => [
            'class' => '\hyperia\security\Headers',
            'upgradeInsecureRequests' => true,
            'blockAllMixedContent' => true,
            'stsMaxAge' => 10,
            'xFrameOptions' => 'DENY',
            'xPoweredBy' => 'Hyperia',
            'publicKeyPins' => '',
            'reportUri' => 'https://company.report-uri.io',
            'cspDirectives' => [
                'script-src' => "'self' 'unsafe-inline'",
                'style-src' => "'self' 'unsafe-inline'",
                'img-src' => "'self' data:",
                'connect-src' => "'self'",
                'font-src' => "'self'",
                'object-src' => "'self'",
                'media-src' => "'self'",
                'form-action' => "'self'",
                'frame-src' => "'self'",
                'child-src' => "'self'"
            ]
            ],
        'request' => [
            'csrfParam' => '_csrf-frontend',
        ],

        'assetManager' => [
            'bundles' => [
                'yii\web\JqueryAsset' => [
                    'jsOptions' => [ 'position' => \yii\web\View::POS_HEAD ],
                    'sourcePath' => null,   // do not publish the bundle
                    'js' => [
                       
                       'smart_pos/frontend/web/themeassets/assets/global/plugins/jquery.min.js'
                       // 'http://localhost/basic/themeassets/assets/global/plugins/jquery.min.js',
                    ]
                ],
            ],
        ],
        'user' => [
            'identityClass' => 'common\models\User',
            'enableAutoLogin' => true,
            'identityCookie' => ['name' => '_identity-frontend', 'httpOnly' => true],
        ],
        'session' => [
            // this is the name of the session cookie used for login on the frontend
            'name' => 'advanced-frontend',
        ],
        'log' => [
            'traceLevel' => YII_DEBUG ? 3 : 0,
            'targets' => [
                [
                    'class' => 'yii\log\FileTarget',
                    'levels' => ['error', 'warning'],
                ],
                [
                    'class' => 'yii\log\FileTarget',
                    'categories' => ['order'],
                    'logFile' => '@app/runtime/logs/order.log',
                ],
            ],
        ],
        'errorHandler' => [
            'errorAction' => 'site/error',
        ],
        
        'urlManager' => [
            'enablePrettyUrl' => true,
            'showScriptName' => true,
            'rules' => [
            ],
        ],
    
    ],
    'params' => $params,
];
