<?php

namespace frontend\controllers;

use Yii;
use frontend\models\Order;
use morozovsk\websocket\examples\chat3\server\Chat3WebsocketDaemonHandler;
use morozovsk\websocket\Daemon;
use morozovsk\websocket\Generic;


use frontend\models\OrderItem;
use frontend\models\OrderFeedback;
use frontend\models\OrderSearch;
use frontend\models\OrderType;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use backend\models\Vendor;
use backend\models\Product;
use backend\models\PayTypes;
use backend\models\PriceList;
use backend\models\Discount;
use backend\models\GenieAccount;
use backend\models\EzcashAccount;
use yii\filters\ContentNegotiator;
use yii\web\Response;
use yii\data\Pagination;
use Da\QrCode\QrCode;

use backend\models\User; 
use backend\models\Organization;
use backend\models\Feedback;
use frontend\models\SignupForm;
use common\models\LoginForm;
use common\models\OtpCodes;
use common\models\GeniePushTransaction;
use common\models\EzcashPushTransaction;
use common\models\TransactionNotification;

use common\models\OtpCodeValidate;
use common\models\OtpCodeResend;

use backend\models\MenuType;
use yii\helpers\Json;
use common\models\AccessTokens;
use common\models\AuthorizationCodes;

use backend\behaviours\Verbcheck;
use backend\behaviours\Apiauth;

use backend\components\AccessBehavior;
use backend\components\Api;
use yii\db\Query;
use linslin\yii2\curl;
use yii\httpclient\Client;



/**
 * OrderController implements the CRUD actions for Order model.
 */
class OrderController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [

            'access' => [
                'class' => AccessControl::className(),
                // 'only' => ['location', 'update'],
                'rules' => [
                    [
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                    
                ],
                'denyCallback' => function () {
                    return Yii::$app->response->redirect(['site/login']);
                },
      
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                    'addtocart'=> ['POST'],
                    'removeproduct'=> ['POST'],
                    'paymentmethod'=> ['POST'],
                    'uncheckedmenutype'=> ['POST'],
                    'cartclean'=> ['POST'],
                    'feedbackdelete'=> ['POST'],
                    'sendfeedback'=> ['POST'],
                    'ordertype'=> ['POST'],
                    'socketcon'=>['POST'],
                    'createrating'=>['POST'],
                    'reorder'=>['POST'],
                    'rules' => [
                        [
                            'allow' => true,
                            'roles' => ['@'],
                        ],
                        
                    ],
                
                ],
            ],
            'contentNegotiator' => [
                'class' => ContentNegotiator::className(),
                'only' => ['addtocart','removeproduct','paymentmethod','uncheckedmenutype','cartclean','feedbackdelete','sendfeedback','ordertype','socketcon','createrating','reorder'], 
                'formats' => [
                    'application/json' => Response::FORMAT_JSON,
                ],
            ]
        ]   ;
    }

    /**
     * Lists all Order models.
     * @return mixed
     */

    public function setDb($database_name) 
    { 
 
        $connection =Yii::$app->PosDbManager->getDbConnection($database_name);
         return $connection;
    } 
    

    public function actionCreaterating()
    {

      
        $order_id =$_POST['order_id'];
        $value=$_POST['value'];

        $ModelOrder=Order::find()->where(['id'=>$order_id])->one();
        $ModelOrder->rating=$value;
        $ModelOrder->save();
        


        return $order_id;
        

    }

    public function actionReorder()
    {
        $model = new Order();
        $session = Yii::$app->session;
        $order_ref =$_POST['order_id'];
        $arr = $order_ref; // convert string to an array
       
       $ven_id=$arr['0'];

       $vendor_name = Vendor::find()->where(['id'=>$ven_id])->one()->database_name;
        

       $session->set('vendor_db_name',  $vendor_name);


       $modelOrder=Order::find()->where(['refference_id'=>$order_ref])->one();

       $databaseName=$vendor_name;

       $order = new Order(); 
       $AmountOfodre=0; 
       $FullAmountOfodre=0; 
       $orderserial= $order->getSerialNum();
       $yearend= substr(date("Y"), -2);
       $date_of_year=date("z", mktime(0,0,0,date("m"),date("d"),date("Y")))+1;
       $min = date("i");
       $scend = date("s");
       
       
      
       $refference_id_created = $ven_id.Yii::$app->user->id.$min.$scend.$yearend.$date_of_year.$orderserial;

       $OrderItemModel =OrderItem::find()->where(['order_id'=>$modelOrder->id])->all();
       $OrderItemModelForNewprice =OrderItem::find()->where(['order_id'=>$modelOrder->id])->all();


       $paymethod = $modelOrder->pay_type_id;
       $getOrderType =  $modelOrder->order_type;

       foreach($OrderItemModelForNewprice as $OrderItemModelForNewprice){

       
        $selectporPriceList=PriceList::find()->where(['product_id'=>$OrderItemModelForNewprice->product_id])->andWhere(['is_active'=>1])->one();
        $lastprice= $selectporPriceList->selling_price * $OrderItemModelForNewprice->quantity;


        $FullAmountOfodre= $FullAmountOfodre + $lastprice;

       }
       $selectporPayTypes=PayTypes::find()->Where(['id'=>$paymethod])->one();

       $AmountOfodre= $FullAmountOfodre - ($FullAmountOfodre *($selectporPayTypes->discount/100)   );


       $getdiscount=PayTypes::find()->where(['id'=>$paymethod])->one();
       $model->refference_id=$refference_id_created;
       $model->number_of_items=$modelOrder->number_of_items;
       $model->total_amount=$AmountOfodre;
       $model->full_amount=$FullAmountOfodre;
       $model->status=0;
       $model->created_on=date('Y-m-d h:i:s');
       $model->created_by=Yii::$app->user->id;
       $model->customer_id=Yii::$app->user->id;
       $model->rating=0;
       $model->pay_type_id=$modelOrder->pay_type_id;
       $model->order_type=$modelOrder->order_type;
       $model->order_option_id=$modelOrder->order_option_id;;
       $model->customer_req=$modelOrder->customer_req;
       $model->discount=$getdiscount->discount;
      
       if( $model->save()){

      
        $availbaleCountCheck=[];
       foreach($OrderItemModel as $OrderItemModel){
        $OrderItemModelnew = new OrderItem();
         $UnitPrice=PriceList::find()->where(['product_id'=>$OrderItemModel->product_id])->andWhere(['is_active'=>1])->one();
         $OrderItemModelnew->unit_price=$UnitPrice->selling_price;
         $OrderItemModelnew->quantity=$OrderItemModel->quantity;
         $OrderItemModelnew->order_id=$model->id;
         $OrderItemModelnew->product_id=$OrderItemModel->product_id;
         $OrderItemModelnew->created_date=date('Y-m-d h:i:s');
         $OrderItemModelnew->vendor_id=$ven_id;
//   $OrderItemModel->validate();
//                  print_r($OrderItemModel->getErrors());

//                  die;
         $OrderItemModelnew->save();

         $getProdouctCount= Product::find()->where(['id'=>$OrderItemModel->product_id])->one();

          /////////////////////////NEW1       
                 if($getProdouctCount->available_quantity < $OrderItemModel->quantity){
                    array_push($availbaleCountCheck, $OrderItemModel->product_id);
                 }

       
     }
     if($availbaleCountCheck){

   
        $productNames=[];
               foreach($availbaleCountCheck as $values){
                   

                  $findProduct=Product::find()->where(['id'=>$values])->one();
                                    array_push($productNames, $findProduct->name);
                  

                    }

                  //   $array2 = (array_values($productNames)); 

              
                  $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                  $afterPaiedOrderModel->status=2;
                 $afterPaiedOrderModel->save();
                 
                     
          Yii::$app->session->setFlash('warning', 'The products quantity is low' . " " . json_encode(array_values($productNames))); 
         

          return $this->redirect(['view', 'id' => $model->id]);

         
      }



 if($model->pay_type_id == 2){




////// testing withot genie
                // return $this->redirect(['view', 'id' => $model->id]);

//testing
               
       // Get access_token genieApi

       $responseAuthorized = Yii::$app->GenieApi->accessToken();

       if ($responseAuthorized->isOk) {

           $AccessToken=$responseAuthorized->data['access_token'];

          }else{
           Yii::$app->session->setFlash('warning', "Genie is Not Working 1. Please try Again"); 
           return $this->redirect(['view', 'id' => $model->id]);
          
           //  return "error";
          }
           /////////////////////////NEW1    
                // Get Initiate Push Transaction genieApiffvv
                 $phoneNumber="+94".Yii::$app->user->identity->mobile_number;
                 $modelGenieAccount=GenieAccount::find()->where(['vendor_id'=>$ven_id])->one();
               // $phoneNumber="+94715205107";
                $responseInitiatePushTransaction = Yii::$app->GenieApi->initiatePushTransaction($AccessToken,$phoneNumber,$model,$databaseName,$modelGenieAccount);

                // return $responseInitiatePushTransaction;

                if(isset($responseInitiatePushTransaction->data['response']['status']) ) {
            if ($responseInitiatePushTransaction->data['response']['status']=='success') {

               

                            // GeniePushTransaction save table


                $modelGeniePushTransaction= new GeniePushTransaction();
                $modelGeniePushTransaction->status = $responseInitiatePushTransaction->data['response']['status'];
                $modelGeniePushTransaction->message = $responseInitiatePushTransaction->data['response']['message'];
                $modelGeniePushTransaction->genieTransactionId = $responseInitiatePushTransaction->data['response']['genieTransactionId'];
                $modelGeniePushTransaction->isDiscountApplied = $responseInitiatePushTransaction->data['response']['isDiscountApplied'];
               //  $modelGeniePushTransaction->attempts = $responseInitiatePushTransaction->data['response']['attempts'];
               //  $modelGeniePushTransaction->lockRemainingTime = $responseInitiatePushTransaction->data['response']['lockRemainingTime'];
               //  $modelGeniePushTransaction->accountPermanentlyBlocked = $responseInitiatePushTransaction->data['response']['accountPermanentlyBlocked'];
               //  $modelGeniePushTransaction->nicuploadEnable = $responseInitiatePushTransaction->data['response']['nicuploadEnable'];
                $modelGeniePushTransaction->mobile_number = $phoneNumber;
                $modelGeniePushTransaction->created_at = time('Y-m-d h:i:s');
                $modelGeniePushTransaction->order_rf_id = $model->refference_id;
                $modelGeniePushTransaction->total_amount = $model->total_amount;
                $modelGeniePushTransaction->cron_status =1;
                $modelGeniePushTransaction->user_id =Yii::$app->user->identity->id;
                $modelGeniePushTransaction->vendor_name =$vendor_name;
               
               //  $modelGeniePushTransaction->validate();
               //  print_r($modelGeniePushTransaction->getErrors());
                $modelGeniePushTransaction->save();


                if($responseInitiatePushTransaction->data['response']['status']=='success'){
       $session->remove('add_to_cart_arrya17'); 
       $modelNt=new TransactionNotification();
       $modelNt->transaction_id=$responseInitiatePushTransaction->data['response']['genieTransactionId'];
       $modelNt->created_at= time('Y-m-d h:i:s');
       $modelNt->pay_type=2;
       $modelNt->cron_status=1;
       $modelNt->mobile_number=$phoneNumber;
       $modelNt->user_id=Yii::$app->user->identity->id;
       $modelNt->order_rf_id=$model->refference_id;
       $modelNt->order_id=$model->id;
    //    $modelNt->push_transaction_id=$push_transaction_id;
       $modelNt->vendor_name=$vendor_name;

    //    $modelNt->validate();
    //    print_r($modelNt->getErrors());
    //    die;
       $modelNt->save();

                    // Get Transaction Status
       //              for ($i=0; $i <= 70; $i++) {
       //              // Get Transaction Status genieApi

       //                  $responseStatus = Yii::$app->GenieApi->getTransactionStatus($AccessToken,$responseInitiatePushTransaction,$model);  

       //                  if($responseStatus->data['response']['merchantTxnStatusName']=="Customer Reject") {

       //                             $session->remove('add_to_cart_arrya17'); 

       //                            $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
       //                            $afterPaiedOrderModel->status=-1;
       //                            $afterPaiedOrderModel->save();

       //                             $responseOfPayment = [
       //                                  "Success" => false,
       //                                  "Massege" =>"Customer Reject Genie Payment",
       //                                  "orderId" => $model->refference_id 

       //                              ];
       //              Yii::$app->session->setFlash('warning', "Customer Reject Genie Payment. Please try Again"); 

       //                              return $this->redirect(['view', 'id' => $model->id]);
                            

       //                      break;

       //                  }

       //                 if($responseStatus->data['response']['merchantTxnStatusName']=="Payment Success") {
       //                         $session->remove('add_to_cart_arrya17');              
       //                          $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
       //                          $afterPaiedOrderModel->status=1;
       //                          $afterPaiedOrderModel->save();

       //                              $responseOfPayment = [
       //                                  "Success" => true,
       //                                  "Massege" =>"Payment Success",
       //                                  "orderId" => $model->refference_id 

       //                              ];
       //              Yii::$app->session->setFlash('success', "Genie Payment Success. Please try Again"); 

       //                             return $this->redirect(['view', 'id' => $model->id]);
       //     //  return \yii\helpers\Json::encode($responseOfPayment); 

       //                          break;

       //                      }

       //                      if($responseStatus->data['response']['merchantTxnStatusName']=="Payment Fail") {
       //                         $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
       //                         $afterPaiedOrderModel->status=2;
       //                         $afterPaiedOrderModel->save();

       //                             $responseOfPayment = [
       //                                 "Success" => false,
       //                                 "Massege" =>"Payment Fail",
       //                                 "orderId" => $model->refference_id 

       //                             ];
       //              Yii::$app->session->setFlash('warning', "Genie Payment Fail. Please try Again"); 

       //                            return $this->redirect(['cartview']);
       //    //  return \yii\helpers\Json::encode($responseOfPayment); 

       //                         break;

       //                     }
                        

       //                  sleep(1); // this should halt for 3 seconds for every loop
       //              }
                   //  $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                   //  $afterPaiedOrderModel->status=2;
                   // $afterPaiedOrderModel->save();
                   //  $responseOfPayment = [
                   //      "Success" => false,
                   //      "Massege" =>"Payment Fail",
                   //      "orderId" => $model->refference_id 
        
                   //  ];
                           Yii::$app->session->setFlash('success', "Check genies app and Approve Payment"); 
                           return $this->redirect(['view', 'id' => $model->id]);
                           

                }else{
                    return'error in number send';

                }
            }
            // GeniePushTransaction save table

            $modelGeniePushTransaction= new GeniePushTransaction();
            $modelGeniePushTransaction->status = $responseInitiatePushTransaction->data['response']['status'];
            $modelGeniePushTransaction->message = $responseInitiatePushTransaction->data['response']['message'];
           //  $modelGeniePushTransaction->attempts = $responseInitiatePushTransaction->data['response']['attempts'];
           //  $modelGeniePushTransaction->lockRemainingTime = $responseInitiatePushTransaction->data['response']['lockRemainingTime'];
           //  $modelGeniePushTransaction->accountPermanentlyBlocked = $responseInitiatePushTransaction->data['response']['accountPermanentlyBlocked'];
           //  $modelGeniePushTransaction->nicuploadEnable = $responseInitiatePushTransaction->data['response']['nicuploadEnable'];
            $modelGeniePushTransaction->mobile_number = $phoneNumber;
            $modelGeniePushTransaction->created_at = time('Y-m-d h:i:s');
            $modelGeniePushTransaction->order_rf_id = $model->refference_id;
            $modelGeniePushTransaction->total_amount = $model->total_amount;
            $modelGeniePushTransaction->cron_status =0;
            $modelGeniePushTransaction->user_id =Yii::$app->user->identity->id;
            $modelGeniePushTransaction->vendor_name =$vendor_name;



            $modelGeniePushTransaction->validate();
            print_r($modelGeniePushTransaction->getErrors());
            $modelGeniePushTransaction->save();


            if ($responseInitiatePushTransaction->data['response']['status']=='FAILURE') {

               $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
               $afterPaiedOrderModel->status=2;
              $afterPaiedOrderModel->save();
       
               $responseOfPayment = [
                   "Success" => false,
                   "Massege" =>"Genie is Not Working",
                   "orderId" => $model->refference_id 
       
               ];
               Yii::$app->session->setFlash('warning', $responseInitiatePushTransaction->data['response']['message']); 

           return $this->redirect(['view', 'id' => $model->id]);
              
               // return \yii\helpers\Json::encode($responseOfPayment); 
       
       
       
           }

           if ($responseInitiatePushTransaction->data['response']['status']=='failure') {
               $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
               $afterPaiedOrderModel->status=2;
              $afterPaiedOrderModel->save();
       
               $responseOfPayment = [
                   "Success" => false,
                   "Massege" =>$responseInitiatePushTransaction->data['response']['message'],
                   "orderId" => $model->refference_id 
       
               ];
               Yii::$app->session->setFlash('error', $responseInitiatePushTransaction->data['response']['message']); 

           return $this->redirect(['view', 'id' => $model->id]);
              
       
       
       
           }


           return $responseInitiatePushTransaction->content; 

       }else{

           $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
               $afterPaiedOrderModel->status=2;
              $afterPaiedOrderModel->save();


           $response = [
               "Success" => false,
               "massege" =>"Genie is Not Working",
               "orderId" => $model->refference_id 
               
           ];
           Yii::$app->session->setFlash('warning', "Genie is Not Working . Please try Again"); 
           return $this->redirect(['view', 'id' => $model->id]);
             
           // return \yii\helpers\Json::encode($response); 

           
       }

           }


           if($model->pay_type_id == 1){


            // return $_POST['ezcash_pin'];


            $responseAuthorized = Yii::$app->GenieApi->accessToken();


            // print_r($responseAuthorized);
            // die;

            if ($responseAuthorized->isOk) {

                $AccessToken=$responseAuthorized->data['access_token'];


              
               }else{
     
                 return "error";
               }
                 $phoneNumber=Yii::$app->user->identity->mobile_number;
                 $modelEzcashAccount=EzcashAccount::find()->where(['vendor_id'=>$ven_id])->one();
                 $ezcash_pin=$_POST['ezcash_pin'];   
              //$phoneNumber="766921091";
               $responseInitiatePushTransaction=Yii::$app->EzcashApi->initiatePushTransaction($AccessToken,$phoneNumber,$model,$databaseName,$modelEzcashAccount,$ezcash_pin);

               if(isset($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'])){
                 
                if($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status']==5){


                  $session->remove('add_to_cart_arrya17');              
                  
                  $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                  $afterPaiedOrderModel->status=1;
                  $afterPaiedOrderModel->save();


                  $orderItemmodel=OrderItem::find()->where(['order_id'=>$model->id])->all();
                  foreach( $orderItemmodel as $value ) {
                  $productModel=Product::find()->where(['id'=>$value->product_id])->one();
      
                   $newQuantity=($productModel->available_quantity - $value->quantity);
                   if($newQuantity<0){
                       $productModel->available_quantity=0;
                       $productModel->save();
      
      
      
                   }else{
                      $productModel->available_quantity=$newQuantity;
                      $productModel->save();
      
                   }
                  }




                 $modeEpt=new EzcashPushTransaction();
                 $modeEpt->requestId=$model->refference_id;
                 $modeEpt->response_array=json_encode($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']); 
                 $modeEpt->status=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'];
                  $modeEpt->description=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'];
                 // $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                 // $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                  $modeEpt->txAmount=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['netAmount'];
                 // $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                 $modeEpt->cron_status=1;
                 $modeEpt->user_id=Yii::$app->user->identity->id;
                 $modeEpt->vendor_name=$vendor_name;
                 $modeEpt->order_rf_id=$model->refference_id;
                 $modeEpt->mobile_number=$phoneNumber;
                 $modeEpt->created_at= time('Y-m-d h:i:s');
         //         $modeEpt->validate();
         //  print_r($modeEpt->getErrors());
         //  die;
                 
                 if($modeEpt->save()){
                    $modelNt=new TransactionNotification();
                    $modelNt->transaction_id=$model->refference_id;
                    $modelNt->created_at= time('Y-m-d h:i:s');
                    $modelNt->pay_type=1;
                    $modelNt->cron_status=2;
                    $modelNt->mobile_number=$phoneNumber;
                    $modelNt->user_id=Yii::$app->user->identity->id;
                    $modelNt->order_rf_id=$model->refference_id;
                    $modelNt->order_id=$model->id;
                 //    $modelNt->push_transaction_id=$push_transaction_id;
                    $modelNt->vendor_name=$vendor_name;

                 //    $modelNt->validate();
                 //    print_r($modelNt->getErrors());
                 //    die;
                    $modelNt->save();



                     Yii::$app->session->setFlash('success',  $responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description']); 
                     return $this->redirect(['view', 'id' => $model->id]);
                 }else{
                     Yii::$app->session->setFlash('success',  $responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description']); 
                     return $this->redirect(['view', 'id' => $model->id]);

                 }


                }else{

                 $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                 $afterPaiedOrderModel->status=2;
                $afterPaiedOrderModel->save();
                 
                 $modeEpt=new EzcashPushTransaction();
                 $modeEpt->requestId=$model->refference_id;
                 $modeEpt->response_array=json_encode($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']); 
                 $modeEpt->status=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'];
                  $modeEpt->description=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'];
                 // $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                 // $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                  $modeEpt->txAmount=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['netAmount'];
                 // $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                 $modeEpt->cron_status=1;
                 $modeEpt->user_id=Yii::$app->user->identity->id;
                 $modeEpt->vendor_name=$vendor_name;
                 $modeEpt->order_rf_id=$model->refference_id;
                 $modeEpt->mobile_number=$phoneNumber;
                 $modeEpt->created_at= time('Y-m-d h:i:s');
         //         $modeEpt->validate();
         //  print_r($modeEpt->getErrors());
         //  die;
                 
                 if($modeEpt->save()){
                    $modelNt=new TransactionNotification();
                    $modelNt->transaction_id=$model->refference_id;
                    $modelNt->created_at= time('Y-m-d h:i:s');
                    $modelNt->pay_type=1;
                    $modelNt->cron_status=-1;
                    $modelNt->mobile_number=$phoneNumber;
                    $modelNt->user_id=Yii::$app->user->identity->id;
                    $modelNt->order_rf_id=$model->refference_id;
                    $modelNt->order_id=$model->id;
                 //    $modelNt->push_transaction_id=$push_transaction_id;
                    $modelNt->vendor_name=$vendor_name;

                 //    $modelNt->validate();
                 //    print_r($modelNt->getErrors());
                 //    die;
                    $modelNt->save();



                     Yii::$app->session->setFlash('error', $responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description']); 
                     return $this->redirect(['view', 'id' => $model->id]);
                 }else{
                     Yii::$app->session->setFlash('error', $responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description']); 
                     return $this->redirect(['view', 'id' => $model->id]);

                 }


                }
                }else{

                 Yii::$app->session->setFlash('Warning', "EZcash is Not Working. Please try Again"); 

             return $this->redirect(['view', 'id' => $model->id]);

                }
               

        }


        if($model->pay_type_id == 3){

            $session->remove('add_to_cart_arrya17');              
            Yii::$app->session->setFlash('Success', "Cash Payment success."); 

            return $this->redirect(['view', 'id' => $model->id]);

        }


    


       
       
    }

    Yii::$app->session->setFlash('error', "An error occurred. please try again"); 
    return $this->redirect(['view', 'id' => $model->id]);






       

        return $ven_id;


    }

    public function actionCartclean()
    {

        $session = Yii::$app->session;
        $product_id = ($_POST['pay_item_id']);
        $session->remove('add_to_cart_arrya17'); 


        return $product_id;
        

    }

    


    public function actionOrdertype()
    {

        $session = Yii::$app->session;
        $ordertype = ($_POST['ordertype']);
        $session->set('order_type',  $ordertype);

        // $session->remove('add_to_cart_arrya17'); 


        return $ordertype;
        

    }

    public function actionSendfeedback()
    {

        $session = Yii::$app->session;
        $order_id = ($_POST['order_id']);
       
        $feedback = ($_POST['feedback']);
        $modelOrder= Order::find()->where(['id'=>$order_id])->one();


        $orderFeedbackModel=new OrderFeedback(); 
        $orderFeedbackModel->order_id=$order_id;
        $orderFeedbackModel->feedback=$feedback;
        $orderFeedbackModel->user_id=Yii::$app->user->identity->id;
        $orderFeedbackModel->created_date=date('Y-m-d h:i:s');
        if($orderFeedbackModel->save()){

            $db_name = $session->get('vendor_db_name');
            $ved_model=Vendor::find()->where(['database_name'=>$db_name])->one();

           $modelFeedback= new Feedback();
           $modelFeedback->description=$feedback; 
           $modelFeedback->created_date=date('Y-m-d h:i:s');
           $modelFeedback->created_by=Yii::$app->user->identity->id;
           $modelFeedback->vendor_id=$ved_model->id;
           $modelFeedback->order_id=$order_id;
           $modelFeedback->order_ref_id=$modelOrder->refference_id;
           $modelFeedback->status=1;
           $modelFeedback->save();



   $OrderFeedbackAllModel2=OrderFeedback::find()->where(['order_id'=>$order_id])->all();
   $OrderFeedbackAllCount=OrderFeedback::find()->where(['order_id'=>$order_id])->count();



   $data=[
       'OrderFeedbackAllModel2'=>$OrderFeedbackAllModel2,
       'OrderFeedbackAllCount'=>$OrderFeedbackAllCount,
       'ModelId'=>$orderFeedbackModel->id,
       'Modelcreated_date'=>$orderFeedbackModel->created_date,
       'ModelFeedback'=>$orderFeedbackModel->feedback,


   ];



   return $data;


        }
    


        // return $feedback;
        

    }


    public function actionFeedbackdelete()
    {

        // $session = Yii::$app->session;
        $feedbanck_id = ($_POST['feedbanck_id']);
        $order_id = ($_POST['order_id']);

        // return $order_id;

        $fanclub = OrderFeedback::find()
        ->where(['id'=>$feedbanck_id])
        ->one()
        ->delete();

       $OrderFeedbackAllCount=OrderFeedback::find()->where(['order_id'=>$order_id])->count();


       $data=[
        'status'=>$feedbanck_id,
         'feedbackCount'=>$OrderFeedbackAllCount,

       ];





        return $data;
        

    }

    public function actionRemoveproduct()
    {

        $session = Yii::$app->session;
        $product_id = ($_POST['product_id']);
        $ven_id = ($_POST['ven_id']);

        $allorders = $session->get('add_to_cart_arrya17');
        

        for($i=0; $i<=count($allorders); ++$i){

            if($allorders[$i]['product_id']== $product_id){
                $allordersreshedul=[];

              

           unset($allorders[$i]);


      

           foreach ($allorders as $key => $value) {


            $schedule_array = [
                            'ven_id' => $value['ven_id'],
                            'product_id' => $value['product_id'],
                        ];
                        array_push($allordersreshedul,$schedule_array);



           }



                $session['add_to_cart_arrya17'] = $allordersreshedul;

        //  return $this->redirect(['cartview']);
        $session->set('cart_array_cout_view',count($session['add_to_cart_arrya17'] ) );
        return true;



            }
        }
                return $allorders;
    }


     public function actionPaymentmethod()
    {

                $pay_item_id = ($_POST['pay_item_id']);

                $session = Yii::$app->session;
                $paymethod = $session->get('pay_item');

                if($paymethod==$pay_item_id){
                    $session->remove('pay_item'); 
                }else{
                    $session->set('pay_item',  $pay_item_id);

                }

                
                // $this->renderPartial('//order/cartview');
                
                return $pay_item_id;

    }


     public function actionAddtocart()
     {
        $session = Yii::$app->session;

        $all_product_array = array();
         $product_id = ($_POST['product_id']);
         $ven_id = ($_POST['ven_id']);







         $vendoer_deatails=Vendor::find()->where(['id'=> $ven_id])->one();

         $session->set('select_vandor',$ven_id );
    
         $session->set('vendor_db_name',$vendoer_deatails->database_name);



         $con = $this->setDb($vendoer_deatails->database_name);
         $product_details  = (new \yii\db\Query())
            ->select('*')
            ->from('product') 
            ->andWhere(['id'=>$product_id])
            ->one($con);
        $con->close();
        $productcount= 0;
        $allProductCount= 0;
        

        if($session->get('add_to_cart_arrya17')){

            $getcount=$session->get('add_to_cart_arrya17');

            for ($x = 0; $x <= count($getcount)-1; $x++) {


                 if($getcount[$x]['product_id'] == $product_id){

           


                   ++ $productcount;

                 }
            // return $productcount;
               
            }

            $allProductCount= $productcount;

        }

        if($product_details['available_quantity']>0 && $product_details['available_quantity'] > $allProductCount ){


            $available_conut=$product_details['available_quantity']; 
    
            $addtocartsession = $session->get('add_to_cart_arrya17');
            if($addtocartsession){
                
           
                $myarr = $session['add_to_cart_arrya17'];
                $myarr[] = [
                    'ven_id' => $ven_id,
                    'product_id' => $product_id,
                ];
                $session['add_to_cart_arrya17'] = $myarr;
                $addtocartsession13 = $session->get('add_to_cart_arrya17');
    
    
                $session->set('cart_array_cout_view', count($addtocartsession13));
    
                return $addtocartsession13;
    
            }else{
              
                $myarr = $session['add_to_cart_arrya17'];
                $myarr[] = [
                    'ven_id' => $ven_id,
                    'product_id' => $product_id,
                ];
                $session['add_to_cart_arrya17'] = $myarr;
                $addtocartsession12 = $session->get('add_to_cart_arrya17');
                $session->set('cart_array_cout_view',count($addtocartsession12) );
                // $session->set('cart_array_cout_view',$addtocartsession12.sizeof()  );
                return $addtocartsession12;
    
            }
            

        }else{
           
            return false;
        }

       
     
     }


     public function actionCartview()
    {   
    


        $session = Yii::$app->session;
        // $session->remove('add_to_cart_arrya17');
        $allorders = $session->get('add_to_cart_arrya17');
        $vendor_db_name = $session->get('vendor_db_name');
        $getOrderType = $session->get('order_type');
        $paymethod = $session->get('pay_item');

        
        // print_r($getOrderType);
        // die;

        if($getOrderType == null){
            $modelOrderType=OrderType::find()->orderBy(['id' => SORT_DESC])->one();

            $session->set('order_type',  $modelOrderType->id);
        }
        if($paymethod == null){
            $modelPayTypes=PayTypes::find()->where(['status'=>1])->one();

            $session->set('pay_item',  $modelPayTypes->id);
        }
        if($allorders== null){

            $vendoer_deatails=Vendor::find()->where(['database_name'=> $vendor_db_name])->one();
    
            return $this->redirect(['ven_product?id='.$vendoer_deatails->id]);
    
    
            }
       

        $vendoer_deatails=Vendor::find()->where(['id'=> $allorders[0]['ven_id']])->one();
        $modelOrderType=OrderType :: find()->all();



        $con = Yii::$app->PosDbManager->getDbConnection($vendoer_deatails->database_name);


        $paytypes_all  = (new \yii\db\Query())
        ->select('*')
        ->from('pay_types') 
        ->where(['status'=>1])
        ->all($con);

         $con->close();

        $selected_odre=[];
     

        for($i=0; $i<count($allorders); ++$i){
        $is_added=false;
            for($j=0; $j<count($selected_odre); ++$j){

                if($allorders[$i]['product_id'] == $selected_odre[$j]['product_id']){
                   ++ $selected_odre[$j]['count'];
                   $is_added=true;

                }
    
            }
            if($is_added==false){

                           $myarr = [
                    'ven_id' => $allorders[$i]['ven_id'],
                    'product_id' => $allorders[$i]['product_id'],
                    'count'=>1,
                ];
                array_push($selected_odre,$myarr);
        
            }

            
        }
    

        return $this->render('cartview', [
            'allorders'=>$allorders,
            'selected_odre'=>$selected_odre,
            'paytypes_all'=>$paytypes_all,
            'vendoer_deatails'=>$vendoer_deatails,
            'modelOrderType'=>$modelOrderType
            
         
        ]);
    } 

    
    public function actionIndex()
    {
        return $this->render('index',
        [
            'orders'=> $orders  
             ,'vendors' => $vendors
             ,'pages' => $pages
        ]);
    }

    public function actionCustomerOrders()
    {
        $session = Yii::$app->session;
       
        try {

            $order = new Order(); 

            $vendors= $order->getVendorsByCustomerOrders();
          
    
            $vendorId  = Yii::$app->request->get('vendor');

             
          
            $vendor = $order->getSelectedVendor($vendorId);
          
            $session->set('vendor_db_name',  $vendor->database_name);

            $selectedVendor = $vendor ->id;
            
            $user = Yii::$app->user->identity;
         
    
            $totalCount = $order->getCustomerOrderCount($vendor->database_name, $user->id);

           

            $pages = $order ->getPagination($totalCount, 10);
        
            $orders = $order ->getCustomerOrders($vendor->database_name, $user->id, $pages);
           
            if (Yii::$app->request->isAjax)
             {
                $ajaxView= $this->renderPartial('index',
                    [
                         'selectedVendor'=> $selectedVendor 
                         ,'orders'=> $orders 
                         ,'vendors' => $vendors
                         ,'pages' => $pages
                    ]);
                echo  $ajaxView;
                exit;
            }
            
            return $this->render('index',
            [
                 'selectedVendor'=> $selectedVendor 
                 ,'orders'=> $orders  
                 ,'vendors' => $vendors
                 ,'pages' => $pages
            ]);

        } catch (\Exception $e) {
            \Yii::error($e,'order');
            throw new \yii\web\HttpException(500, "we are working on this :)");
            
        }
    }

    public function actionSearchOrders()
    {
       try {
        $order = new Order();      
        
        $vendorId = Yii::$app->request->get('vendor');
        $orderRefference =  Yii::$app->request->get('oref');
       
        $vendor=$order->getSelectedVendor($vendorId);
       
        $user = Yii::$app->user->identity;
       
        $orders = $order 
        -> searchCustomerOrders($vendor->database_name, $user->id, $orderRefference, 10);
      
        if (Yii::$app->request->isAjax) {

            $ajaxView= $this->renderPartial('_orderList',
                [
                    'orders'=> $orders 
                ]);
            
            echo  $ajaxView;
            exit;
        }
       } catch (\Exception $e) {
            \Yii::error($e,'order');
            throw new \yii\web\HttpException(500, "we are working on this :)");
       }
         
    }
    
    public function actionFilterOrdersRating()
    {
       try {
        $order = new Order();      
        
        $vendorId = Yii::$app->request->get('vendor');
        $filterRatings =  Yii::$app->request->get('ratings');
       
        $vendor = $order->getSelectedVendor($vendorId);
       
        $user = Yii::$app->user->identity;
       
        $orders = $order 
        -> FilterCustomerOrders($vendor->database_name, $user->id, $filterRatings, 10);
      
        if (Yii::$app->request->isAjax) {

            $ajaxView= $this->renderPartial('_orderList',
                [
                    'orders'=> $orders 
                ]);
            
            echo  $ajaxView;
            exit;
        }
       } catch (\Exception $e) {
            \Yii::error($e,'order');
            throw new \yii\web\HttpException(500, "we are working on this :)");
       }
         
    }


    
    
    /**
     * Displays a single Order model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */

    

    public function actionSelectvendor()
    { 
        $all_vendor=Vendor::find()->where(['status'=>1])->all();


        return $this->render('selectvendor', [
            'all_vendor' => $all_vendor,
        ]);
       
       
    }


    public function actionUncheckedmenutype()
    {
        $session = Yii::$app->session;
        $allmenutypeSelected = $session->get('menutypeSelected_order');

        $item_id = ($_POST['item_id']);
        $ven_id = ($_POST['ven_id']);
        $type = ($_POST['type']);
     


        for($i=0; $i<=count($allmenutypeSelected); ++$i){

          

            if($allmenutypeSelected[$i]['menutypeID'] == $item_id && $allmenutypeSelected[$i]['type'] == $type  ){

               
                $selectedMenuTypesReshedul=[];

               
              

           unset($allmenutypeSelected[$i]);

          
      

           foreach ($allmenutypeSelected as $key => $value) {


            $MenuTypesReshedul = [
                            'menutypeID' => $value['menutypeID'],
                            'ven_id' => $value['ven_id'],
                            'type'=>$value['type'],    

                        ];
                        array_push($selectedMenuTypesReshedul,$MenuTypesReshedul);



           }


           $session['menutypeSelected_order'] = $selectedMenuTypesReshedul;

            }


        }
   
        $allmenutypeSelected2 = $session->get('menutypeSelected_order');
        if(count($allmenutypeSelected2)==0){
    

            $session->remove('menutypeSelected_order'); 


        }

     
        return $this->redirect(['ven_product?id='.$ven_id]);
    

    }


    public function actionVen_product($id)
    { 
        $session = Yii::$app->session;

        $allmenutypeSelected = $session->get('menutypeSelected_order');

       



      
         if(! $session->get('select_vandor') || $session->get('select_vandor')!= $id){
            $session->set('select_vandor',$id );
            $session->remove('add_to_cart_arrya17');
         }
        

      

        $ven_model=Vendor::find()->where(['id'=>$id])->one();
        if($ven_model){
            $session->set('vendor_db_name',  $ven_model->database_name);
        }else{
            $ven_model=Vendor::find()->where(['status'=>1])->one();
            $session->set('vendor_db_name',  $ven_model->database_name);
        }
       

        $vendoer_deatails=$ven_model;
         $con = $this->setDb($vendoer_deatails->database_name);
         if( isset($_POST['checked'])){
            $menutypeArray = array();
            $allcatogoryArray = array();



            if($_POST['type'] == 1){
            

            if($session->get('menutypeSelected_order') ){
                $myarr = $session['menutypeSelected_order'];
                $myarr[] = [
                    'menutypeID' => $_POST['menutypeID'],
                    'ven_id'=>$_POST['ven_id'],
                    'type'=>$_POST['type']      
                ];
                $session['menutypeSelected_order'] = $myarr;
                $allmenutypeSelected = $session->get('menutypeSelected_order');
              }else{
                $myarr = $session['menutypeSelected_order'];
                $myarr[] = [
                    'menutypeID' => $_POST['menutypeID'],
                    'ven_id'=>$_POST['ven_id'],
                    'type'=>$_POST['type']     
                    
                ];
                $session['menutypeSelected_order'] = $myarr;
                $allmenutypeSelected = $session->get('menutypeSelected_order');
                  
              }
              foreach($allmenutypeSelected as $allmenutypeSelected ){
                  if($id == $allmenutypeSelected['ven_id']  ){

                    if($allmenutypeSelected['type']==1){ array_push($menutypeArray,$allmenutypeSelected['menutypeID']); }
                    if($allmenutypeSelected['type']==2){ array_push($allcatogoryArray,$allmenutypeSelected['menutypeID']); }

                    
                  }
             
              }
            }
            if($_POST['type'] == 2){
              
                if($session->get('menutypeSelected_order') ){
                    $myarr = $session['menutypeSelected_order'];
                    $myarr[] = [
                        'menutypeID' => $_POST['allcatogoryID'],
                        'ven_id'=>$_POST['ven_id'],
                        'type'=>$_POST['type']      
                    ];
                    $session['menutypeSelected_order'] = $myarr;
                    $allmenutypeSelected = $session->get('menutypeSelected_order');
                  }else{
                    $myarr = $session['menutypeSelected_order'];
                    $myarr[] = [
                        'menutypeID' => $_POST['allcatogoryID'],
                        'ven_id'=>$_POST['ven_id'],
                        'type'=>$_POST['type']     
                        
                    ];
                    $session['menutypeSelected_order'] = $myarr;
                    $allmenutypeSelected = $session->get('menutypeSelected_order');
                      
                  }

                //     print_r($allmenutypeSelected);
                // die;
                  foreach($allmenutypeSelected as $allmenutypeSelected ){
                      if($id == $allmenutypeSelected['ven_id']  ){
    
                        if($allmenutypeSelected['type']==1){ array_push($menutypeArray,$allmenutypeSelected['menutypeID']); }

                        if($allmenutypeSelected['type']==2){ array_push($allcatogoryArray,$allmenutypeSelected['menutypeID']); }
                      }
                 
                  }

            }


            
            $product_count = (new \yii\db\Query())
            ->select('COUNT(*)')
            ->from('product') 
            ->andFilterWhere(['munu_type_id'=>$menutypeArray])
            ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])
            ->one($con);   

          $pages = new Pagination(
                ['totalCount' =>$product_count['COUNT(*)']
                ,'pageSize' => 18]);

        $product_details  = (new \yii\db\Query())
            ->select('*')
            ->from('product') 
            ->where(['status'=>1])
            ->andFilterWhere(['munu_type_id'=>$menutypeArray])
            ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])
            ->offset($pages->offset)
            ->limit($pages->limit)
            ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])
            ->all($con);


            $allMenuType = (new \yii\db\Query())
            ->select('*')
            ->from('menu_type') 
            ->all($con);  

            $allSubCategory = (new \yii\db\Query())
            ->select('*')
            ->from('sub_category') 
            ->all($con);
            if( isset($_POST['searchbyname'])){

                $product_count = (new \yii\db\Query())
                ->select('COUNT(*)')
                ->from('product')
                ->filterWhere(['like', 'name', $_POST['searchbyname']])

                ->andFilterWhere(['munu_type_id'=>$menutypeArray])
                ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])

    
    
                ->one($con);   
    
                 $pages = new Pagination(
                    ['totalCount' =>$product_count['COUNT(*)']
                    ,'pageSize' => 18]);
    
    
                $product_details  = (new \yii\db\Query())
                    ->select('*')
                    ->from('product') 
                    ->filterWhere(['like', 'name', $_POST['searchbyname']])
                    ->andFilterWhere(['munu_type_id'=>$menutypeArray])
                    ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])                
                    ->offset($pages->offset)
                    ->limit($pages->limit)
                    ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])
                    ->all($con);
                $vendor_id=$id;
    
                
              $con->close();
    
    
            
    
                return $this->render('ven_product', [
                    'product_details'=>$product_details,
                'product_details2'=>$product_details,

                    // 'all_vendoer'=>$all_vendoer,
                    'vendor_id'=>$id,
                    'pages'=>$pages,
                    'ven_model'=>$ven_model,
                    'allMenuType'=>$allMenuType,
                    'allSubCategory'=>$allSubCategory,
                    'menutypeArray'=>$menutypeArray,
                    'allcatogoryArray'=>$allcatogoryArray,
            'secarchinpur'=>$_POST['searchbyname']


    
        
        
                ]);
    


            }  
        $con->close();

        return $this->render('ven_product', [
            'product_details'=>$product_details,
            'vendor_id'=>$id,
            'pages'=>$pages,
            'ven_model'=>$ven_model,
            'allMenuType'=>$allMenuType,
            'allSubCategory'=>$allSubCategory,
            'menutypeArray'=>$menutypeArray,
            'allcatogoryArray'=>$allcatogoryArray

         
        ]);

        }
        if( $allmenutypeSelected){


          

            $menutypeArray = array();
            $allcatogoryArray = array();


            foreach($allmenutypeSelected as $allmenutypeSelected ){
                //   if($autoselect->id == $allmenutypeSelected['ven_id'] && $allmenutypeSelected['type']==1 ){

                //     array_push($menutypeArray,$allmenutypeSelected['menutypeID']);
                //   }

                  if($id == $allmenutypeSelected['ven_id']  ){
    
                    if($allmenutypeSelected['type']==1){ array_push($menutypeArray,$allmenutypeSelected['menutypeID']); }

                    if($allmenutypeSelected['type']==2){ array_push($allcatogoryArray,$allmenutypeSelected['menutypeID']); }
                  }
             
              }


              $product_count = (new \yii\db\Query())
              ->select('COUNT(*)')
              ->from('product') 
              ->andFilterWhere(['munu_type_id'=>$menutypeArray])
              ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])
              ->one($con);   
  
            $pages = new Pagination(
                  ['totalCount' =>$product_count['COUNT(*)']
                  ,'pageSize' => 18]);
  
          $product_details  = (new \yii\db\Query())
              ->select('*')
              ->from('product') 
            ->where(['status'=>1])
              ->andFilterWhere(['munu_type_id'=>$menutypeArray])
              ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])
              ->offset($pages->offset)
              ->limit($pages->limit)
              ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])
              ->all($con);
  
  
              $allMenuType = (new \yii\db\Query())
              ->select('*')
              ->from('menu_type') 
              ->all($con);  
  
              $allSubCategory = (new \yii\db\Query())
              ->select('*')
              ->from('sub_category') 
              ->all($con);  

              if( isset($_POST['searchbyname'])){

                $product_count = (new \yii\db\Query())
                ->select('COUNT(*)')
                ->from('product')
                ->filterWhere(['like', 'name', $_POST['searchbyname']])

                ->andFilterWhere(['munu_type_id'=>$menutypeArray])
                ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])

    
    
                ->one($con);   
    
                 $pages = new Pagination(
                    ['totalCount' =>$product_count['COUNT(*)']
                    ,'pageSize' => 18]);
    
    
                $product_details  = (new \yii\db\Query())
                    ->select('*')
                    ->from('product') 
                    ->filterWhere(['like', 'name', $_POST['searchbyname']])
                    ->andFilterWhere(['munu_type_id'=>$menutypeArray])
                    ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])                
                    ->offset($pages->offset)
                    ->limit($pages->limit)
                    ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])
                    ->all($con);
                $vendor_id=$id;
    
                
              $con->close();
    
    
            
    
                return $this->render('ven_product', [
                    'product_details'=>$product_details,
                'product_details2'=>$product_details,

                    // 'all_vendoer'=>$all_vendoer,
                    'vendor_id'=>$id,
                    'pages'=>$pages,
                    'ven_model'=>$ven_model,
                    'allMenuType'=>$allMenuType,
                    'allSubCategory'=>$allSubCategory,
                    'menutypeArray'=>$menutypeArray,
                    'allcatogoryArray'=>$allcatogoryArray,
            'secarchinpur'=>$_POST['searchbyname']


    
        
        
                ]);
    


            }
          $con->close();
  
          return $this->render('ven_product', [
              'product_details'=>$product_details,
              'vendor_id'=>$id,
              'pages'=>$pages,
              'ven_model'=>$ven_model,
              'allMenuType'=>$allMenuType,
              'allSubCategory'=>$allSubCategory,
              'menutypeArray'=>$menutypeArray,
              'allcatogoryArray'=>$allcatogoryArray
  
           
          ]);




        }

         
            $product_count = (new \yii\db\Query())
            ->select('COUNT(*)')
            ->from('product') 
            ->one($con);   

          $pages = new Pagination(
                ['totalCount' =>$product_count['COUNT(*)']
                ,'pageSize' => 18]);

        $product_details  = (new \yii\db\Query())
            ->select('*')
            ->from('product') 
            ->where(['status'=>1])

            ->offset($pages->offset)
            ->limit($pages->limit)
            ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])
            ->all($con);


            $allMenuType = (new \yii\db\Query())
            ->select('*')
            ->from('menu_type') 
            ->all($con);  

            $allSubCategory = (new \yii\db\Query())
            ->select('*')
            ->from('sub_category') 
            ->all($con);
            
            
            if( isset($_POST['searchbyname'])){

                $product_count = (new \yii\db\Query())
                ->select('COUNT(*)')
                ->from('product')
                ->filterWhere(['like', 'name', $_POST['searchbyname']])

                // ->andFilterWhere(['munu_type_id'=>$menutypeArray])
                // ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])

    
    
                ->one($con);   
    
                 $pages = new Pagination(
                    ['totalCount' =>$product_count['COUNT(*)']
                    ,'pageSize' => 18]);
    
    
                $product_details  = (new \yii\db\Query())
                    ->select('*')
                    ->from('product') 
                    ->filterWhere(['like', 'name', $_POST['searchbyname']])
                    // ->andFilterWhere(['munu_type_id'=>$menutypeArray])
                    // ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])                
                    ->offset($pages->offset)
                    ->limit($pages->limit)
                    ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])
                    ->all($con);
                $vendor_id=$id;
    
                
              $con->close();
    
    
            
    
                return $this->render('ven_product', [
                    'product_details'=>$product_details,
                'product_details2'=>$product_details,

                    // 'all_vendoer'=>$all_vendoer,
                    'vendor_id'=>$vendor_id,
                    'pages'=>$pages,
                    'ven_model'=>$ven_model,
                    'allMenuType'=>$allMenuType,
                    'allSubCategory'=>$allSubCategory,
            'secarchinpur'=>$_POST['searchbyname']


    
        
        
                ]);
    


            }
        $con->close();
        $session->remove('menutypeSelected'); 
        return $this->render('ven_product', [
            'product_details'=>$product_details,
            'vendor_id'=>$id,
            'pages'=>$pages,
            'ven_model'=>$ven_model,
            'allMenuType'=>$allMenuType,
            'allSubCategory'=>$allSubCategory

         
        ]);
       
       
    }



    public function actionView($id)
    {
        

       $allOrderModel=Order::find()->where(['id'=>$id])->andWhere(['created_by'=>Yii::$app->user->identity->id])->one();
       $OrderItemModel=OrderItem::find()->where(['order_id'=>$id])->all();
       $OrderFeedbackAllModel=OrderFeedback::find()->where(['order_id'=>$id])->all();
       $OrderFeedbackAllCount=OrderFeedback::find()->where(['order_id'=>$id])->count();

    

  
            if(isset($_POST['order_id']) && $_POST['feedback'] ){

                


                $orderFeedbackModel=new OrderFeedback(); 
                $orderFeedbackModel->order_id=$_POST['order_id'];
                $orderFeedbackModel->feedback=$_POST['feedback'];
                $orderFeedbackModel->user_id=Yii::$app->user->identity->id;
                $orderFeedbackModel->created_date=date('Y-m-d h:i:s');
                if($orderFeedbackModel->save()){

        //    $OrderFeedbackAllModel2=OrderFeedback::find()->where(['order_id'=>$id])->all();



           return $this->redirect(['view', 'id' => $id]);


                }




               

            }


     


        return $this->render('view', [
            'allOrderModel'=>$allOrderModel,
            'OrderItemModel'=>$OrderItemModel,
            'OrderFeedbackAllModel'=>$OrderFeedbackAllModel,
            'OrderFeedbackAllCount'=>$OrderFeedbackAllCount


           
        ]);
    }

    /**
     * Creates a new Order model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {

       
        $model = new Order();
        $session = Yii::$app->session;


        $Customer_Reuqest=$_POST['comment_text'];
    
        $addtocartsession = $session->get('add_to_cart_arrya17');
    
        $productcount =count($addtocartsession);
        $paymethod = $session->get('pay_item');
      
        $getOrderType = $session->get('order_type');

        

        $vendor_name = Vendor::find()->where(['id'=> $session->get('select_vandor')])->one()->database_name;
        

        $session->set('vendor_db_name',  $vendor_name);
        $databaseName=$vendor_name;
        $AmountOfodre=0; 
        $FullAmountOfodre=0; 


            foreach ($addtocartsession as $addtocartsession) {  
                

               

                 $selectporduct=Product::find()->where(['id'=>$addtocartsession['product_id']])->one();
                 $selectporPriceList=PriceList::find()->where(['product_id'=>$addtocartsession['product_id']])->andWhere(['is_active'=>1])->one();
                 $selectporPayTypes=PayTypes::find()->Where(['id'=>$paymethod])->one();
                 $selectporDiscount=Discount::find()->Where(['product_id'=>$addtocartsession['product_id']])->andWhere(['pay_type_id'=>$paymethod])->one();
                 


                    $lastprice= $selectporPriceList->selling_price - ($selectporPriceList->selling_price *($selectporPayTypes->discount/100)   );
                    // $all_after_discout=$after_discout*$selected_odre['count'];



                $AmountOfodre= $AmountOfodre + $lastprice;
                $FullAmountOfodre= $FullAmountOfodre + $selectporPriceList->selling_price;



                

               
            }

            if($paymethod==2){

            
            $TotalAmountOfodre=round($AmountOfodre);


            }else{
            $TotalAmountOfodre=$AmountOfodre;
            }

            $vendorCode = (new \yii\db\Query())
            ->select('*')
            ->from('vendor')
            ->where(['id'=> $session->get('select_vandor')])
            ->one();
           
            $order = new Order(); 

            $orderserial= $order->getSerialNum();
            $yearend= substr(date("Y"), -2);
            $date_of_year=date("z", mktime(0,0,0,date("m"),date("d"),date("Y")))+1;
            $min = date("i");
            $scend = date("s");
           

           
            $refference_id_created = $vendorCode['id'].Yii::$app->user->id.$min.$scend.$yearend.$date_of_year.$orderserial;

            $getdiscount=PayTypes::find()->where(['id'=>$paymethod])->one();

            
            $model->refference_id=$refference_id_created;
            $model->number_of_items=$productcount;
            $model->total_amount=$TotalAmountOfodre;
            $model->full_amount=$FullAmountOfodre;
            $model->status=0;
            $model->created_on=date('Y-m-d h:i:s');
            $model->created_by=Yii::$app->user->id;
            $model->customer_id=Yii::$app->user->id;
            $model->rating=0;
            $model->pay_type_id=$paymethod;
            $model->order_type=$getOrderType;
            $model->order_option_id=1;
            $model->customer_req=$Customer_Reuqest;
            $model->discount=$getdiscount->discount;
            
            if($model->save()){ 

                $allorders=  $session->get('add_to_cart_arrya17');
               
            
                $selected_odre=[];
             
        
                for($i=0; $i<count($allorders); ++$i){
                $is_added=false;
                    for($j=0; $j<count($selected_odre); ++$j){
        
                        if($allorders[$i]['product_id'] == $selected_odre[$j]['product_id']){
                           ++ $selected_odre[$j]['count'];
                           $is_added=true;
        
                        }
            
                    }
                    if($is_added==false){
        
                                   $myarr = [
                            'ven_id' => $allorders[$i]['ven_id'],
                            'product_id' => $allorders[$i]['product_id'],
                            'count'=>1,
                        ];
                        array_push($selected_odre,$myarr);
                
                    }
        
                    
                }
             
               $availbaleCountCheck=[];
               foreach($selected_odre as $selected_odre){
               $OrderItemModel = new OrderItem();
                $UnitPrice=PriceList::find()->where(['product_id'=>$selected_odre['product_id']])->andWhere(['is_active'=>1])->one();
                $OrderItemModel->unit_price=$UnitPrice->selling_price;
                $OrderItemModel->quantity=$selected_odre['count'];
                $OrderItemModel->order_id=$model->id;
                $OrderItemModel->product_id=$selected_odre['product_id'];
                $OrderItemModel->created_date=date('Y-m-d h:i:s');
                $OrderItemModel->vendor_id=$vendorCode['id'];
                $OrderItemModel->save(); 
                 $getProdouctCount= Product::find()->where(['id'=>$selected_odre['product_id']])->one();

                 
                 if($getProdouctCount->available_quantity < $selected_odre['count']){
                    array_push($availbaleCountCheck, $selected_odre['product_id']);
                 }

            }

            if($availbaleCountCheck){
              $productNames=[];
                     foreach($availbaleCountCheck as $values){
                         

                        $findProduct=Product::find()->where(['id'=>$values])->one();
                                          array_push($productNames, $findProduct->name);
                        

                          }

                        //   $array2 = (array_values($productNames)); 

                    
                        $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                        $afterPaiedOrderModel->status=2;
                       $afterPaiedOrderModel->save();
                       
                           
                Yii::$app->session->setFlash('warning', 'The products quantity is low' . " " . json_encode(array_values($productNames))); 
               

                return $this->redirect(['cartview']);

               
            }

         


            if($model->pay_type_id == 2){


////// testing withot genie
                // return $this->redirect(['view', 'id' => $model->id]);

//testing
               
       // Get access_token genieApi

        $responseAuthorized = Yii::$app->GenieApi->accessToken();

        if ($responseAuthorized->isOk) {
 
            $AccessToken=$responseAuthorized->data['access_token'];
 
           }else{
            Yii::$app->session->setFlash('warning', "Genie is Not Working 1. Please try Again"); 
            return $this->redirect(['cartview']);
            //  return "error";
           }

         /////////////////////////NEW1    
                 // Get Initiate Push Transaction genieApiffvv
                 
                // $phoneNumber="+94".Yii::$app->user->identity->mobile_number;
                 $phoneNumber="+94".Yii::$app->user->identity->mobile_number;


                 $modelGenieAccount=GenieAccount::find()->where(['vendor_id'=>$vendorCode['id']])->one();
                //  print_r($modelGenieAccount->password);
                //  die;
                 $responseInitiatePushTransaction = Yii::$app->GenieApi->initiatePushTransaction($AccessToken,$phoneNumber,$model,$databaseName,$modelGenieAccount);
 
                 // return $responseInitiatePushTransaction;

                 if(isset($responseInitiatePushTransaction->data['response']['status']) ) {
             if ($responseInitiatePushTransaction->data['response']['status']=='success') {

                
 
                             // GeniePushTransaction save table
 
 
                 $modelGeniePushTransaction= new GeniePushTransaction();
                 $modelGeniePushTransaction->status = $responseInitiatePushTransaction->data['response']['status'];
                 $modelGeniePushTransaction->message = $responseInitiatePushTransaction->data['response']['message'];
                 $modelGeniePushTransaction->genieTransactionId = $responseInitiatePushTransaction->data['response']['genieTransactionId'];
                 $modelGeniePushTransaction->isDiscountApplied = $responseInitiatePushTransaction->data['response']['isDiscountApplied'];
                //  $modelGeniePushTransaction->attempts = $responseInitiatePushTransaction->data['response']['attempts'];
                //  $modelGeniePushTransaction->lockRemainingTime = $responseInitiatePushTransaction->data['response']['lockRemainingTime'];
                //  $modelGeniePushTransaction->accountPermanentlyBlocked = $responseInitiatePushTransaction->data['response']['accountPermanentlyBlocked'];
                //  $modelGeniePushTransaction->nicuploadEnable = $responseInitiatePushTransaction->data['response']['nicuploadEnable'];
                 $modelGeniePushTransaction->mobile_number = $phoneNumber;
                 $modelGeniePushTransaction->created_at = time('Y-m-d h:i:s');
                 $modelGeniePushTransaction->order_rf_id = $model->refference_id;
                 $modelGeniePushTransaction->total_amount = $model->total_amount;
                 $modelGeniePushTransaction->cron_status =1;
                 $modelGeniePushTransaction->user_id =Yii::$app->user->identity->id;
                 $modelGeniePushTransaction->vendor_name =$vendor_name;
                
                //  $modelGeniePushTransaction->validate();
                //  print_r($modelGeniePushTransaction->getErrors());
                 $modelGeniePushTransaction->save();
 
 
                 if($responseInitiatePushTransaction->data['response']['status']=='success'){
        $session->remove('add_to_cart_arrya17'); 
        $modelNt=new TransactionNotification();
        $modelNt->transaction_id=$responseInitiatePushTransaction->data['response']['genieTransactionId'];
        $modelNt->created_at= time('Y-m-d h:i:s');
        $modelNt->pay_type=2;
        $modelNt->cron_status=1;
        $modelNt->mobile_number=$phoneNumber;
        $modelNt->user_id=Yii::$app->user->identity->id;
        $modelNt->order_rf_id=$model->refference_id;
        $modelNt->order_id=$model->id;
     //    $modelNt->push_transaction_id=$push_transaction_id;
        $modelNt->vendor_name=$vendor_name;

     //    $modelNt->validate();
     //    print_r($modelNt->getErrors());
     //    die;
        $modelNt->save();

                     // Get Transaction Status
        //              for ($i=0; $i <= 70; $i++) {
        //              // Get Transaction Status genieApi
 
        //                  $responseStatus = Yii::$app->GenieApi->getTransactionStatus($AccessToken,$responseInitiatePushTransaction,$model);  
 
        //                  if($responseStatus->data['response']['merchantTxnStatusName']=="Customer Reject") {

        //                             $session->remove('add_to_cart_arrya17'); 

        //                            $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
        //                            $afterPaiedOrderModel->status=-1;
        //                            $afterPaiedOrderModel->save();
 
        //                             $responseOfPayment = [
        //                                  "Success" => false,
        //                                  "Massege" =>"Customer Reject Genie Payment",
        //                                  "orderId" => $model->refference_id 
 
        //                              ];
        //              Yii::$app->session->setFlash('warning', "Customer Reject Genie Payment. Please try Again"); 

        //                              return $this->redirect(['view', 'id' => $model->id]);
                             
 
        //                      break;
 
        //                  }
 
        //                 if($responseStatus->data['response']['merchantTxnStatusName']=="Payment Success") {
        //                         $session->remove('add_to_cart_arrya17');              
        //                          $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
        //                          $afterPaiedOrderModel->status=1;
        //                          $afterPaiedOrderModel->save();
 
        //                              $responseOfPayment = [
        //                                  "Success" => true,
        //                                  "Massege" =>"Payment Success",
        //                                  "orderId" => $model->refference_id 
 
        //                              ];
        //              Yii::$app->session->setFlash('success', "Genie Payment Success. Please try Again"); 

        //                             return $this->redirect(['view', 'id' => $model->id]);
        //     //  return \yii\helpers\Json::encode($responseOfPayment); 
 
        //                          break;
 
        //                      }

        //                      if($responseStatus->data['response']['merchantTxnStatusName']=="Payment Fail") {
        //                         $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
        //                         $afterPaiedOrderModel->status=2;
        //                         $afterPaiedOrderModel->save();

        //                             $responseOfPayment = [
        //                                 "Success" => false,
        //                                 "Massege" =>"Payment Fail",
        //                                 "orderId" => $model->refference_id 

        //                             ];
        //              Yii::$app->session->setFlash('warning', "Genie Payment Fail. Please try Again"); 

        //                            return $this->redirect(['cartview']);
        //    //  return \yii\helpers\Json::encode($responseOfPayment); 

        //                         break;

        //                     }
                         
 
        //                  sleep(1); // this should halt for 3 seconds for every loop
        //              }
                    //  $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                    //  $afterPaiedOrderModel->status=2;
                    // $afterPaiedOrderModel->save();
                    //  $responseOfPayment = [
                    //      "Success" => false,
                    //      "Massege" =>"Payment Fail",
                    //      "orderId" => $model->refference_id 
         
                    //  ];
                            Yii::$app->session->setFlash('success', "Check genies app and Approve Payment"); 
                            return $this->redirect(['view', 'id' => $model->id]);
                            

                 }else{
                     return'error in number send';
 
                 }
             }
             // GeniePushTransaction save table
 
             $modelGeniePushTransaction= new GeniePushTransaction();
             $modelGeniePushTransaction->status = $responseInitiatePushTransaction->data['response']['status'];
             $modelGeniePushTransaction->message = $responseInitiatePushTransaction->data['response']['message'];
            //  $modelGeniePushTransaction->attempts = $responseInitiatePushTransaction->data['response']['attempts'];
            //  $modelGeniePushTransaction->lockRemainingTime = $responseInitiatePushTransaction->data['response']['lockRemainingTime'];
            //  $modelGeniePushTransaction->accountPermanentlyBlocked = $responseInitiatePushTransaction->data['response']['accountPermanentlyBlocked'];
            //  $modelGeniePushTransaction->nicuploadEnable = $responseInitiatePushTransaction->data['response']['nicuploadEnable'];
             $modelGeniePushTransaction->mobile_number = $phoneNumber;
             $modelGeniePushTransaction->created_at = time('Y-m-d h:i:s');
             $modelGeniePushTransaction->order_rf_id = $model->refference_id;
             $modelGeniePushTransaction->total_amount = $model->total_amount;
             $modelGeniePushTransaction->cron_status =0;
             $modelGeniePushTransaction->user_id =Yii::$app->user->identity->id;
             $modelGeniePushTransaction->vendor_name =$vendor_name;



             $modelGeniePushTransaction->validate();
             print_r($modelGeniePushTransaction->getErrors());
             $modelGeniePushTransaction->save();


             if ($responseInitiatePushTransaction->data['response']['status']=='FAILURE') {

                $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                $afterPaiedOrderModel->status=2;
               $afterPaiedOrderModel->save();
        
                $responseOfPayment = [
                    "Success" => false,
                    "Massege" =>"Genie is Not Working",
                    "orderId" => $model->refference_id 
        
                ];
                Yii::$app->session->setFlash('warning', $responseInitiatePushTransaction->data['response']['message']); 

                return $this->redirect(['cartview']);
                // return \yii\helpers\Json::encode($responseOfPayment); 
        
        
        
            }

            if ($responseInitiatePushTransaction->data['response']['status']=='failure') {
                $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                $afterPaiedOrderModel->status=2;
               $afterPaiedOrderModel->save();
        
                $responseOfPayment = [
                    "Success" => false,
                    "Massege" =>$responseInitiatePushTransaction->data['response']['message'],
                    "orderId" => $model->refference_id 
        
                ];
                Yii::$app->session->setFlash('error', $responseInitiatePushTransaction->data['response']['message']); 

                return $this->redirect(['cartview']);   
        
        
        
            }
 

            return $responseInitiatePushTransaction->content; 
 
        }else{

            $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                $afterPaiedOrderModel->status=2;
               $afterPaiedOrderModel->save();


            $response = [
                "Success" => false,
                "massege" =>"Genie is Not Working",
                "orderId" => $model->refference_id 
                
            ];
            Yii::$app->session->setFlash('warning', "Genie is Not Working 3. Please try Again"); 
            return $this->redirect(['cartview']);   
            // return \yii\helpers\Json::encode($response); 

            
        }

            }

            if($model->pay_type_id == 1){
            


                $responseAuthorized = Yii::$app->GenieApi->accessToken();


               

                if ($responseAuthorized->isOk) {
 
                    $AccessToken=$responseAuthorized->data['access_token'];


                  
                   }else{
         
                     return "error";
                   }
                   $phoneNumber=Yii::$app->user->identity->mobile_number;   
                 $modelEzcashAccount=EzcashAccount::find()->where(['vendor_id'=>$vendorCode['id']])->one();
                 $ezcash_pin=$_POST['ezcash_pin'];               
                   //$phoneNumber="766921091";
                   $responseInitiatePushTransaction=Yii::$app->EzcashApi->initiatePushTransaction($AccessToken,$phoneNumber,$model,$databaseName,$modelEzcashAccount,$ezcash_pin);
                  //start8
                   if(isset($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'])){
                 
                   if($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status']==5){


                     $session->remove('add_to_cart_arrya17');              
                     
                     $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                     $afterPaiedOrderModel->status=1;
                     $afterPaiedOrderModel->save();


                     
                  $orderItemmodel=OrderItem::find()->where(['order_id'=>$model->id])->all();
                  foreach( $orderItemmodel as $value ) {
                  $productModel=Product::find()->where(['id'=>$value->product_id])->one();
      
                   $newQuantity=($productModel->available_quantity - $value->quantity);
                   if($newQuantity<0){
                       $productModel->available_quantity=0;
                       $productModel->save();
      
      
      
                   }else{
                      $productModel->available_quantity=$newQuantity;
                      $productModel->save();
      
                   }
                  }

                    $modeEpt=new EzcashPushTransaction();
                    $modeEpt->requestId=$model->refference_id;
                    $modeEpt->response_array=json_encode($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']); 
                    $modeEpt->status=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'];
                     $modeEpt->description=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'];
                    // $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                    // $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                     $modeEpt->txAmount=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['netAmount'];
                    // $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                    $modeEpt->cron_status=1;
                    $modeEpt->user_id=Yii::$app->user->identity->id;
                    $modeEpt->vendor_name=$vendor_name;
                    $modeEpt->order_rf_id=$model->refference_id;
                    $modeEpt->mobile_number=$phoneNumber;
                    $modeEpt->created_at= time('Y-m-d h:i:s');
            //         $modeEpt->validate();
            //  print_r($modeEpt->getErrors());
            //  die;
                    
                    if($modeEpt->save()){
                       $modelNt=new TransactionNotification();
                       $modelNt->transaction_id=$model->refference_id;
                       $modelNt->created_at= time('Y-m-d h:i:s');
                       $modelNt->pay_type=1;
                       $modelNt->cron_status=2;
                       $modelNt->mobile_number=$phoneNumber;
                       $modelNt->user_id=Yii::$app->user->identity->id;
                       $modelNt->order_rf_id=$model->refference_id;
                       $modelNt->order_id=$model->id;
                    //    $modelNt->push_transaction_id=$push_transaction_id;
                       $modelNt->vendor_name=$vendor_name;

                    //    $modelNt->validate();
                    //    print_r($modelNt->getErrors());
                    //    die;
                       $modelNt->save();



                        Yii::$app->session->setFlash('success',  $responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description']); 
                        return $this->redirect(['view', 'id' => $model->id]);
                    }else{
                        Yii::$app->session->setFlash('success',  $responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description']); 
                        return $this->redirect(['view', 'id' => $model->id]);

                    }


                   }else{

                    $afterPaiedOrderModel=Order::find()->where(['id'=>$model->id])->one();
                    $afterPaiedOrderModel->status=2;
                   $afterPaiedOrderModel->save();
                    
                    $modeEpt=new EzcashPushTransaction();
                    $modeEpt->requestId=$model->refference_id;
                    $modeEpt->response_array=json_encode($responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']); 
                    $modeEpt->status=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['status'];
                     $modeEpt->description=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description'];
                    // $modeEpt->ownerAlias=$responseInitiatePushTransaction->data['ownerAlias'];
                    // $modeEpt->recipientAlias=$responseInitiatePushTransaction->data['recipientAlias'];
                     $modeEpt->txAmount=$responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['netAmount'];
                    // $modeEpt->responseId=$responseInitiatePushTransaction->data['responseId'];
                    $modeEpt->cron_status=1;
                    $modeEpt->user_id=Yii::$app->user->identity->id;
                    $modeEpt->vendor_name=$vendor_name;
                    $modeEpt->order_rf_id=$model->refference_id;
                    $modeEpt->mobile_number=$phoneNumber;
                    $modeEpt->created_at= time('Y-m-d h:i:s');
            //         $modeEpt->validate();
            //  print_r($modeEpt->getErrors());
            //  die;
                    
                    if($modeEpt->save()){
                       $modelNt=new TransactionNotification();
                       $modelNt->transaction_id=$model->refference_id;
                       $modelNt->created_at= time('Y-m-d h:i:s');
                       $modelNt->pay_type=1;
                       $modelNt->cron_status=-1;
                       $modelNt->mobile_number=$phoneNumber;
                       $modelNt->user_id=Yii::$app->user->identity->id;
                       $modelNt->order_rf_id=$model->refference_id;
                       $modelNt->order_id=$model->id;
                    //    $modelNt->push_transaction_id=$push_transaction_id;
                       $modelNt->vendor_name=$vendor_name;

                    //    $modelNt->validate();
                    //    print_r($modelNt->getErrors());
                    //    die;
                       $modelNt->save();



                        Yii::$app->session->setFlash('error', $responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description']); 
                        return $this->redirect(['cartview']); 
                    }else{
                        Yii::$app->session->setFlash('error', $responseInitiatePushTransaction->data['submitCustomerTransactionRequestResponse']['return']['description']); 
                        return $this->redirect(['cartview']); 

                    }


                   }
                   }else{

                    Yii::$app->session->setFlash('Warning', "EZcash is Not Working. Please try Again"); 

                return $this->redirect(['cartview']);

                   }

                  //start8


            }
            if($model->pay_type_id == 3){

                $session->remove('add_to_cart_arrya17');              
                Yii::$app->session->setFlash('Success', "Cash Payment success."); 

                return $this->redirect(['view', 'id' => $model->id]);

            }
            return $this->redirect(['view', 'id' => $model->id]);
    }
    Yii::$app->session->setFlash('error', "An error occurred. please try again"); 
    return $this->redirect(['cartview']);
}


  

    /**
     * Updates an existing Order model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Order model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Order model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Order the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Order::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }

    public function beforeAction($action) 
    { 
        $this->enableCsrfValidation = false; 
        return parent::beforeAction($action); 
    } 
}
