<?php
namespace frontend\controllers;

use frontend\models\ResendVerificationEmailForm;
use frontend\models\VerifyEmailForm;
use Yii;
use yii\base\InvalidArgumentException;
use yii\web\BadRequestHttpException;
use yii\web\Controller;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;
use common\models\LoginForm;
use common\models\OtpCodes;
use common\models\OtpCodeValidate;
use common\models\OtpCodeResend;
use frontend\models\Order;
use frontend\models\SocketCount;
use frontend\models\PasswordResetRequestForm;
use frontend\models\ResetPasswordForm;
use frontend\models\SignupForm;
use frontend\models\ContactForm;
use backend\models\Vendor;
use yii\filters\ContentNegotiator;
use yii\web\Response;
use yii\data\Pagination;
use backend\models\Product;
use backend\models\Discount;
use backend\models\PayTypes;
use backend\models\PriceList;
use frontend\models\UploadForm;
use yii\web\UploadedFile;
use backend\models\MenuType;
use yii\web\NotFoundHttpException;
use common\models\GeniePushTransaction;


use yii\helpers\Json;


/**
 * Site controller
 */
class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout', 'signup','notificationsend','notifica'],
                'rules' => [
                    [
                        'actions' => ['signup','notificationsend','notifica'],
                        'allow' => true,
                        'roles' => ['?'],
                    ],
                    [
                        'actions' => ['logout','notificationsend','notifica'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                    'alllistajax'=> ['POST'],
                    'uncheckedmenutype'=> ['POST'],
                    'socketcon'=>['POST'],
                    'croncheking'=>['POST'],

                ],
            ],
            'contentNegotiator' => [
                'class' => ContentNegotiator::className(),
                'only' => ['alllistajax','uncheckedmenutype','socketcon','croncheking','socketwork'],
                'formats' => [
                    'application/json' => Response::FORMAT_JSON,
                ],
            ]
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return mixed
     */


    public function setDb($database_name) {

        $connection = new \yii\db\Connection([
            'dsn' => 'mysql:host=localhost;dbname='.$database_name,
            'username' => 'eimuser',
            'password' => 'Welcome@2019',

            'charset' => 'utf8',
            ]);
            $connection->open();
       return $connection;
      }


    public function actionIndex()
    {

       // $this->redirect(‘link’, array(‘target’=>’_blank’));
     
      
        // get all vandor
        $all_product_array = array();
        $all_vendoer=Vendor::find()->where(['status'=>1])->orderBy([
            'id' => SORT_DESC,
            // 'item_no'=>SORT_ASC
          ])->all();

   



        for ($x = 0; $x <= sizeof($all_vendoer)-1; $x++) {

            $database=$all_vendoer[$x]['database_name'];

            // print_r($all_vendoer[$x]['image_path']);
            // die;
            $con = Yii::$app->PosDbManager->getDbConnection($database);
            $product_details  = (new \yii\db\Query())
            ->select('*')
            ->from('product')
            ->all($con);

            // print_r($product_details);
            // die;
    

            $main_category_details  = (new \yii\db\Query())
            ->select('*')
            ->from('main_category')
            ->all($con);

            $menu_type_details  = (new \yii\db\Query())
            ->select('*')
            ->from('menu_type')
            ->all($con);

             array_push($all_product_array, array(' '=>$product_details , 'vendor_image_path'=>$all_vendoer[$x]['image_path'] ,'vendoer_name'=>$all_vendoer[$x]['name'],'db_name'=>$database,'vendoer_id'=>$all_vendoer[$x]['id'] ,'main_category'=>$main_category_details ,'menu_type'=>$menu_type_details ));

        }
    $con->close();
    

        return $this->render('index', [
            'all_product_array' => $all_product_array,
        ]);
    }

    /**
     * Logs in a user.
     *
     * @return mixed
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }


        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->redirect(Yii::$app->request->referrer);
        } else {
            $model->password = '';

            return $this->render('login', [
                'model' => $model,
            ]);
        }
    }



    public function actionOtpvalidate(){


        $session = Yii::$app->session;
        $id = $session->get('send_otp_id');

        $model=new OtpCodeValidate();
        $modelOtpCodes=OtpCodes::find()->where(['id'=>$id])->one();

        // print_r($modelOtpCodes);
        // die;



        if ($model->load(Yii::$app->request->post()) ) {

            $OtpValidet=OtpCodes::find()->where(['code'=>$model->code])->andWhere(['status'=>1])->andWhere(['phone_number'=>$modelOtpCodes->phone_number])->one();

            if($OtpValidet){

                $OtpValidet->status=2;
                $OtpValidet->save();



            //  return $this->redirect('signup');
             return $this->redirect(array('signup'));
            }else{
                Yii::$app->session->setFlash('warning','Invalid code'); 
                

            }
        }


        return $this->render('otpvalidate', [
            'model' => $model,
            'modelOtpCodes'=>$modelOtpCodes
        ]);

    }

    public function actionSocketcon()
    {

        $session = Yii::$app->session;
        $client_id = ($_POST['client_id']);
        if($client_id=="masgeServer"){
            return $client_id;

        }else{
        SocketCount::updateAll(['status' => 0], ['=', 'user_id', Yii::$app->user->identity->id]);

        $modelSocketCount=new SocketCount();
        $modelSocketCount->user_id=Yii::$app->user->identity->id;
        $modelSocketCount->socket_id=$client_id;
        $modelSocketCount->status=1;
        $modelSocketCount->save();
        return $client_id;
        }

    }
    public function actionCroncheking()
    {

        $session = Yii::$app->session;
        $id = ($_POST['id']);
 $modelNew=GeniePushTransaction::find()->where(['cron_status'=>2])->one();

 if($modelNew){


    $session->set('socketuser',$modelNew->user_id );

    // return $modelNew;


    // return $id;

    echo"
    <script >


    
 

    console.log('@SID')

   
  
        document.cookie = '';
        function wsStart() {
           var ws = new WebSocket('ws://127.0.0.1:8006/userId=' + Math.round(Math.random()*10000));

            ws.onopen = function() { 
            
                alert('opne21');
            
             };
             ws.sendmsg = function() { 
            
                alert('opne221');
            
             };
             ws.onclose = function() { };
             ws.onmessage = function(evt) {
                
                  alert('onmessage');

                  };


       
        }

       

     

         wsStart();
    function sendmsg(){
        console.log('sla');
        ws.send('123456');
    }
    

    sendmsg();
    
    </script>
    ";


    return $id;
     

 }

        // SocketCount::updateAll(['status' => 0], ['=', 'user_id', Yii::$app->user->identity->id]);

        // $modelSocketCount=new SocketCount();
        // $modelSocketCount->user_id=Yii::$app->user->identity->id;
        // $modelSocketCount->socket_id=$client_id;
        // $modelSocketCount->status=1;
        // $modelSocketCount->save();
        

    }

    public function actionResendotpcode($id){

$session = Yii::$app->session;
        $otpresendmodel=new OtpCodeResend();

      
        

        $phone_numbermodel=OtpCodeResend::find()->where(['id'=>$id])->andWhere(['status'=>1])->one();

        if($phone_numbermodel){

            

            $phone_numbermodel->status=0;

            $phone_numbermodel->validate();

            // print_r( $phone_numbermodel->getErrors());
            // die;
        if($phone_numbermodel->save()){
            $six_digit_random_number = mt_rand(10000, 99999);
            $one_code=$six_digit_random_number; 

            $otpresendmodel->phone_number=$phone_numbermodel->phone_number;
            $otpresendmodel->status=1;
            $otpresendmodel->created_on=time('Y-m-d h:i:s');
            $otpresendmodel->code=$one_code;


            if($otpresendmodel->save()){
                $enter_phone_number=715205107;
                $msagg=$one_code;
                Yii::$app->PosDbManager->sendMessage($enter_phone_number, $msagg);
                $session->set('send_otp_id',$otpresendmodel->id);
                Yii::$app->session->setFlash('success', 'OPT sent successfully, check your mobile phone');
                return $this->redirect(['otpvalidate']);
            



           }else{

            echo("error2  try again");
        
           }








        }else{

            echo("error2 try again");
            
        }

        }else{

            $model=new OtpCodes();
            return $this->redirect('sendotpcode');
    

        }

       






    }




    public function actionSendotpcode(){
        $model=new OtpCodes();
        $session = Yii::$app->session;
       

        if ($model->load(Yii::$app->request->post()) ) {

            $modelNewOtpCodes=OtpCodes::find()->where(['phone_number'=>$model->phone_number])->andWhere(['status'=>1])->one();


           
            if($modelNewOtpCodes){
                $modelNewOtpCodes->status=0;
                $modelNewOtpCodes->save();


                if(time()-($modelNewOtpCodes->created_on) <= 5){
                    $timeSet=time()-($modelNewOtpCodes->created_on);

                    Yii::$app->session->setFlash('warning','Wait please try again after'. $timeSet .'s'); 
                    return $this->render('sendotpcode', [
                        'model' => $model,
                    ]);
            
       
                   }else{

                    $six_digit_random_number = mt_rand(10000, 99999);
                    $one_code=$six_digit_random_number;
                    $model->status=1;
                    $model->created_on=time('Y-m-d h:i:s');
                    $model->code=$one_code.'';
        
               if($model->save()){
        
        
        
        
                    $enter_phone_number=715205107;
                    $msagg=$one_code;
                    Yii::$app->PosDbManager->sendMessage($enter_phone_number,"452");


                    $session->set('send_otp_id',$model->id);
                   
                 return $this->redirect(['otpvalidate']);
                    
        
               }
    


                   }

            }else{

                $six_digit_random_number = mt_rand(10000, 99999);
                $one_code=$six_digit_random_number;
                $model->status=1;
                $model->created_on=time('Y-m-d h:i:s');
                $model->code=$one_code.'';
    
           if($model->save()){
    
    
    
    
                $enter_phone_number=715205107;
                $msagg=$one_code;
                Yii::$app->PosDbManager->sendMessage($enter_phone_number,"455");
                $session->set('send_otp_id',$model->id);
             return $this->redirect(['otpvalidate']);
                
    
           }

            }
          


          
            
             
         


        }

        // }
        return $this->render('sendotpcode', [
            'model' => $model,
        ]);

        // return $this->render('sendotpcode');

    }



    /**
     * Logs out the current user.
     *
     * @return mixed
     */





    public function actionProduct_view($id ,$ve_id)
    {


        $each_vendoer=Vendor::find()->where(['id'=>$ve_id])->one();

        $con = Yii::$app->PosDbManager->getDbConnection($each_vendoer->database_name);


       $model  = (new \yii\db\Query())
       ->select('*')
       ->from('product')
       ->where(['id'=>$id])
       ->one($con);



       $modelMenuType  = (new \yii\db\Query())
       ->select('*')
       ->from('menu_type')
       ->where(['id'=>$model['munu_type_id']])
       ->one($con);

       $modelPriceList=  (new \yii\db\Query())
       ->select('*')
       ->from('price_list')
       ->where(['product_id'=>$model['id']])
       ->andWhere(['is_active'=>1])
       ->one($con);


       $modelDiscount=  (new \yii\db\Query())
       ->select('*')
       ->from('discount')
       ->where(['product_id'=>$model['id']])
       ->andWhere(['status'=>1])
       ->all($con);

       $allCategory=  (new \yii\db\Query())
       ->select('*')
       ->from('sub_category')
       ->all($con);




       $con->close();




        return $this->render('product_view', [
            'model' => $model,
            'modelMenuType'=>$modelMenuType,
            'modelPriceList'=>$modelPriceList,
            'modelDiscount'=>$modelDiscount,
            'allCategory'=>$allCategory,
            'each_vendoer'=>$each_vendoer

        ]);

    }

    public function actionSocketwork()
    {
        $type = ($_POST['ven_id']);
        $type = ($_POST['type']);

        return $type;

    }

    public function actionNotifica()
    {

        print_r("locl");
        die;

    }


    public function actionNotificationsend()
    {
        // return $this->redirect(['notifica',]);

        $session = Yii::$app->session;
       
 $modelNew=GeniePushTransaction::find()->where(['cron_status'=>2])->one();

 if($modelNew){

       $modelSocketCount= SocketCount::find()->where(['user_id'=>$modelNew->user_id])->andWhere(['status'=>1])->one();

   
    return $this->render('sand',[
           'modelNew'=>$modelNew,
           'modelSocketCount'=>$modelSocketCount,


       ]);
    $session->set('socketuser',$modelNew->user_id );


        echo"
        <script >
    
    
        
     
    
        console.log('@SID')
    
       
      
            document.cookie = '';
            function wsStart() {
               var ws = new WebSocket('ws://localhost:8006/Id=$modelNew->user_id.$modelSocketCount->socket_id');
    
                ws.onopen = function() { 
                
                    alert('opne21');

                 
                
                 };
                 ws.sendmsg = function() { 
                
                    alert('opne221');
                
                 };
                 ws.onclose = function() { };
                 ws.onmessage = function(evt) {
                    
                      alert('onmessage');
    
                      };
    
    
           
            }
    
           
    
         
    
             wsStart();
        function sendmsg(){
            console.log('sla');
            ws.send('123456');
        }
        
    
        sendmsg();
        
        </script>
        ";

        die;


    }
}

    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->redirect(Yii::$app->request->referrer);
    }

    /**
     * Displays contact page.
     *
     * @return mixed
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($model->sendEmail(Yii::$app->params['contactEmail'])) {
                Yii::$app->session->setFlash('success', 'Thank you for contacting us. We will respond to you as soon as possible.');
            } else {
                Yii::$app->session->setFlash('error', 'There was an error sending your message.');
            }

            return $this->refresh();
        } else {
            return $this->render('contact', [
                'model' => $model,
            ]);
        }
    }

    public function actionAlllistajax()
    {
        if (Yii::$app->request->isAjax) {

         $vendor_id = ($_POST['vendor_id']);

         $session = Yii::$app->session;
         if(! $session->get('select_vandor') || $session->get('select_vandor')!= $vendor_id){
            $session->set('select_vandor',$vendor_id );
            $session->remove('add_to_cart_arrya17');
         }
        

      

        $ven_model=Vendor::find()->where(['id'=>$vendor_id])->one();
        $session->set('vendor_db_name',  $ven_model->database_name);





         return $this->redirect('alllist?vendor='.$vendor_id);
         }

    }

    public function actionUncheckedmenutype()
    {
        $session = Yii::$app->session;
        $allmenutypeSelected = $session->get('menutypeSelected');

        $item_id = ($_POST['item_id']);
        $ven_id = ($_POST['ven_id']);
        $type = ($_POST['type']);



        for($i=0; $i<=count($allmenutypeSelected); ++$i){



            if($allmenutypeSelected[$i]['menutypeID'] == $item_id && $allmenutypeSelected[$i]['type'] == $type  ){


                $selectedMenuTypesReshedul=[];




           unset($allmenutypeSelected[$i]);




           foreach ($allmenutypeSelected as $key => $value) {


            $MenuTypesReshedul = [
                            'startTime' => $value['menutypeID'],
                            'endTime' => $value['ven_id'],
                            'departureTime'=>$value['type'],
                            'arrivalTime'=>$value['type'],
                            'totalDay'=>$value['type'],
                            'daysDelaye'=>$value['type'],

                        ];
                        array_push($selectedMenuTypesReshedul,$MenuTypesReshedul);



           }


           $session['menutypeSelected'] = $selectedMenuTypesReshedul;

            }


        }

        $allmenutypeSelected2 = $session->get('menutypeSelected');
        if(count($allmenutypeSelected2)==0){


            $session->remove('menutypeSelected');


        }


        return $this->redirect(['alllist?vendor='.$ven_id]);


    }



    public function actionAlllist()
    {
        $session = Yii::$app->session;
        $allmenutypeSelected = $session->get('menutypeSelected');


       


        if( isset($_POST['checked'])){

            $menutypeArray = array();
            $allcatogoryArray = array();


            $all_vendoer=Vendor::find()->where(['status'=>1])->all();

        if(Yii::$app->request->get('vendor')){

            $autoselect=Vendor::find()->where(['id'=>Yii::$app->request->get('vendor')])->one();
            if($autoselect){
                $auloselectdb=$autoselect->database_name;
            }else {

                $autoselect=Vendor::find()->where(['status'=>1])->one();
        $auloselectdb=$autoselect->database_name;
                # code...
            }
           

            // print_r($_POST['type']);
            // die;

            if($_POST['type'] == 1){

                if($session->get('menutypeSelected') ){
                    $myarr = $session['menutypeSelected'];
                    $myarr[] = [
                        'menutypeID' => $_POST['menutypeID'],
                        'ven_id'=>$_POST['ven_id'],
                        'type'=>$_POST['type']
                    ];
                    $session['menutypeSelected'] = $myarr;
                    $allmenutypeSelected = $session->get('menutypeSelected');
                  }else{
                    $myarr = $session['menutypeSelected'];
                    $myarr[] = [
                        'menutypeID' => $_POST['menutypeID'],
                        'ven_id'=>$_POST['ven_id'],
                        'type'=>$_POST['type']

                    ];
                    $session['menutypeSelected'] = $myarr;
                    $allmenutypeSelected = $session->get('menutypeSelected');

                  }
                  foreach($allmenutypeSelected as $allmenutypeSelected ){
                      if($autoselect->id == $allmenutypeSelected['ven_id']  ){

                        if($allmenutypeSelected['type']==1){ array_push($menutypeArray,$allmenutypeSelected['menutypeID']); }
                        if($allmenutypeSelected['type']==2){ array_push($allcatogoryArray,$allmenutypeSelected['menutypeID']); }


                      }

                  }

            }

            if($_POST['type'] == 2){

                if($session->get('menutypeSelected') ){
                    $myarr = $session['menutypeSelected'];
                    $myarr[] = [
                        'menutypeID' => $_POST['allcatogoryID'],
                        'ven_id'=>$_POST['ven_id'],
                        'type'=>$_POST['type']
                    ];
                    $session['menutypeSelected'] = $myarr;
                    $allmenutypeSelected = $session->get('menutypeSelected');
                  }else{
                    $myarr = $session['menutypeSelected'];
                    $myarr[] = [
                        'menutypeID' => $_POST['allcatogoryID'],
                        'ven_id'=>$_POST['ven_id'],
                        'type'=>$_POST['type']

                    ];
                    $session['menutypeSelected'] = $myarr;
                    $allmenutypeSelected = $session->get('menutypeSelected');

                  }

                //     print_r($allmenutypeSelected);
                // die;
                  foreach($allmenutypeSelected as $allmenutypeSelected ){
                      if($autoselect->id == $allmenutypeSelected['ven_id']  ){

                        if($allmenutypeSelected['type']==1){ array_push($menutypeArray,$allmenutypeSelected['menutypeID']); }

                        if($allmenutypeSelected['type']==2){ array_push($allcatogoryArray,$allmenutypeSelected['menutypeID']); }
                      }

                  }

            }



            //   print_r($menutypeArray);
            //   die;

            if($menutypeArray==null){
                $allcatogoryArray= null;

                
                $session->remove('menutypeSelected');

            }

            $session->set('vendor_db_name',  $auloselectdb);

            $con = Yii::$app->PosDbManager->getDbConnection($auloselectdb);

            // $allMenuType=MenuType::find()->all($con);main_category

            $allMenuType = (new \yii\db\Query())
            ->select('*')
            ->from('menu_type')
            ->all($con);

            $allSubCategory = (new \yii\db\Query())
            ->select('*')
            ->from('sub_category')
            ->andFilterWhere(['menu_type_id'=>$menutypeArray])
            // ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])
            ->all($con);

            $product_count = (new \yii\db\Query())
            ->select('COUNT(*)')
            ->from('product')
            ->andFilterWhere(['munu_type_id'=>$menutypeArray])
            ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])


            ->one($con);

             $pages = new Pagination(
                ['totalCount' =>$product_count['COUNT(*)']
                ,'pageSize' => 18]);

            $product_details  = (new \yii\db\Query())
                ->select('*')
                ->from('product')
                ->filterWhere(['munu_type_id'=>$menutypeArray])
                ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])
                ->offset($pages->offset)
                ->limit($pages->limit)
                ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])
                ->all($con);
            $vendor_id=$autoselect->id;


          $con->close();




            return $this->render('alllist', [
                'product_details'=>$product_details,
                'product_details2'=>$product_details,
                'all_vendoer'=>$all_vendoer,
                'vendor_id'=>$vendor_id,
                'pages'=>$pages,
                'menutypeArray'=>$menutypeArray,
            'allMenuType'=>$allMenuType,
            'allSubCategory'=>$allSubCategory,
            'allcatogoryArray'=>$allcatogoryArray




            ]);

        }
        }

        if( $allmenutypeSelected){

            
        
          

            $menutypeArray = array();
            $allcatogoryArray = array();





            $all_vendoer=Vendor::find()->where(['status'=>1])->all();

        if(Yii::$app->request->get('vendor')){

            $autoselect=Vendor::find()->where(['id'=>Yii::$app->request->get('vendor')])->one();
            if($autoselect){
                $auloselectdb=$autoselect->database_name;
            }else {

                $autoselect=Vendor::find()->where(['status'=>1])->one();
        $auloselectdb=$autoselect->database_name;
                # code...
            }

              foreach($allmenutypeSelected as $allmenutypeSelected ){
                //   if($autoselect->id == $allmenutypeSelected['ven_id'] && $allmenutypeSelected['type']==1 ){

                //     array_push($menutypeArray,$allmenutypeSelected['menutypeID']);
                //   }

                  if($autoselect->id == $allmenutypeSelected['ven_id']  ){

                    if($allmenutypeSelected['type']==1){ array_push($menutypeArray,$allmenutypeSelected['menutypeID']); }

                    if($allmenutypeSelected['type']==2){ array_push($allcatogoryArray,$allmenutypeSelected['menutypeID']); }
                  }

              }

            //   print_r($menutypeArray);
            //   die;

            $session->set('vendor_db_name',  $auloselectdb);

            $con = Yii::$app->PosDbManager->getDbConnection($auloselectdb);

            // $allMenuType=MenuType::find()->all($con);main_category


            if($menutypeArray==null){
                $allcatogoryArray= null;
                $session->remove('menutypeSelected');

                // print_r($menutypeArray);
                // die;

            }

           

            $allMenuType = (new \yii\db\Query())
            ->select('*')
            ->from('menu_type')
            ->all($con);

           

            $allSubCategory = (new \yii\db\Query())
            ->select('*')
            ->from('sub_category')
            ->andFilterWhere(['menu_type_id'=>$menutypeArray])

            ->all($con);

            if( isset($_POST['searchbyname'])){

                $product_count = (new \yii\db\Query())
                ->select('COUNT(*)')
                ->from('product')
                ->filterWhere(['like', 'name', $_POST['searchbyname']])

                ->andFilterWhere(['munu_type_id'=>$menutypeArray])
                ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])

    
    
                ->one($con);   
    
                 $pages = new Pagination(
                    ['totalCount' =>$product_count['COUNT(*)']
                    ,'pageSize' => 18]);
    
    
                $product_details  = (new \yii\db\Query())
                    ->select('*')
                    ->from('product') 
                    ->filterWhere(['like', 'name', $_POST['searchbyname']])
                    ->andFilterWhere(['munu_type_id'=>$menutypeArray])
                    ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])                
                    ->offset($pages->offset)
                    ->limit($pages->limit)
                    ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])
                    ->all($con);
                $vendor_id=$autoselect->id;
    
                
              $con->close();
    
    
            
    
                return $this->render('alllist', [
                    'product_details'=>$product_details,
                'product_details2'=>$product_details,

                    'all_vendoer'=>$all_vendoer,
                    'vendor_id'=>$vendor_id,
                    'pages'=>$pages,
                    'menutypeArray'=>$menutypeArray,
                'allMenuType'=>$allMenuType,
                'allSubCategory'=>$allSubCategory,
                'allcatogoryArray'=>$allcatogoryArray,
            'secarchinpur'=>$_POST['searchbyname']


    
        
        
                ]);
    


            }

            $product_count = (new \yii\db\Query())
            ->select('COUNT(*)')
            ->from('product')
            ->andFilterWhere(['munu_type_id'=>$menutypeArray])
            ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])


            ->one($con);

             $pages = new Pagination(
                ['totalCount' =>$product_count['COUNT(*)']
                ,'pageSize' => 18]);


            $product_details  = (new \yii\db\Query())
                ->select('*')
                ->from('product')
                ->andFilterWhere(['munu_type_id'=>$menutypeArray])
                ->andFilterWhere(['sub_category_id'=>$allcatogoryArray])
                ->offset($pages->offset)
                ->limit($pages->limit)
                ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])
                ->all($con);
            $vendor_id=$autoselect->id;


          $con->close();




            return $this->render('alllist', [
                'product_details'=>$product_details,
                'product_details2'=>$product_details,

                'all_vendoer'=>$all_vendoer,
                'vendor_id'=>$vendor_id,
                'pages'=>$pages,
                'menutypeArray'=>$menutypeArray,
            'allMenuType'=>$allMenuType,
            'allSubCategory'=>$allSubCategory,
            'allcatogoryArray'=>$allcatogoryArray



            ]);

        }
        }


        $all_vendoer=Vendor::find()->where(['status'=>1])->all();

        if(Yii::$app->request->get('vendor')){

          


            $autoselect=Vendor::find()->where(['id'=>Yii::$app->request->get('vendor')])->one();
            if($autoselect){
                $auloselectdb=$autoselect->database_name;
            }else {

                $autoselect=Vendor::find()->where(['status'=>1])->one();
                $auloselectdb=$autoselect->database_name;
                # code...
            }


            $session->set('vendor_db_name',  $auloselectdb);

            $con = Yii::$app->PosDbManager->getDbConnection($auloselectdb);

            // $allMenuType=MenuType::find()->all($con);main_category

            $allMenuType = (new \yii\db\Query())
            ->select('*')
            ->from('menu_type')
            ->all($con);

            $allSubCategory = (new \yii\db\Query())
            ->select('*')
            ->from('sub_category')
            ->all($con);

            if( isset($_POST['searchbyname'])){



           $product_count = (new \yii\db\Query())
            ->select('COUNT(*)')
            ->from('product') 
            ->where(['like', 'name', $_POST['searchbyname']])

            ->one($con);   

             $pages = new Pagination(
                ['totalCount' =>$product_count['COUNT(*)']
                ,'pageSize' => 18]);


            $product_details  = (new \yii\db\Query())
                ->select('*')
                ->from('product') 
                ->where(['like', 'name', $_POST['searchbyname']])

                ->offset($pages->offset)
            ->limit($pages->limit)
            ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])
                ->all($con);
            $vendor_id=$autoselect->id;
            
          $con->close();
          $session->remove('menutypeSelected'); 


            return $this->render('alllist', [
                'product_details'=>$product_details,
                'product_details2'=>$product_details,

                'all_vendoer'=>$all_vendoer,
                'vendor_id'=>$vendor_id,
                'pages'=>$pages,
            'allMenuType'=>$allMenuType,
            'allSubCategory'=>$allSubCategory,
            'secarchinpur'=>$_POST['searchbyname']

            // 'allcatogoryArray'=>$allcatogoryArray


    
    
            ]);


            }



            $product_count = (new \yii\db\Query())
            ->select('COUNT(*)')
            ->from('product')
            ->one($con);

             $pages = new Pagination(
                ['totalCount' =>$product_count['COUNT(*)']
                ,'pageSize' => 18]);


            $product_details  = (new \yii\db\Query())
                ->select('*')
                ->from('product')
                ->offset($pages->offset)
            ->limit($pages->limit)
            ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])

                ->all($con);
            $vendor_id=$autoselect->id;

          $con->close();
          $session->remove('menutypeSelected');


            return $this->render('alllist', [
                'product_details'=>$product_details,
                'product_details2'=>$product_details,

                'all_vendoer'=>$all_vendoer,
                'vendor_id'=>$vendor_id,
                'pages'=>$pages,
            'allMenuType'=>$allMenuType,
            'allSubCategory'=>$allSubCategory,
            // 'allcatogoryArray'=>$allcatogoryArray




            ]);

        }




        $autoselect=Vendor::find()->where(['status'=>1])->one();
        $auloselectdb=$autoselect->database_name;




        $session->set('vendor_db_name',  $auloselectdb);

        $con = Yii::$app->PosDbManager->getDbConnection($auloselectdb);

        $allMenuType = (new \yii\db\Query())
        ->select('*')
        ->from('menu_type')
        ->all($con);

        $allSubCategory = (new \yii\db\Query())
        ->select('*')
        ->from('sub_category')
        ->all($con);

        if( isset($_POST['searchbyname'])){
        
            $product_count = (new \yii\db\Query())
            ->select('COUNT(*)')
            ->from('product') 
            ->where(['like', 'name', $_POST['searchbyname']])
            ->one($con);   
    
            $pages = new Pagination(
                    ['totalCount' =>$product_count['COUNT(*)']
                    ,'pageSize' => 18]);
    
    
    
    
            $product_details  = (new \yii\db\Query())
                ->select('*')
                ->from('product') 
                ->where(['like', 'name', $_POST['searchbyname']])
                ->offset($pages->offset)
                ->limit($pages->limit)
                ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])
                ->all($con);
            $vendor_id=$autoselect->id;
    
            // $allMenuType=MenuType::find()->all();
            $con->close();
            $session->remove('menutypeSelected'); 
        
            return $this->render('alllist', [
                'product_details'=>$product_details,
                'product_details2'=>$product_details,

                'all_vendoer'=>$all_vendoer,
                'vendor_id'=>$vendor_id,
                'pages'=>$pages,
                'allMenuType'=>$allMenuType,
                'allSubCategory'=>$allSubCategory,
                'secarchinpur'=>$_POST['searchbyname']
    
    
    
            ]);  

        }

        $product_count = (new \yii\db\Query())
        ->select('COUNT(*)')
        ->from('product')
        ->one($con);

        $pages = new Pagination(
                ['totalCount' =>$product_count['COUNT(*)']
                ,'pageSize' => 18]);




        $product_details  = (new \yii\db\Query())
            ->select('*')
            ->from('product')
            ->offset($pages->offset)
            ->limit($pages->limit)
            ->orderBy(['munu_type_id'=>SORT_ASC,'name' => SORT_ASC])
            ->all($con);
        $vendor_id=$autoselect->id;

        // $allMenuType=MenuType::find()->all();
        $con->close();
        $session->remove('menutypeSelected');

        return $this->render('alllist', [
            'product_details'=>$product_details,
            'product_details2'=>$product_details,

            'all_vendoer'=>$all_vendoer,
            'vendor_id'=>$vendor_id,
            'pages'=>$pages,
            'allMenuType'=>$allMenuType,
            'allSubCategory'=>$allSubCategory



        ]);
    }




    /**
     * Displays about page.
     *
     * @return mixed
     */
    public function actionAbout()
    {
        



    
        return $this->render('about');
    }

    /**
     * Signs user up.
     *
     * @return mixed
     */
   public function actionSignup()
    {
        $model = new SignupForm();

        $session = Yii::$app->session;
        $Otpid = $session->get('send_otp_id');


        if ($model->load(Yii::$app->request->post())) {
            if ($user = $model->signup()) {
                // if (Yii::$app->getUser()->login($user)) {

                //     $otpCodesmodel= OtpCodes::find()->where(['id'=>Yii::$app->getRequest()->getQueryParam('otp_id')])->one();
                //     $otpCodesmodel->status=3;
                //     $otpCodesmodel->save();
                //     return $this->goHome();
                // }
                $otpCodesmodel= OtpCodes::find()->where(['id'=>$Otpid])->one();
                $otpCodesmodel->status=3;
                $otpCodesmodel->save();
                $session->remove('send_otp_id');
                return Yii::$app->response->redirect(['site/login']);
            }
        }

        if($Otpid){



            $PhoneNumber=OtpCodes::find()->where(['id'=>$Otpid])->andWhere(['status'=>2])->one();

        }

        if($PhoneNumber){
            return $this->render('signup', [
                'model' => $model,
                'user_phone_number'=>$PhoneNumber->phone_number
            ]);
        }else{


            return $this->redirect(array('otpvalidate'));

        }

       
    }

    /**
     * Requests password reset.
     *
     * @return mixed
     */
    public function actionRequestPasswordReset()
    {
        $model = new PasswordResetRequestForm();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($model->sendEmail()) {
                Yii::$app->session->setFlash('success', 'Check your email for further instructions.');

                return $this->goHome();
            } else {
                Yii::$app->session->setFlash('error', 'Sorry, we are unable to reset password for the provided email address.');
            }
        }

        return $this->render('requestPasswordResetToken', [
            'model' => $model,
        ]);
    }

    /**
     * Resets password.
     *
     * @param string $token
     * @return mixed
     * @throws BadRequestHttpException
     */
    public function actionResetPassword($token)
    {
        try {
            $model = new ResetPasswordForm($token);
        } catch (InvalidArgumentException $e) {
            throw new BadRequestHttpException($e->getMessage());
        }

        if ($model->load(Yii::$app->request->post()) && $model->validate() && $model->resetPassword()) {
            Yii::$app->session->setFlash('success', 'New password saved.');

            return $this->goHome();
        }

        return $this->render('resetPassword', [
            'model' => $model,
        ]);
    }

    /**
     * Verify email address
     *
     * @param string $token
     * @throws BadRequestHttpException
     * @return yii\web\Response
     */
    public function actionVerifyEmail($token)
    {
        try {
            $model = new VerifyEmailForm($token);
        } catch (InvalidArgumentException $e) {
            throw new BadRequestHttpException($e->getMessage());
        }
        if ($user = $model->verifyEmail()) {
            if (Yii::$app->user->login($user)) {
                Yii::$app->session->setFlash('success', 'Your email has been confirmed!');
                return $this->goHome();
            }
        }

        Yii::$app->session->setFlash('error', 'Sorry, we are unable to verify your account with provided token.');
        return $this->goHome();
    }

    /**
     * Resend verification email
     *
     * @return mixed
     */
    public function actionResendVerificationEmail()
    {
        $model = new ResendVerificationEmailForm();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            if ($model->sendEmail()) {
                Yii::$app->session->setFlash('success', 'Check your email for further instructions.');
                return $this->goHome();
            }
            Yii::$app->session->setFlash('error', 'Sorry, we are unable to resend verification email for the provided email address.');
        }

        return $this->render('resendVerificationEmail', [
            'model' => $model
        ]);
    }

    public function beforeAction($action)
    {
        $this->enableCsrfValidation = false;
        return parent::beforeAction($action);
    }

    public function actionProfile()
    {
        try
         {
            if(Yii::$app->user->isGuest)
            return Yii::$app->response->redirect(['site/login']);

            $vendors
            =Vendor::find()->all();

            $orderModel = new Order();
            $orders = array();
            $orderCountByVendor = array();
            $topProductsByVendor = array();

            foreach($vendors as $vendor)
            {
                // get vendor specified orders
                $vendor_orders
                =  $orderModel->getAllCustomerOrders($vendor->database_name, Yii::$app->user->identity->id);
                //
                $vendor_order_ids = array_column($vendor_orders, 'id');
                // get the order count by vendor
                $vendor_top_products
                = $orderModel->getTopOrderedProducts($vendor->database_name, 3, $vendor_order_ids);
                // get order count by vendor
                $orderCountByVendor[ $vendor->name ] = count($vendor_orders);
                // get top products by vendor
                $topProductsByVendor[ $vendor->name ] =  $vendor_top_products;
                 // merge all vendors to gether
                array_push( $orders, $vendor_orders);
            }

            $orders = call_user_func_array('array_merge', $orders);

            Yii::$app->SortArray->sort($orderCountByVendor,true);
            
            $model = new UploadForm();

            if (Yii::$app->request->isPost) {

                $model->imageFile = UploadedFile::getInstance($model, 'imageFile');
                $path = '../web/profilepics/' .Yii::$app->user->identity->id. '.' . $model->imageFile->extension;
                if ($model->upload($path)) {
                    // file is uploaded successfullyx

                }
            }

            return $this->render('profile',
                                [
                                    'orderCountByVendor'=>$orderCountByVendor,
                                    'topProductByVendor'=>$topProductsByVendor,
                                    'model' => $model
                                ]);
        } catch (\Exception $e)
        { \Yii::error($e,'order');
          throw new \yii\web\HttpException(500, "we are working on this :)");
        }
    }
}
