<?php

namespace frontend\models;

use Yii;

/**
 * This is the model class for table "pay_types".
 *
 * @property int $id
 * @property string $name
 * @property int $status
 * @property string $image_path
 *
 * @property Discount[] $discounts
 * @property Order[] $orders
 */
class PayTypes extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'pay_types';
    }

    /**
     * @return \yii\db\Connection the database connection used by this AR class.
     */
    public static function getDb()
    {
        $session = Yii::$app->session;
        $db_name = $session->get('vendor_db_name');
        if(! $session->get($db_name) ){


             $connection =Yii::$app->PosDbManager->getDbConnection($db_name);

            
            
         $dbcon= $session->set($db_name, $connection);
        
         return $connection;
        }else{
            $dbcon= $session->get($db_name);
          
            return $dbcon;
        }
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name', 'status', 'image_path'], 'required'],
            [['status'], 'integer'],
            [['name'], 'string', 'max' => 150],
            [['image_path'], 'string', 'max' => 300],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'status' => 'Status',
            'image_path' => 'Image Path',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getDiscounts()
    {
        return $this->hasMany(Discount::className(), ['pay_type_id' => 'id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getOrders()
    {
        return $this->hasMany(Order::className(), ['pay_type_id' => 'id']);
    }
}
