<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model \frontend\models\ContactForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">


	<div class="container main-container">
		<section class="contact-form-section">
			<h3 class="text-bold text-center">Contact Us</h3>

			<p>
				If you have business inquiries or other questions, please fill out the following form to contact us.
				Thank you.
			</p>
			<div class="row">
				
					<?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>
					<div class="col-md-4 col-sm-6 col-xs-12">
					<?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>
					</div>

					<div class="col-md-4 col-sm-6 col-xs-12">
					<?= $form->field($model, 'email') ?>
					</div>
					<div class="col-md-4 col-sm-6 col-xs-12">
					<?= $form->field($model, 'subject') ?>
					</div>
					<div class="col-md-12 col-sm-6 col-xs-12">
					<?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>
					</div>
					<div class="col-md-6 col-sm-6 col-xs-12">
					<?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                    'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                ]) ?>

				</div>

				<div class="col-md-12 col-sm-6 col-xs-12">

					<div class="form-group" style="text-align: center;">
						<?= Html::submitButton('Submit Your Details', ['class' => 'btn btn-danger', 'name' => 'contact-button']) ?>
					</div>
					</div>

					<?php ActiveForm::end(); ?>
				
			</div>

	</div>
	</section>
</div>