<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model \frontend\models\SignupForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use yii\widgets\Breadcrumbs;


$this->title = 'Signup';
$this->params['breadcrumbs'][] = $this->title;
?>
<?=
                    Breadcrumbs::widget([
                        'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
                    ])
                    ?>


<div class="main-container container">
    <!-- Content Login Wrap Starts -->
    <div class="content-login-wrap">
        <!-- Nested Row Starts -->
        <div class="row">
            <!-- Login Col Starts -->
            <div class="col-md-5 col-xs-12">
            <h4 class="text-spl-color"><?= Html::encode($this->title) ?></h4>

<p>Please fill out the following fields to signup:</p>
<h6>Mobile Number: (+94)<?= Html::encode($user_phone_number) ?></h6>
                <!-- Login Form Starts -->
                <?php $form = ActiveForm::begin(['id' => 'form-signup']); ?>

<?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

<?= $form->field($model, 'email') ?>

<?= $form->field($model, 'password')->passwordInput() ?>

<?= $form->field($model, 'confirm_password')->passwordInput() ?>

<?= $form->field($model, 'mobile_number')->hiddenInput(['value'=>$user_phone_number] )->label(false) ?>

<div class="form-group">
    <?= Html::submitButton('Signup', ['class' => 'btn btn-primary', 'name' => 'signup-button','onsubmit'=>'return checkForm(this)']) ?>
</div>

<?php ActiveForm::end(); ?>
                <!-- Login Form Ends -->
            </div>
            <!-- Login Col Ends -->
            <!-- Divider For Small Devices -->
            <div class="col-xs-12 visible-sm visible-xs">
                <br>
                <hr><br>
            </div>
            <!-- Divider For Small Ends -->
            <!-- Register Col Starts -->
            <div class="col-md-5 col-xs-12 col-md-offset-2">
                <h4 class="text-spl-color">Login for first time user?</h4>
                <p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the
                    industry's standard..</p>
               
          
            </div>
            <!-- Register Col Ends -->
        </div>
        <!-- Nested Row Ends -->
    </div>
    <!-- Content Login Wrap Ends -->
    <!-- Banners Starts -->
    <div class="row">
        <div class="col-xs-3">
            <a href="#"><img src="<?php echo Yii::$app->getUrlManager()->getBaseUrl(); ?>/themeassets/images/banners/banner-img1.png" alt="Banner 1" class="img-responsive"></a>
        </div>
        <div class="col-xs-3">
            <a href="#"><img src="<?php echo Yii::$app->getUrlManager()->getBaseUrl(); ?>/themeassets/images/banners/banner-img2.png" alt="Banner 2" class="img-responsive"></a>
        </div>
        <div class="col-xs-3">
            <a href="#"><img src="<?php echo Yii::$app->getUrlManager()->getBaseUrl(); ?>/themeassets/images/banners/banner-img3.png" alt="Banner 3" class="img-responsive"></a>
        </div>
        <div class="col-xs-3">
            <a href="#"><img src="<?php echo Yii::$app->getUrlManager()->getBaseUrl(); ?>/themeassets/images/banners/banner-img1.png" alt="Banner 1" class="img-responsive"></a>
        </div>
    </div>
    <!-- Banners Ends -->
</div>
<!-- Main Container Ends -->
<!-- Register Modal Window Starts -->
<div class="modal fade" id="registerModal" tabindex="-1" role="dialog" aria-labelledby="registerModal">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content no-boxshadow text-center">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span
                        aria-hidden="true">&times;</span></button>
                <h4 class="modal-title text-spl-color" id="registerModalLabel">Register Here</h4>
            </div>
            <div class="modal-body">
                <!-- Register Form Starts -->
                <form>
                    <div class="form-group">
                        <label class="sr-only" for="register-fname">First Name</label>
                        <input type="text" class="form-control" id="register-fname" placeholder="First Name">
                    </div>
                    <div class="form-group">
                        <label class="sr-only" for="register-lname">Last Name</label>
                        <input type="text" class="form-control" id="register-lname" placeholder="Last Name">
                    </div>
                    <div class="form-group">
                        <label class="sr-only" for="register-address">Last Name</label>
                        <textarea class="form-control" id="register-address" placeholder="Address" rows="4"></textarea>
                    </div>
                    <div class="form-group">
                        <label class="sr-only" for="register-zipcode">Zip Code</label>
                        <input type="text" class="form-control" id="register-zipcode" placeholder="Zip Code">
                    </div>
                    <div class="form-group">
                        <label class="sr-only" for="register-country">Country</label>
                        <select class="form-control" id="register-country">
                            <option>Country</option>
                            <option>India</option>
                            <option>USA</option>
                            <option>China</option>
                            <option>Australia</option>
                        </select>
                    </div>
                    <div class="form-group">
                        <label class="sr-only" for="register-phoneno">Phone No</label>
                        <input type="text" class="form-control" id="register-phoneno" placeholder="Phone No">
                    </div>
                    <div class="form-group">
                        <label class="sr-only" for="register-email">Email address</label>
                        <input type="email" class="form-control" id="register-email" placeholder="Email">
                    </div>
                    <div class="form-group">
                        <label class="sr-only" for="register-password">Password</label>
                        <input type="password" class="form-control" id="register-password" placeholder="Password">
                    </div>
                    <div class="form-group">
                        <div class="checkbox">
                            <label>
                                <input type="checkbox"> Yes, I would like to receive emails with deals and discount
                                codes
                            </label>
                        </div>
                        <p class="help-block">By logging in I agree to the <a href="#">Terms of Use</a> and <a
                                href="#">Privacy Policy</a>.</p>
                    </div>
                    <button type="submit" class="btn btn-lg btn-block btn-tertiary animation">
                        Continue To Register <i class="fa fa-caret-right"></i>
                    </button>
                </form>
                <!-- Register Form Ends -->
            </div>
        </div>
    </div>
</div>
<script>
function checkForm(form)
  {
    // validation fails if the input is blank
    if(form.inputfield.value == "") {
      alert("Error: Input is empty!");
      form.inputfield.focus();
      return false;
    }

    // regular expression to match only alphanumeric characters and spaces
    var re = /^[\w ]+$/;

    // validation fails if the input doesn't match our regular expression
    if(!re.test(form.inputfield.value)) {
      alert("Error: Input contains invalid characters!");
      form.inputfield.focus();
      return false;
    }

    // validation was successful
    return true;
  }
</script>