<?php

namespace webvimark\modules\UserManagement\controllers;

use webvimark\components\AdminDefaultController;
use Yii;
use webvimark\modules\UserManagement\models\User;
use webvimark\modules\UserManagement\models\search\UserSearch;
use yii\web\NotFoundHttpException;

/**
 * UserController implements the CRUD actions for User model.
 */
class UserController extends AdminDefaultController
{
	/**
	 * @var User
	 */
	public $modelClass = 'webvimark\modules\UserManagement\models\User';

	/**
	 * @var UserSearch
	 */
	public $modelSearchClass = 'webvimark\modules\UserManagement\models\search\UserSearch';

	/**
	 * @return mixed|string|\yii\web\Response
	 */
	public function actionCreate()
	{
		$model = new User(['scenario'=>'newUser']);

		if ( $model->load(Yii::$app->request->post())  )
		{
			// print_r();
			// die;
			if($model->user_type==2){
				$model->status=10;

			}
		
			if($model->user_type==1){



				if($model->vendor_id==null){

					if(Yii::$app->user->isSuperadmin){
					
						$model->superadmin=1;
					}

				}
				

			}
			 $model->save();
			User::assignRole($model->id, "Admin");
			return $this->redirect(['view',	'id' => $model->id]);
		}

		return $this->renderIsAjax('create', compact('model'));
	}

	/**
	 * @param int $id User ID
	 *
	 * @throws \yii\web\NotFoundHttpException
	 * @return string
	 */
	public function actionChangePassword($id)
	{
		$model = User::findOne($id);

		if ( !$model )
		{
			throw new NotFoundHttpException('User not found');
		}

		$model->scenario = 'changePassword';

		if ( $model->load(Yii::$app->request->post()) && $model->save() )
		{
			return $this->redirect(['view',	'id' => $model->id]);
		}

		return $this->renderIsAjax('changePassword', compact('model'));
	}

	public function actionView($id)
	{
		$model = User::findOne($id);
		$visit_logs = (new \yii\db\Query())
				->select(['visit_time'])
				->from('user_visit_log')
				->limit(5)
				->where(["user_id" => $id])
				->orderBy('id DESC')
				->all();
				
		return $this->render('view', [
			'model' => $model,
			'visit_logs' => $visit_logs
			]);
	}

}
