<?php

use webvimark\modules\UserManagement\models\User;
use webvimark\modules\UserManagement\UserManagementModule;
use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use webvimark\extensions\BootstrapSwitch\BootstrapSwitch;
use backend\models\Vendor;


/**
 * @var yii\web\View $this
 * @var webvimark\modules\UserManagement\models\User $model
 * @var yii\bootstrap\ActiveForm $form
 */
?>

<div class="user-form">

	<?php $form = ActiveForm::begin([
		'id'=>'user',
		'layout'=>'horizontal',
		'validateOnBlur' => false,
	]); ?>




	<div class="form-group">
		
	</div>

	<?php ActiveForm::end(); ?>

</div>

<?php BootstrapSwitch::widget() ?>







<div class="product-form">

	<?php $form = ActiveForm::begin(); ?>


	<div class="portlet light ">
		<p style="margin-top:8px;margin-bottom:8px;">
			<?= Html::a('Manage', ['index'], ['class' => 'btn btn-success']) ?>
		</p>
		<div class="portlet-title">
			<div class="caption">
				<span class="caption-subject font-dark bold uppercase"><?= Html::encode($this->title) ?></span>
			</div>
			<div class="actions">

			</div>
		</div>
		<div class="portlet-body form">
			<form role="form">
				<div class="form-body">
					<div class="row">
						<div class="col-md-6">
						<label for="status">Status<x style="color: red;">*</x></label>
							<?= $form->field($model->loadDefaultValues(), 'status')->dropDownList(User::getStatusList() )->label(false)  ?>
							<label for="user_name">User Name<x style="color: red;">*</x></label>
							<?= $form->field($model, 'username')->textInput(['maxlength' => 255, 'autocomplete'=>'off'])->label(false) ?>

							<?php if ( $model->isNewRecord ): ?>
								<label for="password">Password<x style="color: red;">*</x></label>
							<?= $form->field($model, 'password')->passwordInput(['maxlength' => 255, 'autocomplete'=>'off'])->label(false) ?>
							<label for="repeat_password">Repeat password<x style="color: red;">*</x></label>
							<?= $form->field($model, 'repeat_password')->passwordInput(['maxlength' => 255, 'autocomplete'=>'off'])->label(false) ?>
							<?php endif; ?>


						

							
						</div>
						<div class="col-md-6">
						<?php if ( User::hasPermission('editUserEmail') ): ?>

							<?= $form->field($model, 'email')->textInput(['maxlength' => 255]) ?>
							

							<?php endif; ?>


							<?php if (Yii::$app->user->isSuperadmin ): ?>

								<label for="User_Type">User Type<x style="color: red;">*</x></label>
							<?= $form->field($model, 'user_type')->dropDownList( ['1' => 'Web User'] )->label(false)?>

								<?php endif; ?>


								<?php if (! Yii::$app->user->isSuperadmin ): ?>

								<label for="User_Type">User Type<x style="color: red;">*</x></label>
							<?= $form->field($model, 'user_type')->dropDownList( ['1' => 'Web User','2'=>'Pos User'] )->label(false)?>

								<?php endif; ?>

							


							<?php if ( Yii::$app->user->identity->vendor_id ): ?>
							<?= $form->field($model, 'vendor_id')->dropDownList(Vendor::getList(), ['id' => 'selectUser',])->hiddenInput(['value'=>Yii::$app->user->identity->vendor_id ])->label(false) ?>

							<?php endif; ?>
							<?php if ( Yii::$app->user->identity->vendor_id==null ): ?>
								<label for="vendor">Vendor<x style="color: red;"></x></label>
							<?= $form->field($model, 'vendor_id')->dropDownList(Vendor::getList(), ['prompt'=>'SuperAdmin','id' => 'selectUser' ])->label(false) ?>

							<?php endif; ?>
							


						</div>
					</div>
					<div class="form-actions right">
					<div class="col-sm-offset-3 col-sm-9">
			<?php if ( $model->isNewRecord ): ?>
			<?= Html::submitButton(
					'<span class="glyphicon glyphicon-plus-sign"></span> ' . UserManagementModule::t('back', 'Create'),
					['class' => 'btn btn-success']
				) ?>
			<?php else: ?>
			<?= Html::submitButton(
					'<span class="glyphicon glyphicon-ok"></span> ' . UserManagementModule::t('back', 'Save'),
					['class' => 'btn btn-primary']
				) ?>
			<?php endif; ?>
		</div>
					</div>
			</form>
		</div>
	</div>
	<?php ActiveForm::end(); ?>



</div>