<?php

use webvimark\modules\UserManagement\components\GhostHtml;
use webvimark\modules\UserManagement\models\rbacDB\Role;
use webvimark\modules\UserManagement\models\User;
use webvimark\modules\UserManagement\UserManagementModule;
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
use yii\widgets\DetailView;

/**
 * @var yii\web\View $this
 * @var webvimark\modules\UserManagement\models\User $model
 */

$this->title = $model->username;
$this->params['breadcrumbs'][] = ['label' => UserManagementModule::t('back', 'Users'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="user-view">
	<div class="row">
		<div class="col-md-4 portlet light ">
		<div class="profile-sidebar-portlet ">
            <div class="profile-userpic">
                 <img style="height: 150px;width: 150px;" src="https://theimag.org/wp-content/uploads/2015/01/user-icon-png-person-user-profile-icon-20-300x300.png" class="img-responsive" alt=""> </div>
                  
            </div>
			<br>
			<div class="" style="padding:10px">
			
			<h4>Recent Visit Logs</h4>
						<div class="table-scrollable">
                                        <table class="table table-bordered table-hover" style="margin-top:20px">
                                            <thead>
                                                <tr>
                                                    <th> id </th>
                                                    <th> Visited Date </th>
                                                    <th> Visited Time </th>
                                                </tr>
                                            </thead>
											
                                            <tbody>
											<?php if (!empty($visit_logs)): ?>
                         					   <?php $a = 0; foreach ($visit_logs as $visits): $a++ ?>
                                                <tr>
                                                    <td > <? echo $a?> </td>
                                                    <td> <? echo date("Y-m-d",  $visits["visit_time"] )?> </td>
													<td> <? echo date("H:i:s",  $visits["visit_time"] ) ?> </td>
                                                 </tr>
												<?php endforeach; ?>
          									 <?php endif; ?>
												
                                            </tbody>
                                        </table>
                                    </div>
                  </div>

			
			
		</div>
		<div class="col-md-8">
		<div class="panel panel-default">
		<div class="panel-body">

		    <p>
			<?= GhostHtml::a(UserManagementModule::t('back', 'Edit'), ['update', 'id' => $model->id], ['class' => 'btn btn-sm btn-primary']) ?>
			<?= GhostHtml::a(UserManagementModule::t('back', 'Create'), ['create'], ['class' => 'btn btn-sm btn-success']) ?>
			<?= GhostHtml::a(
				UserManagementModule::t('back', 'Roles and permissions'),
				['/user-management/user-permission/set', 'id'=>$model->id],
				['class' => 'btn btn-sm btn-default']
			) ?>

			<?= GhostHtml::a(UserManagementModule::t('back', 'Delete'), ['delete', 'id' => $model->id], [
			    'class' => 'btn btn-sm btn-danger pull-right',
			    'data' => [
				'confirm' => UserManagementModule::t('back', 'Are you sure you want to delete this user?'),
				'method' => 'post',
			    ],
			]) ?>
		    </p>

			<?= DetailView::widget([
				'model'      => $model,
				'attributes' => [
					'id',
					[
						'attribute'=>'status',
						'value'=>User::getStatusValue($model->status),
					],
					'username',
					[
						'attribute'=>'email',
						'value'=>$model->email,
						'format'=>'email',
						'visible'=>User::hasPermission('viewUserEmail'),
					],
					[
						'attribute'=>'email_confirmed',
						'value'=>$model->email_confirmed,
						'format'=>'boolean',
						'visible'=>User::hasPermission('viewUserEmail'),
					],
					[
						'label'=>UserManagementModule::t('back', 'Roles'),
						'value'=>implode('<br>', ArrayHelper::map(Role::getUserRoles($model->id), 'name', 'description')),
						'visible'=>User::hasPermission('viewUserRoles'),
						'format'=>'raw',
					],
					[
						'attribute'=>'bind_to_ip',
						'visible'=>User::hasPermission('bindUserToIp'),
					],
					array(
						'attribute'=>'registration_ip',
						'value'=>Html::a($model->registration_ip, "http://ipinfo.io/" . $model->registration_ip, ["target"=>"_blank"]),
						'format'=>'raw',
						'visible'=>User::hasPermission('viewRegistrationIp'),
					),
					'created_at:datetime',
					'updated_at:datetime',
				],
			]) ?>

		</div>
	</div>
		</div>
	</div>
	
</div>
